/****************************************************************
* manager of table progress
****************************************************************/
#include "hconp000.ch"

/****************************************************************
* Form definition
****************************************************************/
FUNCTION p002_Define()
SET NAVIGATION EXTENDED
DEFINE WINDOW p002win ;
 ROW 0 ;
 COL 0 ;
 WIDTH 940 ;
 HEIGHT 705 ;
 TITLE l3w_fMsg("Form", "FRM002")+" (hconp002)" ;
 WINDOWTYPE CHILD ;
 NOAUTORELEASE ;
 NOMAXIMIZE ;
 ON INTERACTIVECLOSE p002_IntClose() ;
 ICON 'L3W_L3WICO' ;
 FONTNAME l3w_fConf("FormFont", "Name") FONTSIZE VAL(l3w_fConf("FormFont", "Size"))

 DEFINE TOOLBAR toolbar1 ;
  BUTTONSIZE 60,30 ;
  FONT l3w_fConf("ButtFont", "Name") ;
  SIZE VAL(l3w_fConf("ButtFont", "Size")) ;
  FLAT ;
  BORDER
  BUTTON bt_exit ;
   CAPTION l3w_fMsg("Command", "CMD001") ;
   PICTURE "L3W_IEXIT" ;
   ACTION p002_Exit() ;
   SEPARATOR
  BUTTON bt_save ;
   CAPTION l3w_fMsg("Command", "CMD002") ;
   PICTURE "L3W_ISAVE" ;
   ACTION p002_Save() ;
   SEPARATOR
  BUTTON bt_reset ;
   CAPTION l3w_fMsg("Command", "CMD009") ;
   PICTURE "L3W_ICLEAR" ;
   ACTION p002_Reset() ;
   SEPARATOR
 END TOOLBAR

 DEFINE STATUSBAR
  STATUSITEM "DataBase : " + l3w_fConf("DataBase", "Description") WIDTH 250
  STATUSITEM "User : " + l3w_fConf("User", "Name") WIDTH 250
  CLOCK WIDTH 80
  DATE WIDTH 100
 END STATUSBAR

* form status :
* N=Form Free
* I=Form committed
 DEFINE LABEL FormStatus
  PARENT p002win
  ROW 20
  COL 500
  WIDTH 20
  HEIGHT 20
  VALUE "N"
  VISIBLE .F.
 END LABEL

* field prgcodice
 DEFINE LABEL lb_prgcodice
  PARENT p002win
  ROW 60
  COL 20
  VALUE l3w_fMsg("Label", "LBL001")
  WIDTH 100
  HEIGHT 25
  ALIGNMENT Left
 END LABEL
 DEFINE TEXTBOX prgcodice
  PARENT p002win
  ROW 60
  COL 125
  HEIGHT 25
  WIDTH 100
  TOOLTIP l3w_fMsg("ToolTip", "TTI001")
  MAXLENGTH p999_LenField("progress", "prgcodice")
  CASECONVERT UPPER
  ONENTER p002_Enter()
 END TEXTBOX
* button bt_src_prgcodice
 DEFINE BUTTON bt_src_prgcodice
  PARENT p002win
  ROW 60
  COL 230
  PICTURE "L3W_ISEARCH"
  ONCLICK p002_Src_prgcodice()
  WIDTH 30
  HEIGHT 30
  TOOLTIP l3w_fMsg("ToolTip", "TTI002")
  FLAT .T.
  TABSTOP .F.
 END BUTTON

* field prgdescri
 DEFINE LABEL lb_prgdescri
  ROW 90
  COL 20
  VALUE l3w_fMsg("Label", "LBL002")
  WIDTH 100
  HEIGHT 25
  ALIGNMENT Left
 END LABEL
 DEFINE TEXTBOX prgdescri
  ROW 90
  COL 125
  HEIGHT 25
  WIDTH 200
  TOOLTIP l3w_fMsg("ToolTip", "TTI003")
  MAXLENGTH p999_LenField("progress","prgdescri")
  ONENTER p002_prgdescri()
 END TEXTBOX

* field prgnumero
 DEFINE LABEL lb_prgnumero
  ROW 120
  COL 20
  VALUE l3w_fMsg("Label", "LBL003")
  WIDTH 100
  HEIGHT 25
  ALIGNMENT Left
 END LABEL
 DEFINE TEXTBOX prgnumero
  ROW 120
  COL 125
  HEIGHT 25
  DATATYPE NUMERIC
  INPUTMASK '99,999,999'
  TOOLTIP l3w_fMsg("ToolTip", "TTI004")
  ONENTER p002_prgnumero()
 END TEXTBOX
END WINDOW
p002win.Center
RETURN NIL

/****************************************************************
* Entry function
* aParm[1] = form name to assign focus when leave this form
* aParm[2] = control name (about prev. form name) to assign focus when leave this form
* aParm[3] = control name (about prev. form name) to assign a value from grid of this form
* aParm[...] = control name (about prev. form name) to assign a value from grid of this form
* aParm[n] = control name (about prev. form name) to assign a value from grid of this form
* cCode = if passed when load grid set Grid.Value else is set to 1
****************************************************************/
FUNCTION p002_Main(aParm, cCode)
LOCAL lReturn := .F.
PUBLIC p002_cProcname := "hconp002"
cCode := IIF(VALTYPE(cCode)=="C", cCode, "")
aParm := IIF(VALTYPE(aParm)=="A", aParm, {})
IF l3w_fGetperms( p002_cProcname, "x" ) .AND. l3w_fFomFree( "p002win", "FormStatus", "N" )
 p002_ShowForm(aParm, cCode)
 lReturn := .T.
ELSE
 p002_NewFocus(aParm)
ENDIF
RETURN lReturn

/****************************************************************
* ShowForm function
* _nRecStatus = -1 No action taken
* _nRecStatus = 0 Record Not Found
* _nRecStatus = 1 Record Found and Locked
* _nRecStatus = 2 Record already deleted
* _nRecStatus = 3 (2+1) Record found and locked but already deleted
****************************************************************/
STATIC FUNCTION p002_ShowForm(aParm, cCode)
PUBLIC p002_nRecStatus := -1, p002_lOnChange := .F.
PUBLIC p002_aParm := aParm
p002win.StatusBar.Item(1) :=  "DataBase : " + l3w_fConf("DataBase", "Description")
p002win.StatusBar.Item(2) :=  "User : " + l3w_fConf("User", "Name")
p002win.Restore
p002win.SetFocus
p002_FormReset()
IF LEN(ALLTRIM(cCode))>0
 p002win.prgcodice.Value := cCode
 p002win.prgcodice.SetFocus
 p002_Enter()
ENDIF
RETURN NIL

/****************************************************************
* Set New Focus
* __MVEXIST, __MVGET, __MVPUT are little trick because p002_aParm is declared PUBLIC inside in p002_ShowForm function
* but p002_NewFocus can be called from p002_Main and p002_aParm it's not declared!
****************************************************************/
STATIC FUNCTION p002_NewFocus(aParm)
LOCAL aNewFocus := IIF(VALTYPE(aParm)=="A", aParm, IIF(__MVEXIST("p002_aParm"), __MVGET("p002_aParm"), {}))
IF LEN(aNewFocus)>=1
 DoMethod(aNewFocus[1], "Restore" )
 IF LEN(aNewFocus)==1
  DoMethod(aNewFocus[1], "SetFocus")
 ELSEIF LEN(aNewFocus)>=2
  DoMethod(aNewFocus[1], aNewFocus[2], "SetFocus")
 ENDIF
ENDIF
IF __MVEXIST("p002_aParm")
 __MVPUT("p002_aParm", {})
ENDIF
RETURN NIL

/****************************************************************
* IntercativeClose function
****************************************************************/
STATIC FUNCTION p002_IntClose()
p002_FormReset()
p002_StatusReset()
p002_NewFocus()
RETURN NIL

/****************************************************************
* Exit function
****************************************************************/
STATIC FUNCTION p002_Exit()
p002_FormReset()
p002_StatusReset()
p002win.Hide
p002_NewFocus()
RETURN NIL

/****************************************************************
* Save function
****************************************************************/
STATIC FUNCTION p002_Save()
IF l3w_fGetperms( p002_cProcname, "w" ) .AND. p002_CheckData()
 IF p002_Update()
  p002_FormReset()
  p002_StatusReset()
 ENDIF
ENDIF
RETURN NIL

/****************************************************************
* Reset function
****************************************************************/
STATIC FUNCTION p002_Reset()
p002_FormReset()
p002_StatusReset()
RETURN NIL

/****************************************************************
* Delete function
****************************************************************/
STATIC FUNCTION p002_Delete()
IF l3w_fGetperms( p002_cProcname, "d" )
 IF p002_nRecStatus==1
  progress->(DBDELETE())
  p002_FormReset()
  p002_StatusReset()
 ELSE
  MsgStop(l3w_fMsg("Error", "ERR001"),"p002_delete()")
 ENDIF
ENDIF
RETURN NIL

/****************************************************************
* UnDelete function
****************************************************************/
STATIC FUNCTION p002_Undelete()
IF l3w_fGetperms( p002_cProcname, "d" )
 IF p002_nRecStatus==3
  progress->(DBRECALL())
  p002_FormReset()
  p002_StatusReset()
 ELSE
  MsgStop(l3w_fMsg("Error", "ERR002"),"p002_undelete()")
 ENDIF
ENDIF
RETURN NIL

/****************************************************************
* Status Reset function
****************************************************************/
STATIC FUNCTION p002_StatusReset()
IF p002_nRecStatus<>-1
 progress->(DBUNLOCK())
ENDIF
p002_nRecStatus := -1
p002win.FormStatus.Value := "N"
RETURN NIL

/****************************************************************
* Form Reset function
****************************************************************/
STATIC FUNCTION p002_FormReset()
p002win.prgcodice.Value := ""
p002win.prgdescri.Value := ""
p002win.prgnumero.Value := 0

l3w_fSetAllControls("p002win", .F., {"prgdescri","prgnumero"})
p002win.prgcodice.Enabled := .T.
p002win.bt_src_prgcodice.Enabled := .T.
p002win.prgcodice.SetFocus

p002win.bt_save.Enabled := .F.
p002win.bt_reset.Enabled := .F.
RETURN NIL

/****************************************************************
* Retrieve record function
****************************************************************/
STATIC FUNCTION p002_Getrec()
LOCAL cKey := l3w_fFiller(p002win.prgcodice.Value, p999_LenField("progress","prgcodice"))
progress->(ORDSETFOCUS(1))
p002_nRecStatus := 0
IF progress->(DBSEEK(cKey, .F.))==.T.
 IF l3w_fReclock("progress")==.T.
  p002_nRecStatus := 1
  IF progress->(DELETED())
   p002_nRecStatus := 3
  ENDIF
  p002_LoadForm()
 ELSE
  MsgStop(l3w_fMsg("Error", "ERR003"),"p002_Getrec()")
 ENDIF
ELSE
 p002_LoadForm()
ENDIF
RETURN NIL

/****************************************************************
* Load form function
****************************************************************/
STATIC FUNCTION p002_LoadForm()
p002win.FormStatus.Value := "I"
IF p002_nRecStatus<>0
 p002win.prgdescri.Value := progress->prgdescri
 p002win.prgnumero.Value := progress->prgnumero
ENDIF
l3w_fSetAllControls("p002win", .T., {"prgdescri","prgnumero"})
p002win.prgcodice.Enabled := .F.
p002win.bt_src_prgcodice.Enabled := .F.
p002win.prgdescri.SetFocus

p002win.bt_save.Enabled := .T.
p002win.bt_reset.Enabled := .T.
RETURN NIL

/****************************************************************
* Update function
****************************************************************/
STATIC FUNCTION p002_Update()
LOCAL lDone := .T., lRiattiva := .F.
IF p002_nRecStatus==0 .AND. l3w_fAddrec("progress")==.F.
 MsgStop(l3w_fMsg("Error", "ERR004"),"p002_update()")
 lDone:=.F.
ENDIF
IF p002_nRecStatus==3
 lRiattiva := MsgYesNo(l3w_fMsg("Message", "MSG001"),"p002_update()")
ENDIF
IF lDone == .T.
 progress->adminproc := p002_cProcname
 progress->adminuser := l3w_fConf("User", "Login")
 progress->admintstp := HB_TTOS( HB_DATETIME() )
 progress->prgcodice := ALLTRIM(p002win.prgcodice.Value)
 progress->prgdescri := ALLTRIM(p002win.prgdescri.Value)
 progress->prgnumero := p002win.prgnumero.Value
 IF p002_nRecStatus==3 .AND. lRiattiva
  progress->(DBRECALL())
 ENDIF
 progress->(DBCOMMIT())
ENDIF
RETURN lDone

/****************************************************************
* Enter function
****************************************************************/
STATIC FUNCTION p002_Enter()
IF p002_prgcodice()==.T.
 p002_Getrec()
ENDIF
RETURN NIL

/****************************************************************
* Errors check
****************************************************************/
STATIC FUNCTION p002_CheckData()
LOCAL lItsOk := .T.
lItsOk := IF(lItsOk==.T., p002_prgcodice(), lItsOk)
lItsOk := IF(lItsOk==.T., p002_prgdescri(), lItsOk)
lItsOk := IF(lItsOk==.T., p002_prgnumero(), lItsOk)
RETURN lItsOk

/****************************************************************
* error prgcodice
****************************************************************/
STATIC FUNCTION p002_prgcodice()
LOCAL lItsOk := .T.
IF LEN( ALLTRIM( p002win.prgcodice.Value ) )==0
 lItsOk := .F.
 MsgStop(l3w_fMsg("Error", "ERR005"), "p002_prgcodice()")
 p002win.prgcodice.SetFocus
ENDIF
RETURN lItsOk
/****************************************************************
* src_prgcodice
****************************************************************/
STATIC FUNCTION p002_src_prgcodice()
LOCAL lReturn := p003_Main( {"p002win", "prgcodice", "prgcodice"}, p002win.prgcodice.Value )
RETURN NIL

/****************************************************************
* error prgdescri
****************************************************************/
STATIC FUNCTION p002_prgdescri()
LOCAL lItsOk := .T.
IF LEN(ALLTRIM(p002win.prgdescri.Value)) == 0
  lItsOk := .F.
  MsgStop(l3w_fMsg("Error", "ERR006"),"p002_prgdescri()")
  p002win.prgdescri.SetFocus
ENDIF
RETURN lItsOk

/****************************************************************
* error prgnumero
****************************************************************/
STATIC FUNCTION p002_prgnumero()
LOCAL lItsOk := .T.
IF p002win.prgnumero.Value < 0
  lItsOk := .F.
  MsgStop(l3w_fMsg("Error", "ERR007"),"p002_prgnumero()")
  p002win.prgnumero.SetFocus
ENDIF
RETURN lItsOk

/****************************************************************
* useful functions
****************************************************************/
/*
* ritorna il progressivo
*/
FUNCTION p002_getprogr(cQuale, nValore, cProcedure)
LOCAL lRetvalue := .F.
LOCAL p002_lastord := progress->(ORDSETFOCUS(1))
LOCAL p002_lastrec := progress->(RECNO())
LOCAL cKey := l3w_fFiller(cQuale, p999_LenField("progress","prgcodice"))
DEFAULT cProcedure := "hconp002"

* cerca la chiave
IF progress->(DBSEEK(cKey, .F.))==.T.
 IF l3w_fReclock("progress") == .T.
  progress->adminproc := cProcedure
  progress->adminuser := l3w_fConf("User", "Login")
  progress->admintstp := HB_TTOS( HB_DATETIME() )
  progress->prgnumero += 1
  nValore := progress->prgnumero
  progress->(DBCOMMIT())
  progress->(DBUNLOCK())
  lRetvalue := .T.
 ELSE
  MsgStop(l3w_fMsg("Error", "ERR008"),"p002_getprogr()")
 ENDIF
ELSE
 IF l3w_fAddrec("progress") == .T.
  progress->adminproc := cProcedure
  progress->adminuser := l3w_fConf("User", "Login")
  progress->admintstp := HB_TTOS( HB_DATETIME() )
  progress->prgcodice := ALLTRIM(cKey)
  progress->prgdescri := "Progressivo automatizzato"
  progress->prgnumero := 1
  nValore := progress->prgnumero
  progress->(DBCOMMIT())
  progress->(DBUNLOCK())
  lRetvalue := .T.
 ELSE
  MsgStop(l3w_fMsg("Error", "ERR009"),"p002_getprogr()")
 ENDIF
ENDIF
progress->(DBGOTO(p002_lastrec))
progress->(ORDSETFOCUS(p002_lastord))
RETURN lRetvalue