/****************************************************************
*        selezione progress
****************************************************************/
#include "hconp000.ch"

/****************************************************************
* Form definition
****************************************************************/
FUNCTION p003_Define()
LOCAL aGridHead := {l3w_fMsg("Grid", "GRD001"),l3w_fMsg("Grid", "GRD002"),l3w_fMsg("Grid", "GRD003")}

SET NAVIGATION EXTENDED
DEFINE WINDOW p003win ;
 ROW 0 ;
 COL 0 ;
 WIDTH 700 ;
 HEIGHT 525 ;
 TITLE l3w_fMsg("Form", "FRM003")+"(hconp003)" ;
 WINDOWTYPE CHILD ;
 NOAUTORELEASE ;
 NOMAXIMIZE ;
 ON INTERACTIVECLOSE p003_IntClose() ;
 ICON 'L3W_L3WICO' ;
 FONTNAME l3w_fConf("FormFont", "Name") FONTSIZE VAL(l3w_fConf("FormFont", "Size"))

 DEFINE TOOLBAR toolbar1 ;
  BUTTONSIZE 60,30 ;
  FONT l3w_fConf("ButtFont", "Name") ;
  SIZE VAL(l3w_fConf("ButtFont", "Size")) ;
  FLAT ;
  BORDER
  BUTTON bt_exit ;
   CAPTION l3w_fMsg("Command", "CMD001") ;
   PICTURE "L3W_IEXIT" ;
   ACTION p003_Exit() ;
   SEPARATOR
  BUTTON bt_select ;
   CAPTION l3w_fMsg("Command", "CMD010") ;
   PICTURE "L3W_IAPPLY" ;
   ACTION p003_Select() ;
   SEPARATOR
  BUTTON bt_addrec ;
   CAPTION l3w_fMsg("Command", "CMD007") ;
   PICTURE "L3W_IADDREC" ;
   ACTION p003_Addrec() ;
   SEPARATOR
  BUTTON bt_edit ;
   CAPTION l3w_fMsg("Command", "CMD008") ;
   PICTURE "L3W_IEDITREC" ;
   ACTION p003_Editrec() ;
   SEPARATOR
 END TOOLBAR

 DEFINE STATUSBAR
  STATUSITEM "DataBase : " + l3w_fConf("DataBase", "Description") WIDTH 250
  STATUSITEM "User : " + l3w_fConf("User", "Name") WIDTH 250
  CLOCK WIDTH 80
  DATE WIDTH 100
 END STATUSBAR

* Form Status:
* N=Form Free
* I=Form committed
 DEFINE LABEL FormStatus
  PARENT p003win
  ROW 20
  COL 500
  WIDTH 20
  HEIGHT 20
  VALUE "N"
  VISIBLE .F.
 END LABEL

* grid definition
 DEFINE GRID Grid1
  PARENT p003win
  ROW 60
  COL 20
  WIDTH 600
  HEIGHT 330
  HEADERS aGridHead
  WIDTHS {100,250,100}
  ONDBLCLICK p003_Select()
  ONHEADCLICK { {||p003_ChgOrd(1)}, {||p003_ChgOrd(2)}, {||p003_ChgOrd(1)} }
  TOOLTIP l3w_fMsg("ToolTip", "TTI006")
 END GRID

* field fldsearch
 DEFINE LABEL lb_fldsearch
  PARENT p003win
  ROW 420
  COL 20
  VALUE l3w_fMsg("Label", "LBL004")
  WIDTH 100
  HEIGHT 25
  ALIGNMENT Left
 END LABEL
 DEFINE TEXTBOX fldsearch
  ROW 420
  COL 125
  HEIGHT 25
  WIDTH 300
  TOOLTIP l3w_fMsg("ToolTip", "TTI005")
  MAXLENGTH p999_LenField("progress", "prgdescri")
  ONENTER p003_LoadForm()
 END TEXTBOX
* button bt_src1
 DEFINE BUTTON bt_src_fldsearch
  ROW 420
  COL 430
  PICTURE "L3W_IFIND"
  ONCLICK p003_LoadForm()
  WIDTH 30
  HEIGHT 30
  TOOLTIP l3w_fMsg("ToolTip", "TTI002")
  FLAT .T.
  TABSTOP .F.
 END BUTTON
END WINDOW
p003win.Center
RETURN NIL

/****************************************************************
* Entry function
* aParm[1] = form name to assign focus when leave this form
* aParm[2] = control name (about prev. form name) to assign focus when leave this form
* aParm[3] = control name (about prev. form name) to assign a value from grid of this form
* aParm[...] = control name (about prev. form name) to assign a value from grid of this form
* aParm[n] = control name (about prev. form name) to assign a value from grid of this form
* cCode = if passed when load grid set Grid.Value else is set to 1
****************************************************************/
FUNCTION p003_Main( aParm, cCode)
LOCAL lReturn := .F.
PUBLIC p003_cProcname := "hconp003"
cCode := IIF(VALTYPE(cCode)=="C", cCode, "")
aParm := IIF(VALTYPE(aParm)=="A", aParm, {})
IF l3w_fGetperms( p003_cProcname, "x" ) .AND. l3w_fFomFree( "p003win", "FormStatus", "N" )
 p003_ShowForm( aParm, cCode)
 lReturn := .T.
ELSE
 p003_NewFocus(aParm)
ENDIF
RETURN lReturn

/****************************************************************
* ShowForm function
****************************************************************/
STATIC FUNCTION p003_ShowForm( aParm, cCode)
PUBLIC p003_nOrder := 2, p003_lFirst := .T.
PUBLIC p003_aParm := aParm, p003_cCode := cCode
p003win.StatusBar.Item(1) :=  "DataBase : " + l3w_fConf("DataBase", "Description")
p003win.StatusBar.Item(2) :=  "User : " + l3w_fConf("User", "Name")
p003win.Restore
p003win.Setfocus
p003_LoadForm()
RETURN NIL

/****************************************************************
* Set New Focus
* __MVEXIST, __MVGET, __MVPUT are little trick because p003_aParm is declared PUBLIC inside in p003_ShowForm function
* but p003_NewFocus can be called from p003_Main and p003_aParm it's not declared!
****************************************************************/
STATIC FUNCTION p003_NewFocus(aParm)
LOCAL aNewFocus := IIF(VALTYPE(aParm)=="A", aParm, IIF(__MVEXIST("p003_aParm"), __MVGET("p003_aParm"), {}))
IF LEN(aNewFocus)>=1
 DoMethod(aNewFocus[1], "Restore" )
 IF LEN(aNewFocus)==1
  DoMethod(aNewFocus[1], "SetFocus")
 ELSEIF LEN(aNewFocus)>=2
  DoMethod(aNewFocus[1], aNewFocus[2], "SetFocus")
 ENDIF
ENDIF
IF __MVEXIST("p003_aParm")
 __MVPUT("p003_aParm", {})
ENDIF
RETURN NIL

/****************************************************************
* IntercativeClose function
****************************************************************/
STATIC FUNCTION p003_IntClose()
p003_StatusReset()
p003_FormReset()
p003_NewFocus()
RETURN NIL

/****************************************************************
* Exit function
****************************************************************/
STATIC FUNCTION p003_Exit()
p003_StatusReset()
p003_FormReset()
p003win.Hide
p003_NewFocus()
RETURN NIL

/****************************************************************
* Reset function
****************************************************************/
STATIC FUNCTION p003_Reset()
p003_FormReset()
RETURN NIL

/****************************************************************
* Select function
****************************************************************/
STATIC FUNCTION p003_Select()
LOCAL aTemp := {}
IF p003win.Grid1.Value<>0
 aTemp := p003win.Grid1.Item( p003win.Grid1.Value )
 IF LEN(p003_aParm)>=3
  SetProperty( p003_aParm[1], p003_aParm[3], "Value", aTemp[1] )
 ENDIF
 IF LEN(p003_aParm)>=4
  SetProperty( p003_aParm[1], p003_aParm[4], "Value", aTemp[2] )
 ENDIF
 p003_StatusReset()
 p003_FormReset()
 p003win.Hide
 p003_NewFocus()
ENDIF
RETURN NIL

/****************************************************************
* Addrec function
****************************************************************/
STATIC FUNCTION p003_Addrec()
IF p002_Main({"p003win", "Grid1"}, "")
 p003_StatusReset()
 p003_FormReset()
 p003win.Hide
ENDIF
RETURN NIL

/****************************************************************
* Editrec function
****************************************************************/
STATIC FUNCTION p003_Editrec()
LOCAL aTemp := {}
IF p003win.Grid1.Value<>0
 aTemp := p003win.Grid1.Item( p003win.Grid1.Value )
 IF p002_Main({"p003win", "Grid1"}, aTemp[1])
  p003_StatusReset()
  p003_FormReset()
  p003win.Hide
 ENDIF
ENDIF
RETURN NIL

/****************************************************************
* Status Reset function
****************************************************************/
STATIC FUNCTION p003_StatusReset()
p003win.FormStatus.Value := "N"
RETURN NIL

/****************************************************************
* Form Reset function
****************************************************************/
STATIC FUNCTION p003_FormReset()
* p003win.Grid1.DeleteAllItems
p003win.fldsearch.Value := ""
RETURN NIL

/****************************************************************
* Change Order
****************************************************************/
STATIC FUNCTION p003_ChgOrd(nOrd)
p003_nOrder := nOrd
p003_LoadForm()
RETURN NIL

/****************************************************************
* Load form function
****************************************************************/
STATIC FUNCTION p003_LoadForm()
LOCAL nGrid := 1, lAddrow := .T.
* commits form video
p003win.FormStatus.Value := "I"
progress->(ORDSETFOCUS(p003_nOrder))
progress->(DBGOTOP())
p003win.Grid1.DeleteAllItems
DO WHILE !progress->(EOF())
 lAddrow := .F.
 IF LEN(ALLTRIM(p003win.fldsearch.Value))==0 .OR. ;
  AT(LOWER(ALLTRIM(p003win.fldsearch.Value)), LOWER(ALLTRIM(progress->prgdescri)))<>0
  lAddrow := .T.
 ENDIF
 IF lAddrow == .T.
  p003win.Grid1.AddItem( {progress->prgcodice, progress->prgdescri, LTRIM(STR(progress->prgnumero,8,0))} )
  IF p003_lFirst .AND. LEN(ALLTRIM(p003_cCode))>0 .AND. ALLTRIM(p003_cCode)==ALLTRIM(progress->prgcodice)
   nGrid := p003win.Grid1.ItemCount
  ENDIF
 ENDIF
 progress->(DBSKIP(+1))
ENDDO
p003_lFirst := .F.
p003win.Grid1.Value := IIF( nGrid>0, nGrid, 1 )
p003win.Grid1.Refresh
p003win.Grid1.Setfocus
RETURN NIL