/****************************************************************
* manager of table category
****************************************************************/
#include "hconp000.ch"

/****************************************************************
* Form definition
****************************************************************/
FUNCTION p004_Define()
LOCAL aStatdes := p999_aStatus("D")

SET NAVIGATION EXTENDED
DEFINE WINDOW p004win ;
 ROW 0 ;
 COL 0 ;
 WIDTH 940 ;
 HEIGHT 705 ;
 TITLE l3w_fMsg("Form", "FRM004")+" (hconp004)" ;
 WINDOWTYPE CHILD ;
 NOAUTORELEASE ;
 NOMAXIMIZE ;
 ON INTERACTIVECLOSE p004_IntClose() ;
 ICON 'L3W_L3WICO' ;
 FONTNAME l3w_fConf("FormFont", "Name") FONTSIZE VAL(l3w_fConf("FormFont", "Size"))

 DEFINE TOOLBAR toolbar1 ;
  BUTTONSIZE 60,30 ;
  FONT l3w_fConf("ButtFont", "Name") ;
  SIZE VAL(l3w_fConf("ButtFont", "Size")) ;
  FLAT ;
  BORDER
  BUTTON bt_exit ;
   CAPTION l3w_fMsg("Command", "CMD001") ;
   PICTURE "L3W_IEXIT" ;
   ACTION p004_Exit() ;
   SEPARATOR
  BUTTON bt_save ;
   CAPTION l3w_fMsg("Command", "CMD002") ;
   PICTURE "L3W_ISAVE" ;
   ACTION p004_Save() ;
   SEPARATOR
  BUTTON bt_reset ;
   CAPTION l3w_fMsg("Command", "CMD009") ;
   PICTURE "L3W_ICLEAR" ;
   ACTION p004_Reset() ;
   SEPARATOR
 END TOOLBAR

 DEFINE STATUSBAR
  STATUSITEM "DataBase : " + l3w_fConf("DataBase", "Description") WIDTH 250
  STATUSITEM "User : " + l3w_fConf("User", "Name") WIDTH 250
  CLOCK WIDTH 80
  DATE WIDTH 100
 END STATUSBAR

* form status :
* N=Form Free
* I=Form committed
 DEFINE LABEL FormStatus
  PARENT p004win
  ROW 20
  COL 500
  WIDTH 20
  HEIGHT 20
  VALUE "N"
  VISIBLE .F.
 END LABEL

* field catidcate
 DEFINE LABEL lb_catidcate
  PARENT p004win
  ROW 60
  COL 20
  VALUE l3w_fMsg("Label", "LBL001")
  WIDTH 100
  HEIGHT 25
  ALIGNMENT Left
 END LABEL
 DEFINE TEXTBOX catidcate
  PARENT p004win
  ROW 60
  COL 125
  HEIGHT 25
  WIDTH 100
  TOOLTIP l3w_fMsg("ToolTip", "TTI001")
  MAXLENGTH p999_LenField("category", "catidcate")
  CASECONVERT UPPER
  ONENTER p004_Enter()
 END TEXTBOX
* button bt_src_catidcate
 DEFINE BUTTON bt_src_catidcate
  PARENT p004win
  ROW 60
  COL 230
  PICTURE "L3W_ISEARCH"
  ONCLICK p004_Src_catidcate()
  WIDTH 30
  HEIGHT 30
  TOOLTIP l3w_fMsg("ToolTip", "TTI002")
  FLAT .T.
  TABSTOP .F.
 END BUTTON

* field catstatus
 DEFINE LABEL lb_catstatus
  PARENT p004win
  ROW 90
  COL 20
  VALUE 'Status'
  WIDTH 100
  HEIGHT 25
  ALIGNMENT Left
 END LABEL
 DEFINE COMBOBOX cb_catstatus
  PARENT p004win
  ROW 90
  COL 125
  WIDTH 125
  ITEMS aStatdes
  VALUE 1
 END COMBOBOX

* field catdescri
 DEFINE LABEL lb_catdescri
  ROW 120
  COL 20
  VALUE l3w_fMsg("Label", "LBL002")
  WIDTH 100
  HEIGHT 25
  ALIGNMENT Left
 END LABEL
 DEFINE TEXTBOX catdescri
  ROW 120
  COL 125
  HEIGHT 25
  WIDTH 200
  TOOLTIP l3w_fMsg("ToolTip", "TTI003")
  MAXLENGTH p999_LenField("category","catdescri")
  ONENTER p004_catdescri()
 END TEXTBOX

END WINDOW
p004win.Center
RETURN NIL

/****************************************************************
* Entry function
* aParm[1] = form name to assign focus when leave this form
* aParm[2] = control name (about prev. form name) to assign focus when leave this form
* aParm[3] = control name (about prev. form name) to assign a value from grid of this form
* aParm[...] = control name (about prev. form name) to assign a value from grid of this form
* aParm[n] = control name (about prev. form name) to assign a value from grid of this form
* cCode = if passed when load grid set Grid.Value else is set to 1
****************************************************************/
FUNCTION p004_Main(aParm, cCode)
LOCAL lReturn := .F.
PUBLIC p004_cProcname := "hconp004"
cCode := IIF(VALTYPE(cCode)=="C", cCode, "")
aParm := IIF(VALTYPE(aParm)=="A", aParm, {})
IF l3w_fGetperms( p004_cProcname, "x" ) .AND. l3w_fFomFree( "p004win", "FormStatus", "N" )
 p004_ShowForm(aParm, cCode)
 lReturn := .T.
ELSE
 p004_NewFocus(aParm)
ENDIF
RETURN lReturn

/****************************************************************
* ShowForm function
* _nRecStatus = -1 No action taken
* _nRecStatus = 0 Record Not Found
* _nRecStatus = 1 Record Found and Locked
* _nRecStatus = 2 Record already deleted
* _nRecStatus = 3 (2+1) Record found and locked but already deleted
****************************************************************/
STATIC FUNCTION p004_ShowForm(aParm, cCode)
PUBLIC p004_nRecStatus := -1, p004_lOnChange := .F.
PUBLIC p004_aParm := aParm
p004win.StatusBar.Item(1) :=  "DataBase : " + l3w_fConf("DataBase", "Description")
p004win.StatusBar.Item(2) :=  "User : " + l3w_fConf("User", "Name")
p004win.Restore
p004win.SetFocus
p004_FormReset()
IF LEN(ALLTRIM(cCode))>0
 p004win.catidcate.Value := cCode
 p004win.catidcate.SetFocus
 p004_Enter()
ENDIF
RETURN NIL

/****************************************************************
* Set New Focus
* __MVEXIST, __MVGET, __MVPUT are little trick because p004_aParm is declared PUBLIC inside in p004_ShowForm function
* but p004_NewFocus can be called from p004_Main and p004_aParm it's not declared!
****************************************************************/
STATIC FUNCTION p004_NewFocus(aParm)
LOCAL aNewFocus := IIF(VALTYPE(aParm)=="A", aParm, IIF(__MVEXIST("p004_aParm"), __MVGET("p004_aParm"), {}))
IF LEN(aNewFocus)>=1
 DoMethod(aNewFocus[1], "Restore" )
 IF LEN(aNewFocus)==1
  DoMethod(aNewFocus[1], "SetFocus")
 ELSEIF LEN(aNewFocus)>=2
  DoMethod(aNewFocus[1], aNewFocus[2], "SetFocus")
 ENDIF
ENDIF
IF __MVEXIST("p004_aParm")
 __MVPUT("p004_aParm", {})
ENDIF
RETURN NIL

/****************************************************************
* IntercativeClose function
****************************************************************/
STATIC FUNCTION p004_IntClose()
p004_FormReset()
p004_StatusReset()
p004_NewFocus()
RETURN NIL

/****************************************************************
* Exit function
****************************************************************/
STATIC FUNCTION p004_Exit()
p004_FormReset()
p004_StatusReset()
p004win.Hide
p004_NewFocus()
RETURN NIL

/****************************************************************
* Save function
****************************************************************/
STATIC FUNCTION p004_Save()
IF l3w_fGetperms( p004_cProcname, "w" ) .AND. p004_CheckData()
 IF p004_Update()
  p004_FormReset()
  p004_StatusReset()
 ENDIF
ENDIF
RETURN NIL

/****************************************************************
* Reset function
****************************************************************/
STATIC FUNCTION p004_Reset()
p004_FormReset()
p004_StatusReset()
RETURN NIL

/****************************************************************
* Delete function
****************************************************************/
STATIC FUNCTION p004_Delete()
IF l3w_fGetperms( p004_cProcname, "d" )
 IF p004_nRecStatus==1
  category->(DBDELETE())
  p004_FormReset()
  p004_StatusReset()
 ELSE
  MsgStop(l3w_fMsg("Error", "ERR001"),"p004_delete()")
 ENDIF
ENDIF
RETURN NIL

/****************************************************************
* UnDelete function
****************************************************************/
STATIC FUNCTION p004_Undelete()
IF l3w_fGetperms( p004_cProcname, "d" )
 IF p004_nRecStatus==3
  category->(DBRECALL())
  p004_FormReset()
  p004_StatusReset()
 ELSE
  MsgStop(l3w_fMsg("Error", "ERR002"),"p004_undelete()")
 ENDIF
ENDIF
RETURN NIL

/****************************************************************
* Status Reset function
****************************************************************/
STATIC FUNCTION p004_StatusReset()
IF p004_nRecStatus<>-1
 category->(DBUNLOCK())
ENDIF
p004_nRecStatus := -1
p004win.FormStatus.Value := "N"
RETURN NIL

/****************************************************************
* Form Reset function
****************************************************************/
STATIC FUNCTION p004_FormReset()
p004win.cb_catstatus.Value := 1
p004win.catidcate.Value := ""
p004win.catdescri.Value := ""

l3w_fSetAllControls("p004win", .F., {"cb_catstatus","catdescri"})
p004win.catidcate.Enabled := .T.
p004win.bt_src_catidcate.Enabled := .T.
p004win.catidcate.SetFocus

p004win.bt_save.Enabled := .F.
p004win.bt_reset.Enabled := .F.
RETURN NIL

/****************************************************************
* Retrieve record function
****************************************************************/
STATIC FUNCTION p004_Getrec()
LOCAL cKey := l3w_fFiller(p004win.catidcate.Value, p999_LenField("category","catidcate"))
category->(ORDSETFOCUS(1))
p004_nRecStatus := 0
IF category->(DBSEEK(cKey, .F.))==.T.
 IF l3w_fReclock("category")==.T.
  p004_nRecStatus := 1
  IF category->(DELETED())
   p004_nRecStatus := 3
  ENDIF
  p004_LoadForm()
 ELSE
  MsgStop(l3w_fMsg("Error", "ERR003"), "p004_Getrec()")
 ENDIF
ELSE
 p004_LoadForm()
ENDIF
RETURN NIL

/****************************************************************
* Load form function
****************************************************************/
STATIC FUNCTION p004_LoadForm()
p004win.FormStatus.Value := "I"
IF p004_nRecStatus<>0
 p004win.cb_catstatus.Value := p999_StatusByCod(category->catstatus)
 p004win.catdescri.Value := category->catdescri
ENDIF
l3w_fSetAllControls("p004win", .T., {"cb_catstatus","catdescri"})
p004win.catidcate.Enabled := .F.
p004win.bt_src_catidcate.Enabled := .F.
p004win.catdescri.SetFocus

p004win.bt_save.Enabled := .T.
p004win.bt_reset.Enabled := .T.
RETURN NIL

/****************************************************************
* Update function
****************************************************************/
STATIC FUNCTION p004_Update()
LOCAL lDone := .T., lRiattiva := .F.
IF p004_nRecStatus==0 .AND. l3w_fAddrec("category")==.F.
 MsgStop(l3w_fMsg("Error", "ERR004"),"p004_update()")
 lDone:=.F.
ENDIF
IF p004_nRecStatus==3
 lRiattiva := MsgYesNo(l3w_fMsg("Message", "MSG001"),"p004_update()")
ENDIF
IF lDone == .T.
 category->adminproc := p004_cProcname
 category->adminuser := l3w_fConf("User", "Login")
 category->admintstp := HB_TTOS(HB_DATETIME())
 category->catidcate := p004win.catidcate.Value
 category->catstatus := p999_StatusByNum(p004win.cb_catstatus.Value)
 category->catdescri := p004win.catdescri.Value
 IF p004_nRecStatus==3 .AND. lRiattiva==.T.
  category->(DBRECALL())
 ENDIF
 category->(DBCOMMIT())
ENDIF
RETURN lDone

/****************************************************************
* Enter function
****************************************************************/
STATIC FUNCTION p004_Enter()
IF p004_catidcate()==.T.
 p004_Getrec()
ENDIF
RETURN NIL

/****************************************************************
* Errors check
****************************************************************/
STATIC FUNCTION p004_CheckData()
LOCAL lItsOk := .T.
lItsOk := IF(lItsOk==.T., p004_catidcate(), lItsOk)
lItsOk := IF(lItsOk==.T., p004_catdescri(), lItsOk)
RETURN lItsOk

/****************************************************************
* error catidcate
****************************************************************/
STATIC FUNCTION p004_catidcate()
LOCAL lItsOk := .T.
IF LEN( ALLTRIM( p004win.catidcate.Value ) )==0
 lItsOk := .F.
 MsgStop(l3w_fMsg("Error", "ERR005"), "p004_catidcate()")
 p004win.catidcate.SetFocus
ENDIF
RETURN lItsOk
/****************************************************************
* src1
****************************************************************/
STATIC FUNCTION p004_src_catidcate()
LOCAL lReturn := p005_Main( {"p004win", "catidcate", "catidcate"}, p004win.catidcate.Value )
RETURN NIL

/****************************************************************
* error catdescri
****************************************************************/
STATIC FUNCTION p004_catdescri()
LOCAL lItsOk := .T.
IF LEN(ALLTRIM(p004win.catdescri.Value)) == 0
  lItsOk := .F.
  MsgStop(l3w_fMsg("Error", "ERR006"),"p004_catdescri()")
  p004win.catdescri.SetFocus
ENDIF
RETURN lItsOk

/****************************************************************
* useful functions
****************************************************************/
/*
* check if code exists
*/
FUNCTION p004_Isok(cChiave)
LOCAL p004_lastord := category->(ORDSETFOCUS(1))
LOCAL p004_lastrec := category->(RECNO())
LOCAL cKey := l3w_fFiller(cChiave, p999_LenField("category","catidcate"))
LOCAL lReturn := .F.
IF LEN(ALLTRIM(cKey))>0
 lReturn := category->(DBSEEK(cKey, .F.))
ENDIF
category->(DBGOTO(p004_lastrec))
category->(ORDSETFOCUS(p004_lastord))
RETURN lReturn

/*
* retrieve datas
*/
FUNCTION p004_Getdes(cChiave)
LOCAL nLastord := category->(ORDSETFOCUS(1)), nLastrec := category->(RECNO())
LOCAL cKey := l3w_fFiller(cChiave, p999_LenField("category","catidcate"))
LOCAL aReturn := {"",""}
IF LEN(ALLTRIM(cKey))>0
 IF category->(DBSEEK(cKey, .F.))
  aReturn[1] := category->catstatus
  aReturn[2] := category->catdescri
 ENDIF
ENDIF
category->(ORDSETFOCUS(nLastord))
category->(DBGOTO(nLastrec))
RETURN aReturn