/****************************************************************
*        selezione category
****************************************************************/
#include "hconp000.ch"

/****************************************************************
* Form definition
****************************************************************/
FUNCTION p005_Define()
LOCAL aGridHead := {l3w_fMsg("Grid", "GRD004"),l3w_fMsg("Grid", "GRD001"),l3w_fMsg("Grid", "GRD002")}
LOCAL aGrid1 := {"TEXTBOX", "CHARACTER"}
LOCAL aGrid2 := {"TEXTBOX", "CHARACTER"}
LOCAL aGrid3 := {"TEXTBOX", "CHARACTER"}

SET NAVIGATION EXTENDED
DEFINE WINDOW p005win ;
 ROW 0 ;
 COL 0 ;
 WIDTH 700 ;
 HEIGHT 525 ;
 TITLE l3w_fMsg("Form", "FRM005")+" (hconp005)" ;
 WINDOWTYPE CHILD ;
 NOAUTORELEASE ;
 NOMAXIMIZE ;
 ON INTERACTIVECLOSE p005_IntClose() ;
 ICON 'L3W_L3WICO' ;
 FONTNAME l3w_fConf("FormFont", "Name") FONTSIZE VAL(l3w_fConf("FormFont", "Size"))

 DEFINE TOOLBAR toolbar1 ;
  BUTTONSIZE 60,30 ;
  FONT l3w_fConf("ButtFont", "Name") ;
  SIZE VAL(l3w_fConf("ButtFont", "Size")) ;
  FLAT ;
  BORDER
  BUTTON bt_exit ;
   CAPTION l3w_fMsg("Command", "CMD001") ;
   PICTURE "L3W_IEXIT" ;
   ACTION p005_Exit() ;
   SEPARATOR
  BUTTON bt_select ;
   CAPTION l3w_fMsg("Command", "CMD010") ;
   PICTURE "L3W_IAPPLY" ;
   ACTION p005_Select() ;
   SEPARATOR
  BUTTON bt_addrec ;
   CAPTION l3w_fMsg("Command", "CMD007") ;
   PICTURE "L3W_IADDREC" ;
   ACTION p005_Addrec() ;
   SEPARATOR
  BUTTON bt_edit ;
   CAPTION l3w_fMsg("Command", "CMD008") ;
   PICTURE "L3W_IEDITREC" ;
   ACTION p005_Editrec() ;
   SEPARATOR
 END TOOLBAR

 DEFINE STATUSBAR
  STATUSITEM "DataBase : " + l3w_fConf("DataBase", "Description") WIDTH 250
  STATUSITEM "User : " + l3w_fConf("User", "Name") WIDTH 250
  CLOCK WIDTH 80
  DATE WIDTH 100
 END STATUSBAR

* Form Status:
* N=Form Free
* I=Form committed
 DEFINE LABEL FormStatus
  PARENT p005win
  ROW 20
  COL 500
  WIDTH 20
  HEIGHT 20
  VALUE "N"
  VISIBLE .F.
 END LABEL

* grid definition
 DEFINE GRID Grid1
  PARENT p005win
  ROW 60
  COL 20
  WIDTH 600
  HEIGHT 330
  HEADERS aGridHead
  WIDTHS {80,100,300}
  ONHEADCLICK { {||p005_ChgOrd(1)}, {||p005_ChgOrd(1)}, {||p005_ChgOrd(2)} }
  COLUMNCONTROLS {aGrid1, aGrid2, aGrid3}
  TOOLTIP l3w_fMsg("ToolTip", "TTI006")
  ONDBLCLICK p005_Select()
 END GRID

* field fldsearch
 DEFINE LABEL lb_fldsearch
  PARENT p005win
  ROW 420
  COL 20
  VALUE l3w_fMsg("Label", "LBL004")
  WIDTH 100
  HEIGHT 25
  ALIGNMENT Left
 END LABEL
 DEFINE TEXTBOX fldsearch
  ROW 420
  COL 125
  HEIGHT 25
  WIDTH 300
  TOOLTIP l3w_fMsg("ToolTip", "TTI005")
  MAXLENGTH p999_LenField("category", "catdescri")
  ONENTER p005_LoadForm()
 END TEXTBOX
* button bt_src1
 DEFINE BUTTON bt_src_fldsearch
  ROW 420
  COL 430
  PICTURE "L3W_IFIND"
  ONCLICK p005_LoadForm()
  WIDTH 30
  HEIGHT 30
  TOOLTIP l3w_fMsg("ToolTip", "TTI002")
  FLAT .T.
  TABSTOP .F.
 END BUTTON
END WINDOW
p005win.Center
RETURN NIL

/****************************************************************
* Entry function
* aParm[1] = form name to assign focus when leave this form
* aParm[2] = control name (about prev. form name) to assign focus when leave this form
* aParm[3] = control name (about prev. form name) to assign a value from grid of this form
* aParm[...] = control name (about prev. form name) to assign a value from grid of this form
* aParm[n] = control name (about prev. form name) to assign a value from grid of this form
* cCode = if passed when load grid set Grid.Value else is set to 1
****************************************************************/
FUNCTION p005_Main( aParm, cCode)
LOCAL lReturn := .F.
PUBLIC p005_cProcname := "hconp005"
cCode := IIF(VALTYPE(cCode)=="C", cCode, "")
aParm := IIF(VALTYPE(aParm)=="A", aParm, {})
IF l3w_fGetperms( p005_cProcname, "x" ) .AND. l3w_fFomFree( "p005win", "FormStatus", "N" )
 p005_ShowForm( aParm, cCode)
 lReturn := .T.
ELSE
 p005_NewFocus(aParm)
ENDIF
RETURN lReturn

/****************************************************************
* ShowForm function
****************************************************************/
STATIC FUNCTION p005_ShowForm( aParm, cCode)
PUBLIC p005_nOrder := 2, p005_lFirst := .T.
PUBLIC p005_aParm := aParm, p005_cCode := cCode
p005win.StatusBar.Item(1) :=  "DataBase : " + l3w_fConf("DataBase", "Description")
p005win.StatusBar.Item(2) :=  "User : " + l3w_fConf("User", "Name")
p005win.Restore
p005win.Setfocus
p005_LoadForm()
RETURN NIL

/****************************************************************
* Set New Focus
* __MVEXIST, __MVGET, __MVPUT are little trick because p005_aParm is declared PUBLIC inside in p005_ShowForm function
* but p005_NewFocus can be called from p005_Main and p005_aParm it's not declared!
****************************************************************/
STATIC FUNCTION p005_NewFocus(aParm)
LOCAL aNewFocus := IIF(VALTYPE(aParm)=="A", aParm, IIF(__MVEXIST("p005_aParm"), __MVGET("p005_aParm"), {}))
IF LEN(aNewFocus)>=1
 DoMethod(aNewFocus[1], "Restore" )
 IF LEN(aNewFocus)==1
  DoMethod(aNewFocus[1], "SetFocus")
 ELSEIF LEN(aNewFocus)>=2
  DoMethod(aNewFocus[1], aNewFocus[2], "SetFocus")
 ENDIF
ENDIF
IF __MVEXIST("p005_aParm")
 __MVPUT("p005_aParm", {})
ENDIF
RETURN NIL

/****************************************************************
* IntercativeClose function
****************************************************************/
STATIC FUNCTION p005_IntClose()
p005_StatusReset()
p005_FormReset()
p005_NewFocus()
RETURN NIL

/****************************************************************
* Exit function
****************************************************************/
STATIC FUNCTION p005_Exit()
p005_StatusReset()
p005_FormReset()
p005win.Hide
p005_NewFocus()
RETURN NIL

/****************************************************************
* Reset function
****************************************************************/
STATIC FUNCTION p005_Reset()
p005_FormReset()
RETURN NIL

/****************************************************************
* Select function
****************************************************************/
STATIC FUNCTION p005_Select()
LOCAL aTemp := {}
IF p005win.Grid1.Value<>0
 aTemp := p005win.Grid1.Item( p005win.Grid1.Value )
 IF LEN(p005_aParm)>=3
  SetProperty( p005_aParm[1], p005_aParm[3], "Value", aTemp[2] )
 ENDIF
 IF LEN(p005_aParm)>=4
  SetProperty( p005_aParm[1], p005_aParm[4], "Value", aTemp[3] )
 ENDIF
 p005_StatusReset()
 p005_FormReset()
 p005win.Hide
 p005_NewFocus()
ENDIF
RETURN NIL

/****************************************************************
* Addrec function
****************************************************************/
STATIC FUNCTION p005_Addrec()
IF p004_Main({"p005win", "Grid1"}, "")
 p005_StatusReset()
 p005_FormReset()
 p005win.Hide
ENDIF
RETURN NIL

/****************************************************************
* Editrec function
****************************************************************/
STATIC FUNCTION p005_Editrec()
LOCAL aTemp := {}
IF p005win.Grid1.Value<>0
 aTemp := p005win.Grid1.Item( p005win.Grid1.Value )
 IF p004_Main({"p005win", "Grid1"}, aTemp[1])
  p005_StatusReset()
  p005_FormReset()
  p005win.Hide
 ENDIF
ENDIF
RETURN NIL

/****************************************************************
* Status Reset function
****************************************************************/
STATIC FUNCTION p005_StatusReset()
p005win.FormStatus.Value := "N"
RETURN NIL

/****************************************************************
* Form Reset function
****************************************************************/
STATIC FUNCTION p005_FormReset()
* p005win.Grid1.DeleteAllItems
p005win.fldsearch.Value := ""
RETURN NIL

/****************************************************************
* Change Order
****************************************************************/
STATIC FUNCTION p005_ChgOrd(nOrd)
p005_nOrder := nOrd
p005_LoadForm()
RETURN NIL

/****************************************************************
* Load form function
****************************************************************/
STATIC FUNCTION p005_LoadForm()
LOCAL nGrid := 1, lAddrow := .T.
* commits form video
p005win.FormStatus.Value := "I"
category->(ORDSETFOCUS(p005_nOrder))
category->(DBGOTOP())
p005win.Grid1.DeleteAllItems
DO WHILE !category->(EOF())
 lAddrow := .F.
 IF LEN(ALLTRIM(p005win.fldsearch.Value))==0 .OR. ;
  AT(LOWER(ALLTRIM(p005win.fldsearch.Value)), LOWER(ALLTRIM(category->catdescri)))<>0
  lAddrow := .T.
 ENDIF
 IF lAddrow == .T.
*  p005win.Grid1.AddItem( {category->catstatus, category->catidcate, category->catdescri} )
  p005win.Grid1.AddItem( {p999_StatusByDes(category->catstatus), category->catidcate, category->catdescri} )
  IF p005_lFirst .AND. LEN(ALLTRIM(p005_cCode))>0 .AND. ALLTRIM(p005_cCode)==ALLTRIM(category->catidcate)
   nGrid := p005win.Grid1.ItemCount
  ENDIF
 ENDIF
 category->(DBSKIP(+1))
ENDDO
p005_lFirst := .F.
p005win.Grid1.Value := IIF( nGrid>0, nGrid, 1 )
p005win.Grid1.Refresh
p005win.Grid1.Setfocus
RETURN NIL