/****************************************************************
* manager of table language
****************************************************************/
#include "hconp000.ch"

/****************************************************************
* Form definition
****************************************************************/
FUNCTION p006_Define()
LOCAL aStatdes := p999_aStatus("D")

SET NAVIGATION EXTENDED
DEFINE WINDOW p006win ;
 ROW 0 ;
 COL 0 ;
 WIDTH 940 ;
 HEIGHT 705 ;
 TITLE l3w_fMsg("Form", "FRM006")+" (hconp006)" ;
 WINDOWTYPE CHILD ;
 NOAUTORELEASE ;
 NOMAXIMIZE ;
 ON INTERACTIVECLOSE p006_IntClose() ;
 ICON 'L3W_L3WICO' ;
 FONTNAME l3w_fConf("FormFont", "Name") FONTSIZE VAL(l3w_fConf("FormFont", "Size"))

 DEFINE TOOLBAR toolbar1 ;
  BUTTONSIZE 60,30 ;
  FONT l3w_fConf("ButtFont", "Name") ;
  SIZE VAL(l3w_fConf("ButtFont", "Size")) ;
  FLAT ;
  BORDER
  BUTTON bt_exit ;
   CAPTION l3w_fMsg("Command", "CMD001") ;
   PICTURE "L3W_IEXIT" ;
   ACTION p006_Exit() ;
   SEPARATOR
  BUTTON bt_save ;
   CAPTION l3w_fMsg("Command", "CMD002") ;
   PICTURE "L3W_ISAVE" ;
   ACTION p006_Save() ;
   SEPARATOR
  BUTTON bt_reset ;
   CAPTION l3w_fMsg("Command", "CMD009") ;
   PICTURE "L3W_ICLEAR" ;
   ACTION p006_Reset() ;
   SEPARATOR
 END TOOLBAR

 DEFINE STATUSBAR
  STATUSITEM "DataBase : " + l3w_fConf("DataBase", "Description") WIDTH 250
  STATUSITEM "User : " + l3w_fConf("User", "Name") WIDTH 250
  CLOCK WIDTH 80
  DATE WIDTH 100
 END STATUSBAR

* form status :
* N=Form Free
* I=Form committed
 DEFINE LABEL FormStatus
  PARENT p006win
  ROW 20
  COL 500
  WIDTH 20
  HEIGHT 20
  VALUE "N"
  VISIBLE .F.
 END LABEL

* field lanidlang
 DEFINE LABEL lb_lanidlang
  PARENT p006win
  ROW 60
  COL 20
  VALUE l3w_fMsg("Label", "LBL001")
  WIDTH 100
  HEIGHT 25
  ALIGNMENT Left
 END LABEL
 DEFINE TEXTBOX lanidlang
  PARENT p006win
  ROW 60
  COL 125
  HEIGHT 25
  WIDTH 100
  TOOLTIP l3w_fMsg("ToolTip", "TTI001")
  MAXLENGTH p999_LenField("language", "lanidlang")
  CASECONVERT UPPER
  ONENTER p006_Enter()
 END TEXTBOX
* button bt_src_lanidlang
 DEFINE BUTTON bt_src_lanidlang
  PARENT p006win
  ROW 60
  COL 230
  PICTURE "L3W_ISEARCH"
  ONCLICK p006_Src_lanidlang()
  WIDTH 30
  HEIGHT 30
  TOOLTIP l3w_fMsg("ToolTip", "TTI002")
  FLAT .T.
  TABSTOP .F.
 END BUTTON

* field lanstatus
 DEFINE LABEL lb_lanstatus
  PARENT p006win
  ROW 90
  COL 20
  VALUE 'Status'
  WIDTH 100
  HEIGHT 25
  ALIGNMENT Left
 END LABEL
 DEFINE COMBOBOX cb_lanstatus
  PARENT p006win
  ROW 90
  COL 125
  WIDTH 125
  ITEMS aStatdes
  VALUE 1
 END COMBOBOX

* field landescri
 DEFINE LABEL lb_landescri
  ROW 120
  COL 20
  VALUE l3w_fMsg("Label", "LBL002")
  WIDTH 100
  HEIGHT 25
  ALIGNMENT Left
 END LABEL
 DEFINE TEXTBOX landescri
  ROW 120
  COL 125
  HEIGHT 25
  WIDTH 200
  TOOLTIP l3w_fMsg("ToolTip", "TTI003")
  MAXLENGTH p999_LenField("language","landescri")
  ONENTER p006_landescri()
 END TEXTBOX

END WINDOW
p006win.Center
RETURN NIL

/****************************************************************
* Entry function
* aParm[1] = form name to assign focus when leave this form
* aParm[2] = control name (about prev. form name) to assign focus when leave this form
* aParm[3] = control name (about prev. form name) to assign a value from grid of this form
* aParm[...] = control name (about prev. form name) to assign a value from grid of this form
* aParm[n] = control name (about prev. form name) to assign a value from grid of this form
* cCode = if passed when load grid set Grid.Value else is set to 1
****************************************************************/
FUNCTION p006_Main(aParm, cCode)
LOCAL lReturn := .F.
PUBLIC p006_cProcname := "hconp006"
cCode := IIF(VALTYPE(cCode)=="C", cCode, "")
aParm := IIF(VALTYPE(aParm)=="A", aParm, {})
IF l3w_fGetperms( p006_cProcname, "x" ) .AND. l3w_fFomFree( "p006win", "FormStatus", "N" )
 p006_ShowForm(aParm, cCode)
 lReturn := .T.
ELSE
 p006_NewFocus(aParm)
ENDIF
RETURN lReturn

/****************************************************************
* ShowForm function
* _nRecStatus = -1 No action taken
* _nRecStatus = 0 Record Not Found
* _nRecStatus = 1 Record Found and Locked
* _nRecStatus = 2 Record already deleted
* _nRecStatus = 3 (2+1) Record found and locked but already deleted
****************************************************************/
STATIC FUNCTION p006_ShowForm(aParm, cCode)
PUBLIC p006_nRecStatus := -1, p006_lOnChange := .F.
PUBLIC p006_aParm := aParm
p006win.StatusBar.Item(1) :=  "DataBase : " + l3w_fConf("DataBase", "Description")
p006win.StatusBar.Item(2) :=  "User : " + l3w_fConf("User", "Name")
p006win.Restore
p006win.SetFocus
p006_FormReset()
IF LEN(ALLTRIM(cCode))>0
 p006win.lanidlang.Value := cCode
 p006win.lanidlang.SetFocus
 p006_Enter()
ENDIF
RETURN NIL

/****************************************************************
* Set New Focus
* __MVEXIST, __MVGET, __MVPUT are little trick because p006_aParm is declared PUBLIC inside in p006_ShowForm function
* but p006_NewFocus can be called from p006_Main and p006_aParm it's not declared!
****************************************************************/
STATIC FUNCTION p006_NewFocus(aParm)
LOCAL aNewFocus := IIF(VALTYPE(aParm)=="A", aParm, IIF(__MVEXIST("p006_aParm"), __MVGET("p006_aParm"), {}))
IF LEN(aNewFocus)>=1
 DoMethod(aNewFocus[1], "Restore" )
 IF LEN(aNewFocus)==1
  DoMethod(aNewFocus[1], "SetFocus")
 ELSEIF LEN(aNewFocus)>=2
  DoMethod(aNewFocus[1], aNewFocus[2], "SetFocus")
 ENDIF
ENDIF
IF __MVEXIST("p006_aParm")
 __MVPUT("p006_aParm", {})
ENDIF
RETURN NIL

/****************************************************************
* IntercativeClose function
****************************************************************/
STATIC FUNCTION p006_IntClose()
p006_FormReset()
p006_StatusReset()
p006_NewFocus()
RETURN NIL

/****************************************************************
* Exit function
****************************************************************/
STATIC FUNCTION p006_Exit()
p006_FormReset()
p006_StatusReset()
p006win.Hide
p006_NewFocus()
RETURN NIL

/****************************************************************
* Save function
****************************************************************/
STATIC FUNCTION p006_Save()
IF l3w_fGetperms( p006_cProcname, "w" ) .AND. p006_CheckData()
 IF p006_Update()
  p006_FormReset()
  p006_StatusReset()
 ENDIF
ENDIF
RETURN NIL

/****************************************************************
* Reset function
****************************************************************/
STATIC FUNCTION p006_Reset()
p006_FormReset()
p006_StatusReset()
RETURN NIL

/****************************************************************
* Delete function
****************************************************************/
STATIC FUNCTION p006_Delete()
IF l3w_fGetperms( p006_cProcname, "d" )
 IF p006_nRecStatus==1
  language->(DBDELETE())
  p006_FormReset()
  p006_StatusReset()
 ELSE
  MsgStop(l3w_fMsg("Error", "ERR001"),"p006_delete()")
 ENDIF
ENDIF
RETURN NIL

/****************************************************************
* UnDelete function
****************************************************************/
STATIC FUNCTION p006_Undelete()
IF l3w_fGetperms( p006_cProcname, "d" )
 IF p006_nRecStatus==3
  language->(DBRECALL())
  p006_FormReset()
  p006_StatusReset()
 ELSE
  MsgStop(l3w_fMsg("Error", "ERR002"),"p006_undelete()")
 ENDIF
ENDIF
RETURN NIL

/****************************************************************
* Status Reset function
****************************************************************/
STATIC FUNCTION p006_StatusReset()
IF p006_nRecStatus<>-1
 language->(DBUNLOCK())
ENDIF
p006_nRecStatus := -1
p006win.FormStatus.Value := "N"
RETURN NIL

/****************************************************************
* Form Reset function
****************************************************************/
STATIC FUNCTION p006_FormReset()
p006win.cb_lanstatus.Value := 1
p006win.lanidlang.Value := ""
p006win.landescri.Value := ""

l3w_fSetAllControls("p006win", .F., {"cb_lanstatus","landescri"})
p006win.lanidlang.Enabled := .T.
p006win.bt_src_lanidlang.Enabled := .T.
p006win.lanidlang.SetFocus

p006win.bt_save.Enabled := .F.
p006win.bt_reset.Enabled := .F.
RETURN NIL

/****************************************************************
* Retrieve record function
****************************************************************/
STATIC FUNCTION p006_Getrec()
LOCAL cKey := l3w_fFiller(p006win.lanidlang.Value, p999_LenField("language","lanidlang"))
language->(ORDSETFOCUS(1))
p006_nRecStatus := 0
IF language->(DBSEEK(cKey, .F.))==.T.
 IF l3w_fReclock("language")==.T.
  p006_nRecStatus := 1
  IF language->(DELETED())
   p006_nRecStatus := 3
  ENDIF
  p006_LoadForm()
 ELSE
  MsgStop(l3w_fMsg("Error", "ERR003"), "p006_Getrec()")
 ENDIF
ELSE
 p006_LoadForm()
ENDIF
RETURN NIL

/****************************************************************
* Load form function
****************************************************************/
STATIC FUNCTION p006_LoadForm()
p006win.FormStatus.Value := "I"
IF p006_nRecStatus<>0
 p006win.cb_lanstatus.Value := p999_StatusByCod(language->lanstatus)
 p006win.landescri.Value := language->landescri
ENDIF
l3w_fSetAllControls("p006win", .T., {"cb_lanstatus","landescri"})
p006win.lanidlang.Enabled := .F.
p006win.bt_src_lanidlang.Enabled := .F.
p006win.landescri.SetFocus

p006win.bt_save.Enabled := .T.
p006win.bt_reset.Enabled := .T.
RETURN NIL

/****************************************************************
* Update function
****************************************************************/
STATIC FUNCTION p006_Update()
LOCAL lDone := .T., lRiattiva := .F.
IF p006_nRecStatus==0 .AND. l3w_fAddrec("language")==.F.
 MsgStop(l3w_fMsg("Error", "ERR004"),"p006_update()")
 lDone:=.F.
ENDIF
IF p006_nRecStatus==3
 lRiattiva := MsgYesNo(l3w_fMsg("Message", "MSG001"),"p006_update()")
ENDIF
IF lDone == .T.
 language->adminproc := p006_cProcname
 language->adminuser := l3w_fConf("User", "Login")
 language->admintstp := HB_TTOS(HB_DATETIME())
 language->lanidlang := p006win.lanidlang.Value
 language->lanstatus := p999_StatusByNum(p006win.cb_lanstatus.Value)
 language->landescri := p006win.landescri.Value
 IF p006_nRecStatus==3 .AND. lRiattiva==.T.
  language->(DBRECALL())
 ENDIF
 language->(DBCOMMIT())
ENDIF
RETURN lDone

/****************************************************************
* Enter function
****************************************************************/
STATIC FUNCTION p006_Enter()
IF p006_lanidlang()==.T.
 p006_Getrec()
ENDIF
RETURN NIL

/****************************************************************
* Errors check
****************************************************************/
STATIC FUNCTION p006_CheckData()
LOCAL lItsOk := .T.
lItsOk := IF(lItsOk==.T., p006_lanidlang(), lItsOk)
lItsOk := IF(lItsOk==.T., p006_landescri(), lItsOk)
RETURN lItsOk

/****************************************************************
* error lanidlang
****************************************************************/
STATIC FUNCTION p006_lanidlang()
LOCAL lItsOk := .T.
IF LEN( ALLTRIM( p006win.lanidlang.Value ) )==0
 lItsOk := .F.
 MsgStop(l3w_fMsg("Error", "ERR005"), "p006_lanidlang()")
 p006win.lanidlang.SetFocus
ENDIF
RETURN lItsOk
/****************************************************************
* src1
****************************************************************/
STATIC FUNCTION p006_src_lanidlang()
LOCAL lReturn := p007_Main( {"p006win", "lanidlang", "lanidlang"}, p006win.lanidlang.Value )
RETURN NIL

/****************************************************************
* error landescri
****************************************************************/
STATIC FUNCTION p006_landescri()
LOCAL lItsOk := .T.
IF LEN(ALLTRIM(p006win.landescri.Value)) == 0
  lItsOk := .F.
  MsgStop(l3w_fMsg("Error", "ERR006"),"p006_landescri()")
  p006win.landescri.SetFocus
ENDIF
RETURN lItsOk

/****************************************************************
* useful functions
****************************************************************/
/*
* check if code exists
*/
FUNCTION p006_Isok(cChiave)
LOCAL p006_lastord := language->(ORDSETFOCUS(1))
LOCAL p006_lastrec := language->(RECNO())
LOCAL cKey := l3w_fFiller(cChiave, p999_LenField("language","lanidlang"))
LOCAL lReturn := .F.
IF LEN(ALLTRIM(cKey))>0
 lReturn := language->(DBSEEK(cKey, .F.))
ENDIF
language->(DBGOTO(p006_lastrec))
language->(ORDSETFOCUS(p006_lastord))
RETURN lReturn

/*
* retrieve datas
*/
FUNCTION p006_Getdes(cChiave)
LOCAL nLastord := language->(ORDSETFOCUS(1)), nLastrec := language->(RECNO())
LOCAL cKey := l3w_fFiller(cChiave, p999_LenField("language","lanidlang"))
LOCAL aReturn := {"",""}
IF LEN(ALLTRIM(cKey))>0
 IF language->(DBSEEK(cKey, .F.))
  aReturn[1] := language->lanstatus
  aReturn[2] := language->landescri
 ENDIF
ENDIF
language->(ORDSETFOCUS(nLastord))
language->(DBGOTO(nLastrec))
RETURN aReturn