/****************************************************************
*        selezione language
****************************************************************/
#include "hconp000.ch"

/****************************************************************
* Form definition
****************************************************************/
FUNCTION p007_Define()
LOCAL aGridHead := {l3w_fMsg("Grid", "GRD004"),l3w_fMsg("Grid", "GRD001"),l3w_fMsg("Grid", "GRD002")}
LOCAL aGrid1 := {"TEXTBOX", "CHARACTER"}
LOCAL aGrid2 := {"TEXTBOX", "CHARACTER"}
LOCAL aGrid3 := {"TEXTBOX", "CHARACTER"}

SET NAVIGATION EXTENDED
DEFINE WINDOW p007win ;
 ROW 0 ;
 COL 0 ;
 WIDTH 700 ;
 HEIGHT 525 ;
 TITLE l3w_fMsg("Form", "FRM007")+" (hconp007)" ;
 WINDOWTYPE CHILD ;
 NOAUTORELEASE ;
 NOMAXIMIZE ;
 ON INTERACTIVECLOSE p007_IntClose() ;
 ICON 'L3W_L3WICO' ;
 FONTNAME l3w_fConf("FormFont", "Name") FONTSIZE VAL(l3w_fConf("FormFont", "Size"))

 DEFINE TOOLBAR toolbar1 ;
  BUTTONSIZE 60,30 ;
  FONT l3w_fConf("ButtFont", "Name") ;
  SIZE VAL(l3w_fConf("ButtFont", "Size")) ;
  FLAT ;
  BORDER
  BUTTON bt_exit ;
   CAPTION l3w_fMsg("Command", "CMD001") ;
   PICTURE "L3W_IEXIT" ;
   ACTION p007_Exit() ;
   SEPARATOR
  BUTTON bt_select ;
   CAPTION l3w_fMsg("Command", "CMD010") ;
   PICTURE "L3W_IAPPLY" ;
   ACTION p007_Select() ;
   SEPARATOR
  BUTTON bt_addrec ;
   CAPTION l3w_fMsg("Command", "CMD007") ;
   PICTURE "L3W_IADDREC" ;
   ACTION p007_Addrec() ;
   SEPARATOR
  BUTTON bt_edit ;
   CAPTION l3w_fMsg("Command", "CMD008") ;
   PICTURE "L3W_IEDITREC" ;
   ACTION p007_Editrec() ;
   SEPARATOR
 END TOOLBAR

 DEFINE STATUSBAR
  STATUSITEM "DataBase : " + l3w_fConf("DataBase", "Description") WIDTH 250
  STATUSITEM "User : " + l3w_fConf("User", "Name") WIDTH 250
  CLOCK WIDTH 80
  DATE WIDTH 100
 END STATUSBAR

* Form Status:
* N=Form Free
* I=Form committed
 DEFINE LABEL FormStatus
  PARENT p007win
  ROW 20
  COL 500
  WIDTH 20
  HEIGHT 20
  VALUE "N"
  VISIBLE .F.
 END LABEL

* grid definition
 DEFINE GRID Grid1
  PARENT p007win
  ROW 60
  COL 20
  WIDTH 600
  HEIGHT 330
  HEADERS aGridHead
  WIDTHS {80,100,300}
  ONHEADCLICK { {||p007_ChgOrd(1)}, {||p007_ChgOrd(1)}, {||p007_ChgOrd(2)} }
  COLUMNCONTROLS {aGrid1, aGrid2, aGrid3}
  TOOLTIP l3w_fMsg("ToolTip", "TTI006")
  ONDBLCLICK p007_Select()
 END GRID

* field fldsearch
 DEFINE LABEL lb_fldsearch
  PARENT p007win
  ROW 420
  COL 20
  VALUE l3w_fMsg("Label", "LBL004")
  WIDTH 100
  HEIGHT 25
  ALIGNMENT Left
 END LABEL
 DEFINE TEXTBOX fldsearch
  ROW 420
  COL 125
  HEIGHT 25
  WIDTH 300
  TOOLTIP l3w_fMsg("ToolTip", "TTI005")
  MAXLENGTH p999_LenField("language", "landescri")
  ONENTER p007_LoadForm()
 END TEXTBOX
* button bt_src1
 DEFINE BUTTON bt_src_fldsearch
  ROW 420
  COL 430
  PICTURE "L3W_IFIND"
  ONCLICK p007_LoadForm()
  WIDTH 30
  HEIGHT 30
  TOOLTIP l3w_fMsg("ToolTip", "TTI002")
  FLAT .T.
  TABSTOP .F.
 END BUTTON
END WINDOW
p007win.Center
RETURN NIL

/****************************************************************
* Entry function
* aParm[1] = form name to assign focus when leave this form
* aParm[2] = control name (about prev. form name) to assign focus when leave this form
* aParm[3] = control name (about prev. form name) to assign a value from grid of this form
* aParm[...] = control name (about prev. form name) to assign a value from grid of this form
* aParm[n] = control name (about prev. form name) to assign a value from grid of this form
* cCode = if passed when load grid set Grid.Value else is set to 1
****************************************************************/
FUNCTION p007_Main( aParm, cCode)
LOCAL lReturn := .F.
PUBLIC p007_cProcname := "hconp007"
cCode := IIF(VALTYPE(cCode)=="C", cCode, "")
aParm := IIF(VALTYPE(aParm)=="A", aParm, {})
IF l3w_fGetperms( p007_cProcname, "x" ) .AND. l3w_fFomFree( "p007win", "FormStatus", "N" )
 p007_ShowForm( aParm, cCode)
 lReturn := .T.
ELSE
 p007_NewFocus(aParm)
ENDIF
RETURN lReturn

/****************************************************************
* ShowForm function
****************************************************************/
STATIC FUNCTION p007_ShowForm( aParm, cCode)
PUBLIC p007_nOrder := 2, p007_lFirst := .T.
PUBLIC p007_aParm := aParm, p007_cCode := cCode
p007win.StatusBar.Item(1) :=  "DataBase : " + l3w_fConf("DataBase", "Description")
p007win.StatusBar.Item(2) :=  "User : " + l3w_fConf("User", "Name")
p007win.Restore
p007win.Setfocus
p007_LoadForm()
RETURN NIL

/****************************************************************
* Set New Focus
* __MVEXIST, __MVGET, __MVPUT are little trick because p007_aParm is declared PUBLIC inside in p007_ShowForm function
* but p007_NewFocus can be called from p007_Main and p007_aParm it's not declared!
****************************************************************/
STATIC FUNCTION p007_NewFocus(aParm)
LOCAL aNewFocus := IIF(VALTYPE(aParm)=="A", aParm, IIF(__MVEXIST("p007_aParm"), __MVGET("p007_aParm"), {}))
IF LEN(aNewFocus)>=1
 DoMethod(aNewFocus[1], "Restore" )
 IF LEN(aNewFocus)==1
  DoMethod(aNewFocus[1], "SetFocus")
 ELSEIF LEN(aNewFocus)>=2
  DoMethod(aNewFocus[1], aNewFocus[2], "SetFocus")
 ENDIF
ENDIF
IF __MVEXIST("p007_aParm")
 __MVPUT("p007_aParm", {})
ENDIF
RETURN NIL

/****************************************************************
* IntercativeClose function
****************************************************************/
STATIC FUNCTION p007_IntClose()
p007_StatusReset()
p007_FormReset()
p007_NewFocus()
RETURN NIL

/****************************************************************
* Exit function
****************************************************************/
STATIC FUNCTION p007_Exit()
p007_StatusReset()
p007_FormReset()
p007win.Hide
p007_NewFocus()
RETURN NIL

/****************************************************************
* Reset function
****************************************************************/
STATIC FUNCTION p007_Reset()
p007_FormReset()
RETURN NIL

/****************************************************************
* Select function
****************************************************************/
STATIC FUNCTION p007_Select()
LOCAL aTemp := {}
IF p007win.Grid1.Value<>0
 aTemp := p007win.Grid1.Item( p007win.Grid1.Value )
 IF LEN(p007_aParm)>=3
  SetProperty( p007_aParm[1], p007_aParm[3], "Value", aTemp[2] )
 ENDIF
 IF LEN(p007_aParm)>=4
  SetProperty( p007_aParm[1], p007_aParm[4], "Value", aTemp[3] )
 ENDIF
 p007_StatusReset()
 p007_FormReset()
 p007win.Hide
 p007_NewFocus()
ENDIF
RETURN NIL

/****************************************************************
* Addrec function
****************************************************************/
STATIC FUNCTION p007_Addrec()
IF p006_Main({"p007win", "Grid1"}, "")
 p007_StatusReset()
 p007_FormReset()
 p007win.Hide
ENDIF
RETURN NIL

/****************************************************************
* Editrec function
****************************************************************/
STATIC FUNCTION p007_Editrec()
LOCAL aTemp := {}
IF p007win.Grid1.Value<>0
 aTemp := p007win.Grid1.Item( p007win.Grid1.Value )
 IF p006_Main({"p007win", "Grid1"}, aTemp[1])
  p007_StatusReset()
  p007_FormReset()
  p007win.Hide
 ENDIF
ENDIF
RETURN NIL

/****************************************************************
* Status Reset function
****************************************************************/
STATIC FUNCTION p007_StatusReset()
p007win.FormStatus.Value := "N"
RETURN NIL

/****************************************************************
* Form Reset function
****************************************************************/
STATIC FUNCTION p007_FormReset()
* p007win.Grid1.DeleteAllItems
p007win.fldsearch.Value := ""
RETURN NIL

/****************************************************************
* Change Order
****************************************************************/
STATIC FUNCTION p007_ChgOrd(nOrd)
p007_nOrder := nOrd
p007_LoadForm()
RETURN NIL

/****************************************************************
* Load form function
****************************************************************/
STATIC FUNCTION p007_LoadForm()
LOCAL nGrid := 1, lAddrow := .T.
* commits form video
p007win.FormStatus.Value := "I"
language->(ORDSETFOCUS(p007_nOrder))
language->(DBGOTOP())
p007win.Grid1.DeleteAllItems
DO WHILE !language->(EOF())
 lAddrow := .F.
 IF LEN(ALLTRIM(p007win.fldsearch.Value))==0 .OR. ;
  AT(LOWER(ALLTRIM(p007win.fldsearch.Value)), LOWER(ALLTRIM(language->landescri)))<>0
  lAddrow := .T.
 ENDIF
 IF lAddrow == .T.
*  p007win.Grid1.AddItem( {language->lanstatus, language->lanidlang, language->landescri} )
  p007win.Grid1.AddItem( {p999_StatusByDes(language->lanstatus), language->lanidlang, language->landescri} )
  IF p007_lFirst .AND. LEN(ALLTRIM(p007_cCode))>0 .AND. ALLTRIM(p007_cCode)==ALLTRIM(language->lanidlang)
   nGrid := p007win.Grid1.ItemCount
  ENDIF
 ENDIF
 language->(DBSKIP(+1))
ENDDO
p007_lFirst := .F.
p007win.Grid1.Value := IIF( nGrid>0, nGrid, 1 )
p007win.Grid1.Refresh
p007win.Grid1.Setfocus
RETURN NIL