/****************************************************************
* manager of table typology
****************************************************************/
#include "hconp000.ch"

/****************************************************************
* Form definition
****************************************************************/
FUNCTION p008_Define()
LOCAL aStatdes := p999_aStatus("D")

SET NAVIGATION EXTENDED
DEFINE WINDOW p008win ;
 ROW 0 ;
 COL 0 ;
 WIDTH 940 ;
 HEIGHT 705 ;
 TITLE l3w_fMsg("Form", "FRM008")+" (hconp008)" ;
 WINDOWTYPE CHILD ;
 NOAUTORELEASE ;
 NOMAXIMIZE ;
 ON INTERACTIVECLOSE p008_IntClose() ;
 ICON 'L3W_L3WICO' ;
 FONTNAME l3w_fConf("FormFont", "Name") FONTSIZE VAL(l3w_fConf("FormFont", "Size"))

 DEFINE TOOLBAR toolbar1 ;
  BUTTONSIZE 60,30 ;
  FONT l3w_fConf("ButtFont", "Name") ;
  SIZE VAL(l3w_fConf("ButtFont", "Size")) ;
  FLAT ;
  BORDER
  BUTTON bt_exit ;
   CAPTION l3w_fMsg("Command", "CMD001") ;
   PICTURE "L3W_IEXIT" ;
   ACTION p008_Exit() ;
   SEPARATOR
  BUTTON bt_save ;
   CAPTION l3w_fMsg("Command", "CMD002") ;
   PICTURE "L3W_ISAVE" ;
   ACTION p008_Save() ;
   SEPARATOR
  BUTTON bt_reset ;
   CAPTION l3w_fMsg("Command", "CMD009") ;
   PICTURE "L3W_ICLEAR" ;
   ACTION p008_Reset() ;
   SEPARATOR
 END TOOLBAR

 DEFINE STATUSBAR
  STATUSITEM "DataBase : " + l3w_fConf("DataBase", "Description") WIDTH 250
  STATUSITEM "User : " + l3w_fConf("User", "Name") WIDTH 250
  CLOCK WIDTH 80
  DATE WIDTH 100
 END STATUSBAR

* form status :
* N=Form Free
* I=Form committed
 DEFINE LABEL FormStatus
  PARENT p008win
  ROW 20
  COL 500
  WIDTH 20
  HEIGHT 20
  VALUE "N"
  VISIBLE .F.
 END LABEL

* field typidtypo
 DEFINE LABEL lb_typidtypo
  PARENT p008win
  ROW 60
  COL 20
  VALUE l3w_fMsg("Label", "LBL001")
  WIDTH 100
  HEIGHT 25
  ALIGNMENT Left
 END LABEL
 DEFINE TEXTBOX typidtypo
  PARENT p008win
  ROW 60
  COL 125
  HEIGHT 25
  WIDTH 100
  TOOLTIP l3w_fMsg("ToolTip", "TTI001")
  MAXLENGTH p999_LenField("typology", "typidtypo")
  CASECONVERT UPPER
  ONENTER p008_Enter()
 END TEXTBOX
* button bt_src_typidtypo
 DEFINE BUTTON bt_src_typidtypo
  PARENT p008win
  ROW 60
  COL 230
  PICTURE "L3W_ISEARCH"
  ONCLICK p008_Src_typidtypo()
  WIDTH 30
  HEIGHT 30
  TOOLTIP l3w_fMsg("ToolTip", "TTI002")
  FLAT .T.
  TABSTOP .F.
 END BUTTON

* field typstatus
 DEFINE LABEL lb_typstatus
  PARENT p008win
  ROW 90
  COL 20
  VALUE 'Status'
  WIDTH 100
  HEIGHT 25
  ALIGNMENT Left
 END LABEL
 DEFINE COMBOBOX cb_typstatus
  PARENT p008win
  ROW 90
  COL 125
  WIDTH 125
  ITEMS aStatdes
  VALUE 1
 END COMBOBOX

* field typdescri
 DEFINE LABEL lb_typdescri
  ROW 120
  COL 20
  VALUE l3w_fMsg("Label", "LBL002")
  WIDTH 100
  HEIGHT 25
  ALIGNMENT Left
 END LABEL
 DEFINE TEXTBOX typdescri
  ROW 120
  COL 125
  HEIGHT 25
  WIDTH 200
  TOOLTIP l3w_fMsg("ToolTip", "TTI003")
  MAXLENGTH p999_LenField("typology","typdescri")
  ONENTER p008_typdescri()
 END TEXTBOX

END WINDOW
p008win.Center
RETURN NIL

/****************************************************************
* Entry function
* aParm[1] = form name to assign focus when leave this form
* aParm[2] = control name (about prev. form name) to assign focus when leave this form
* aParm[3] = control name (about prev. form name) to assign a value from grid of this form
* aParm[...] = control name (about prev. form name) to assign a value from grid of this form
* aParm[n] = control name (about prev. form name) to assign a value from grid of this form
* cCode = if passed when load grid set Grid.Value else is set to 1
****************************************************************/
FUNCTION p008_Main(aParm, cCode)
LOCAL lReturn := .F.
PUBLIC p008_cProcname := "hconp008"
cCode := IIF(VALTYPE(cCode)=="C", cCode, "")
aParm := IIF(VALTYPE(aParm)=="A", aParm, {})
IF l3w_fGetperms( p008_cProcname, "x" ) .AND. l3w_fFomFree( "p008win", "FormStatus", "N" )
 p008_ShowForm(aParm, cCode)
 lReturn := .T.
ELSE
 p008_NewFocus(aParm)
ENDIF
RETURN lReturn

/****************************************************************
* ShowForm function
* _nRecStatus = -1 No action taken
* _nRecStatus = 0 Record Not Found
* _nRecStatus = 1 Record Found and Locked
* _nRecStatus = 2 Record already deleted
* _nRecStatus = 3 (2+1) Record found and locked but already deleted
****************************************************************/
STATIC FUNCTION p008_ShowForm(aParm, cCode)
PUBLIC p008_nRecStatus := -1, p008_lOnChange := .F.
PUBLIC p008_aParm := aParm
p008win.StatusBar.Item(1) :=  "DataBase : " + l3w_fConf("DataBase", "Description")
p008win.StatusBar.Item(2) :=  "User : " + l3w_fConf("User", "Name")
p008win.Restore
p008win.SetFocus
p008_FormReset()
IF LEN(ALLTRIM(cCode))>0
 p008win.typidtypo.Value := cCode
 p008win.typidtypo.SetFocus
 p008_Enter()
ENDIF
RETURN NIL

/****************************************************************
* Set New Focus
* __MVEXIST, __MVGET, __MVPUT are little trick because p008_aParm is declared PUBLIC inside in p008_ShowForm function
* but p008_NewFocus can be called from p008_Main and p008_aParm it's not declared!
****************************************************************/
STATIC FUNCTION p008_NewFocus(aParm)
LOCAL aNewFocus := IIF(VALTYPE(aParm)=="A", aParm, IIF(__MVEXIST("p008_aParm"), __MVGET("p008_aParm"), {}))
IF LEN(aNewFocus)>=1
 DoMethod(aNewFocus[1], "Restore" )
 IF LEN(aNewFocus)==1
  DoMethod(aNewFocus[1], "SetFocus")
 ELSEIF LEN(aNewFocus)>=2
  DoMethod(aNewFocus[1], aNewFocus[2], "SetFocus")
 ENDIF
ENDIF
IF __MVEXIST("p008_aParm")
 __MVPUT("p008_aParm", {})
ENDIF
RETURN NIL

/****************************************************************
* IntercativeClose function
****************************************************************/
STATIC FUNCTION p008_IntClose()
p008_FormReset()
p008_StatusReset()
p008_NewFocus()
RETURN NIL

/****************************************************************
* Exit function
****************************************************************/
STATIC FUNCTION p008_Exit()
p008_FormReset()
p008_StatusReset()
p008win.Hide
p008_NewFocus()
RETURN NIL

/****************************************************************
* Save function
****************************************************************/
STATIC FUNCTION p008_Save()
IF l3w_fGetperms( p008_cProcname, "w" ) .AND. p008_CheckData()
 IF p008_Update()
  p008_FormReset()
  p008_StatusReset()
 ENDIF
ENDIF
RETURN NIL

/****************************************************************
* Reset function
****************************************************************/
STATIC FUNCTION p008_Reset()
p008_FormReset()
p008_StatusReset()
RETURN NIL

/****************************************************************
* Delete function
****************************************************************/
STATIC FUNCTION p008_Delete()
IF l3w_fGetperms( p008_cProcname, "d" )
 IF p008_nRecStatus==1
  typology->(DBDELETE())
  p008_FormReset()
  p008_StatusReset()
 ELSE
  MsgStop(l3w_fMsg("Error", "ERR001"),"p008_delete()")
 ENDIF
ENDIF
RETURN NIL

/****************************************************************
* UnDelete function
****************************************************************/
STATIC FUNCTION p008_Undelete()
IF l3w_fGetperms( p008_cProcname, "d" )
 IF p008_nRecStatus==3
  typology->(DBRECALL())
  p008_FormReset()
  p008_StatusReset()
 ELSE
  MsgStop(l3w_fMsg("Error", "ERR002"),"p008_undelete()")
 ENDIF
ENDIF
RETURN NIL

/****************************************************************
* Status Reset function
****************************************************************/
STATIC FUNCTION p008_StatusReset()
IF p008_nRecStatus<>-1
 typology->(DBUNLOCK())
ENDIF
p008_nRecStatus := -1
p008win.FormStatus.Value := "N"
RETURN NIL

/****************************************************************
* Form Reset function
****************************************************************/
STATIC FUNCTION p008_FormReset()
p008win.cb_typstatus.Value := 1
p008win.typidtypo.Value := ""
p008win.typdescri.Value := ""

l3w_fSetAllControls("p008win", .F., {"cb_typstatus","typdescri"})
p008win.typidtypo.Enabled := .T.
p008win.bt_src_typidtypo.Enabled := .T.
p008win.typidtypo.SetFocus

p008win.bt_save.Enabled := .F.
p008win.bt_reset.Enabled := .F.
RETURN NIL

/****************************************************************
* Retrieve record function
****************************************************************/
STATIC FUNCTION p008_Getrec()
LOCAL cKey := l3w_fFiller(p008win.typidtypo.Value, p999_LenField("typology","typidtypo"))
typology->(ORDSETFOCUS(1))
p008_nRecStatus := 0
IF typology->(DBSEEK(cKey, .F.))==.T.
 IF l3w_fReclock("typology")==.T.
  p008_nRecStatus := 1
  IF typology->(DELETED())
   p008_nRecStatus := 3
  ENDIF
  p008_LoadForm()
 ELSE
  MsgStop(l3w_fMsg("Error", "ERR003"), "p008_Getrec()")
 ENDIF
ELSE
 p008_LoadForm()
ENDIF
RETURN NIL

/****************************************************************
* Load form function
****************************************************************/
STATIC FUNCTION p008_LoadForm()
p008win.FormStatus.Value := "I"
IF p008_nRecStatus<>0
 p008win.cb_typstatus.Value := p999_StatusByCod(typology->typstatus)
 p008win.typdescri.Value := typology->typdescri
ENDIF
l3w_fSetAllControls("p008win", .T., {"cb_typstatus","typdescri"})
p008win.typidtypo.Enabled := .F.
p008win.bt_src_typidtypo.Enabled := .F.
p008win.typdescri.SetFocus

p008win.bt_save.Enabled := .T.
p008win.bt_reset.Enabled := .T.
RETURN NIL

/****************************************************************
* Update function
****************************************************************/
STATIC FUNCTION p008_Update()
LOCAL lDone := .T., lRiattiva := .F.
IF p008_nRecStatus==0 .AND. l3w_fAddrec("typology")==.F.
 MsgStop(l3w_fMsg("Error", "ERR004"),"p008_update()")
 lDone:=.F.
ENDIF
IF p008_nRecStatus==3
 lRiattiva := MsgYesNo(l3w_fMsg("Message", "MSG001"),"p008_update()")
ENDIF
IF lDone == .T.
 typology->adminproc := p008_cProcname
 typology->adminuser := l3w_fConf("User", "Login")
 typology->admintstp := HB_TTOS(HB_DATETIME())
 typology->typidtypo := p008win.typidtypo.Value
 typology->typstatus := p999_StatusByNum(p008win.cb_typstatus.Value)
 typology->typdescri := p008win.typdescri.Value
 IF p008_nRecStatus==3 .AND. lRiattiva==.T.
  typology->(DBRECALL())
 ENDIF
 typology->(DBCOMMIT())
ENDIF
RETURN lDone

/****************************************************************
* Enter function
****************************************************************/
STATIC FUNCTION p008_Enter()
IF p008_typidtypo()==.T.
 p008_Getrec()
ENDIF
RETURN NIL

/****************************************************************
* Errors check
****************************************************************/
STATIC FUNCTION p008_CheckData()
LOCAL lItsOk := .T.
lItsOk := IF(lItsOk==.T., p008_typidtypo(), lItsOk)
lItsOk := IF(lItsOk==.T., p008_typdescri(), lItsOk)
RETURN lItsOk

/****************************************************************
* error typidtypo
****************************************************************/
STATIC FUNCTION p008_typidtypo()
LOCAL lItsOk := .T.
IF LEN( ALLTRIM( p008win.typidtypo.Value ) )==0
 lItsOk := .F.
 MsgStop(l3w_fMsg("Error", "ERR005"), "p008_typidtypo()")
 p008win.typidtypo.SetFocus
ENDIF
RETURN lItsOk
/****************************************************************
* src1
****************************************************************/
STATIC FUNCTION p008_src_typidtypo()
LOCAL lReturn := p009_Main( {"p008win", "typidtypo", "typidtypo"}, p008win.typidtypo.Value )
RETURN NIL

/****************************************************************
* error typdescri
****************************************************************/
STATIC FUNCTION p008_typdescri()
LOCAL lItsOk := .T.
IF LEN(ALLTRIM(p008win.typdescri.Value)) == 0
  lItsOk := .F.
  MsgStop(l3w_fMsg("Error", "ERR006"),"p008_typdescri()")
  p008win.typdescri.SetFocus
ENDIF
RETURN lItsOk

/****************************************************************
* useful functions
****************************************************************/
/*
* check if code exists
*/
FUNCTION p008_Isok(cChiave)
LOCAL p008_lastord := typology->(ORDSETFOCUS(1))
LOCAL p008_lastrec := typology->(RECNO())
LOCAL cKey := l3w_fFiller(cChiave, p999_LenField("typology","typidtypo"))
LOCAL lReturn := .F.
IF LEN(ALLTRIM(cKey))>0
 lReturn := typology->(DBSEEK(cKey, .F.))
ENDIF
typology->(DBGOTO(p008_lastrec))
typology->(ORDSETFOCUS(p008_lastord))
RETURN lReturn

/*
* retrieve datas
*/
FUNCTION p008_Getdes(cChiave)
LOCAL nLastord := typology->(ORDSETFOCUS(1)), nLastrec := typology->(RECNO())
LOCAL cKey := l3w_fFiller(cChiave, p999_LenField("typology","typidtypo"))
LOCAL aReturn := {"",""}
IF LEN(ALLTRIM(cKey))>0
 IF typology->(DBSEEK(cKey, .F.))
  aReturn[1] := typology->typstatus
  aReturn[2] := typology->typdescri
 ENDIF
ENDIF
typology->(ORDSETFOCUS(nLastord))
typology->(DBGOTO(nLastrec))
RETURN aReturn