/****************************************************************
*        selezione typology
****************************************************************/
#include "hconp000.ch"

/****************************************************************
* Form definition
****************************************************************/
FUNCTION p009_Define()
LOCAL aGridHead := {l3w_fMsg("Grid", "GRD004"),l3w_fMsg("Grid", "GRD001"),l3w_fMsg("Grid", "GRD002")}
LOCAL aGrid1 := {"TEXTBOX", "CHARACTER"}
LOCAL aGrid2 := {"TEXTBOX", "CHARACTER"}
LOCAL aGrid3 := {"TEXTBOX", "CHARACTER"}

SET NAVIGATION EXTENDED
DEFINE WINDOW p009win ;
 ROW 0 ;
 COL 0 ;
 WIDTH 700 ;
 HEIGHT 525 ;
 TITLE l3w_fMsg("Form", "FRM009")+" (hconp009)" ;
 WINDOWTYPE CHILD ;
 NOAUTORELEASE ;
 NOMAXIMIZE ;
 ON INTERACTIVECLOSE p009_IntClose() ;
 ICON 'L3W_L3WICO' ;
 FONTNAME l3w_fConf("FormFont", "Name") FONTSIZE VAL(l3w_fConf("FormFont", "Size"))

 DEFINE TOOLBAR toolbar1 ;
  BUTTONSIZE 60,30 ;
  FONT l3w_fConf("ButtFont", "Name") ;
  SIZE VAL(l3w_fConf("ButtFont", "Size")) ;
  FLAT ;
  BORDER
  BUTTON bt_exit ;
   CAPTION l3w_fMsg("Command", "CMD001") ;
   PICTURE "L3W_IEXIT" ;
   ACTION p009_Exit() ;
   SEPARATOR
  BUTTON bt_select ;
   CAPTION l3w_fMsg("Command", "CMD010") ;
   PICTURE "L3W_IAPPLY" ;
   ACTION p009_Select() ;
   SEPARATOR
  BUTTON bt_addrec ;
   CAPTION l3w_fMsg("Command", "CMD007") ;
   PICTURE "L3W_IADDREC" ;
   ACTION p009_Addrec() ;
   SEPARATOR
  BUTTON bt_edit ;
   CAPTION l3w_fMsg("Command", "CMD008") ;
   PICTURE "L3W_IEDITREC" ;
   ACTION p009_Editrec() ;
   SEPARATOR
 END TOOLBAR

 DEFINE STATUSBAR
  STATUSITEM "DataBase : " + l3w_fConf("DataBase", "Description") WIDTH 250
  STATUSITEM "User : " + l3w_fConf("User", "Name") WIDTH 250
  CLOCK WIDTH 80
  DATE WIDTH 100
 END STATUSBAR

* Form Status:
* N=Form Free
* I=Form committed
 DEFINE LABEL FormStatus
  PARENT p009win
  ROW 20
  COL 500
  WIDTH 20
  HEIGHT 20
  VALUE "N"
  VISIBLE .F.
 END LABEL

* grid definition
 DEFINE GRID Grid1
  PARENT p009win
  ROW 60
  COL 20
  WIDTH 600
  HEIGHT 330
  HEADERS aGridHead
  WIDTHS {80,100,300}
  ONHEADCLICK { {||p009_ChgOrd(1)}, {||p009_ChgOrd(1)}, {||p009_ChgOrd(2)} }
  COLUMNCONTROLS {aGrid1, aGrid2, aGrid3}
  TOOLTIP l3w_fMsg("ToolTip", "TTI006")
  ONDBLCLICK p009_Select()
 END GRID

* field fldsearch
 DEFINE LABEL lb_fldsearch
  PARENT p009win
  ROW 420
  COL 20
  VALUE l3w_fMsg("Label", "LBL004")
  WIDTH 100
  HEIGHT 25
  ALIGNMENT Left
 END LABEL
 DEFINE TEXTBOX fldsearch
  ROW 420
  COL 125
  HEIGHT 25
  WIDTH 300
  TOOLTIP l3w_fMsg("ToolTip", "TTI005")
  MAXLENGTH p999_LenField("typology", "typdescri")
  ONENTER p009_LoadForm()
 END TEXTBOX
* button bt_src1
 DEFINE BUTTON bt_src_fldsearch
  ROW 420
  COL 430
  PICTURE "L3W_IFIND"
  ONCLICK p009_LoadForm()
  WIDTH 30
  HEIGHT 30
  TOOLTIP l3w_fMsg("ToolTip", "TTI002")
  FLAT .T.
  TABSTOP .F.
 END BUTTON
END WINDOW
p009win.Center
RETURN NIL

/****************************************************************
* Entry function
* aParm[1] = form name to assign focus when leave this form
* aParm[2] = control name (about prev. form name) to assign focus when leave this form
* aParm[3] = control name (about prev. form name) to assign a value from grid of this form
* aParm[...] = control name (about prev. form name) to assign a value from grid of this form
* aParm[n] = control name (about prev. form name) to assign a value from grid of this form
* cCode = if passed when load grid set Grid.Value else is set to 1
****************************************************************/
FUNCTION p009_Main( aParm, cCode)
LOCAL lReturn := .F.
PUBLIC p009_cProcname := "hconp009"
cCode := IIF(VALTYPE(cCode)=="C", cCode, "")
aParm := IIF(VALTYPE(aParm)=="A", aParm, {})
IF l3w_fGetperms( p009_cProcname, "x" ) .AND. l3w_fFomFree( "p009win", "FormStatus", "N" )
 p009_ShowForm( aParm, cCode)
 lReturn := .T.
ELSE
 p009_NewFocus(aParm)
ENDIF
RETURN lReturn

/****************************************************************
* ShowForm function
****************************************************************/
STATIC FUNCTION p009_ShowForm( aParm, cCode)
PUBLIC p009_nOrder := 2, p009_lFirst := .T.
PUBLIC p009_aParm := aParm, p009_cCode := cCode
p009win.StatusBar.Item(1) :=  "DataBase : " + l3w_fConf("DataBase", "Description")
p009win.StatusBar.Item(2) :=  "User : " + l3w_fConf("User", "Name")
p009win.Restore
p009win.Setfocus
p009_LoadForm()
RETURN NIL

/****************************************************************
* Set New Focus
* __MVEXIST, __MVGET, __MVPUT are little trick because p009_aParm is declared PUBLIC inside in p009_ShowForm function
* but p009_NewFocus can be called from p009_Main and p009_aParm it's not declared!
****************************************************************/
STATIC FUNCTION p009_NewFocus(aParm)
LOCAL aNewFocus := IIF(VALTYPE(aParm)=="A", aParm, IIF(__MVEXIST("p009_aParm"), __MVGET("p009_aParm"), {}))
IF LEN(aNewFocus)>=1
 DoMethod(aNewFocus[1], "Restore" )
 IF LEN(aNewFocus)==1
  DoMethod(aNewFocus[1], "SetFocus")
 ELSEIF LEN(aNewFocus)>=2
  DoMethod(aNewFocus[1], aNewFocus[2], "SetFocus")
 ENDIF
ENDIF
IF __MVEXIST("p009_aParm")
 __MVPUT("p009_aParm", {})
ENDIF
RETURN NIL

/****************************************************************
* IntercativeClose function
****************************************************************/
STATIC FUNCTION p009_IntClose()
p009_StatusReset()
p009_FormReset()
p009_NewFocus()
RETURN NIL

/****************************************************************
* Exit function
****************************************************************/
STATIC FUNCTION p009_Exit()
p009_StatusReset()
p009_FormReset()
p009win.Hide
p009_NewFocus()
RETURN NIL

/****************************************************************
* Reset function
****************************************************************/
STATIC FUNCTION p009_Reset()
p009_FormReset()
RETURN NIL

/****************************************************************
* Select function
****************************************************************/
STATIC FUNCTION p009_Select()
LOCAL aTemp := {}
IF p009win.Grid1.Value<>0
 aTemp := p009win.Grid1.Item( p009win.Grid1.Value )
 IF LEN(p009_aParm)>=3
  SetProperty( p009_aParm[1], p009_aParm[3], "Value", aTemp[2] )
 ENDIF
 IF LEN(p009_aParm)>=4
  SetProperty( p009_aParm[1], p009_aParm[4], "Value", aTemp[3] )
 ENDIF
 p009_StatusReset()
 p009_FormReset()
 p009win.Hide
 p009_NewFocus()
ENDIF
RETURN NIL

/****************************************************************
* Addrec function
****************************************************************/
STATIC FUNCTION p009_Addrec()
IF p008_Main({"p009win", "Grid1"}, "")
 p009_StatusReset()
 p009_FormReset()
 p009win.Hide
ENDIF
RETURN NIL

/****************************************************************
* Editrec function
****************************************************************/
STATIC FUNCTION p009_Editrec()
LOCAL aTemp := {}
IF p009win.Grid1.Value<>0
 aTemp := p009win.Grid1.Item( p009win.Grid1.Value )
 IF p008_Main({"p009win", "Grid1"}, aTemp[1])
  p009_StatusReset()
  p009_FormReset()
  p009win.Hide
 ENDIF
ENDIF
RETURN NIL

/****************************************************************
* Status Reset function
****************************************************************/
STATIC FUNCTION p009_StatusReset()
p009win.FormStatus.Value := "N"
RETURN NIL

/****************************************************************
* Form Reset function
****************************************************************/
STATIC FUNCTION p009_FormReset()
* p009win.Grid1.DeleteAllItems
p009win.fldsearch.Value := ""
RETURN NIL

/****************************************************************
* Change Order
****************************************************************/
STATIC FUNCTION p009_ChgOrd(nOrd)
p009_nOrder := nOrd
p009_LoadForm()
RETURN NIL

/****************************************************************
* Load form function
****************************************************************/
STATIC FUNCTION p009_LoadForm()
LOCAL nGrid := 1, lAddrow := .T.
* commits form video
p009win.FormStatus.Value := "I"
typology->(ORDSETFOCUS(p009_nOrder))
typology->(DBGOTOP())
p009win.Grid1.DeleteAllItems
DO WHILE !typology->(EOF())
 lAddrow := .F.
 IF LEN(ALLTRIM(p009win.fldsearch.Value))==0 .OR. ;
  AT(LOWER(ALLTRIM(p009win.fldsearch.Value)), LOWER(ALLTRIM(typology->typdescri)))<>0
  lAddrow := .T.
 ENDIF
 IF lAddrow == .T.
*  p009win.Grid1.AddItem( {typology->typstatus, typology->typidtypo, typology->typdescri} )
  p009win.Grid1.AddItem( {p999_StatusByDes(typology->typstatus), typology->typidtypo, typology->typdescri} )
  IF p009_lFirst .AND. LEN(ALLTRIM(p009_cCode))>0 .AND. ALLTRIM(p009_cCode)==ALLTRIM(typology->typidtypo)
   nGrid := p009win.Grid1.ItemCount
  ENDIF
 ENDIF
 typology->(DBSKIP(+1))
ENDDO
p009_lFirst := .F.
p009win.Grid1.Value := IIF( nGrid>0, nGrid, 1 )
p009win.Grid1.Refresh
p009win.Grid1.Setfocus
RETURN NIL