/****************************************************************
* manager of table maillist
****************************************************************/
#include "hconp000.ch"

/****************************************************************
* Form definition
****************************************************************/
FUNCTION p010_Define()
LOCAL aStatdes := p999_aStatus("D")

SET NAVIGATION EXTENDED
DEFINE WINDOW p010win ;
 ROW 0 ;
 COL 0 ;
 WIDTH 940 ;
 HEIGHT 705 ;
 TITLE l3w_fMsg("Form", "FRM010")+" (hconp010)" ;
 WINDOWTYPE CHILD ;
 NOAUTORELEASE ;
 NOMAXIMIZE ;
 ON INTERACTIVECLOSE p010_IntClose() ;
 ICON 'L3W_L3WICO' ;
 FONTNAME l3w_fConf("FormFont", "Name") FONTSIZE VAL(l3w_fConf("FormFont", "Size"))

 DEFINE TOOLBAR toolbar1 ;
  BUTTONSIZE 60,30 ;
  FONT l3w_fConf("ButtFont", "Name") ;
  SIZE VAL(l3w_fConf("ButtFont", "Size")) ;
  FLAT ;
  BORDER
  BUTTON bt_exit ;
   CAPTION l3w_fMsg("Command", "CMD001") ;
   PICTURE "L3W_IEXIT" ;
   ACTION p010_Exit() ;
   SEPARATOR
  BUTTON bt_save ;
   CAPTION l3w_fMsg("Command", "CMD002") ;
   PICTURE "L3W_ISAVE" ;
   ACTION p010_Save() ;
   SEPARATOR
  BUTTON bt_reset ;
   CAPTION l3w_fMsg("Command", "CMD009") ;
   PICTURE "L3W_ICLEAR" ;
   ACTION p010_Reset() ;
   SEPARATOR
 END TOOLBAR

 DEFINE STATUSBAR
  STATUSITEM "DataBase : " + l3w_fConf("DataBase", "Description") WIDTH 250
  STATUSITEM "User : " + l3w_fConf("User", "Name") WIDTH 250
  CLOCK WIDTH 80
  DATE WIDTH 100
 END STATUSBAR

* form status :
* N=Form Free
* I=Form committed
 DEFINE LABEL FormStatus
  PARENT p010win
  ROW 20
  COL 500
  WIDTH 20
  HEIGHT 20
  VALUE "N"
  VISIBLE .F.
 END LABEL

* field mllidmcod
 DEFINE LABEL lb_mllidmcod
  PARENT p010win
  ROW 60
  COL 20
  VALUE l3w_fMsg("Label", "LBL001")
  WIDTH 100
  HEIGHT 25
  ALIGNMENT Left
 END LABEL
 DEFINE TEXTBOX mllidmcod
  PARENT p010win
  ROW 60
  COL 125
  HEIGHT 25
  WIDTH 100
  TOOLTIP l3w_fMsg("ToolTip", "TTI001")
  MAXLENGTH p999_LenField("maillist", "mllidmcod")
  CASECONVERT UPPER
  ONENTER p010_Enter()
 END TEXTBOX
* button bt_src_mllidmcod
 DEFINE BUTTON bt_src_mllidmcod
  PARENT p010win
  ROW 60
  COL 230
  PICTURE "L3W_ISEARCH"
  ONCLICK p010_Src_mllidmcod()
  WIDTH 30
  HEIGHT 30
  TOOLTIP l3w_fMsg("ToolTip", "TTI002")
  FLAT .T.
  TABSTOP .F.
 END BUTTON

* field mllstatus
 DEFINE LABEL lb_mllstatus
  PARENT p010win
  ROW 90
  COL 20
  VALUE 'Status'
  WIDTH 100
  HEIGHT 25
  ALIGNMENT Left
 END LABEL
 DEFINE COMBOBOX cb_mllstatus
  PARENT p010win
  ROW 90
  COL 125
  WIDTH 125
  ITEMS aStatdes
  VALUE 1
 END COMBOBOX

* field mlldescri
 DEFINE LABEL lb_mlldescri
  ROW 120
  COL 20
  VALUE l3w_fMsg("Label", "LBL002")
  WIDTH 100
  HEIGHT 25
  ALIGNMENT Left
 END LABEL
 DEFINE TEXTBOX mlldescri
  ROW 120
  COL 125
  HEIGHT 25
  WIDTH 200
  TOOLTIP l3w_fMsg("ToolTip", "TTI003")
  MAXLENGTH p999_LenField("maillist","mlldescri")
  ONENTER p010_mlldescri()
 END TEXTBOX

END WINDOW
p010win.Center
RETURN NIL

/****************************************************************
* Entry function
* aParm[1] = form name to assign focus when leave this form
* aParm[2] = control name (about prev. form name) to assign focus when leave this form
* aParm[3] = control name (about prev. form name) to assign a value from grid of this form
* aParm[...] = control name (about prev. form name) to assign a value from grid of this form
* aParm[n] = control name (about prev. form name) to assign a value from grid of this form
* cCode = if passed when load grid set Grid.Value else is set to 1
****************************************************************/
FUNCTION p010_Main(aParm, cCode)
LOCAL lReturn := .F.
PUBLIC p010_cProcname := "hconp010"
cCode := IIF(VALTYPE(cCode)=="C", cCode, "")
aParm := IIF(VALTYPE(aParm)=="A", aParm, {})
IF l3w_fGetperms( p010_cProcname, "x" ) .AND. l3w_fFomFree( "p010win", "FormStatus", "N" )
 p010_ShowForm(aParm, cCode)
 lReturn := .T.
ELSE
 p010_NewFocus(aParm)
ENDIF
RETURN lReturn

/****************************************************************
* ShowForm function
* _nRecStatus = -1 No action taken
* _nRecStatus = 0 Record Not Found
* _nRecStatus = 1 Record Found and Locked
* _nRecStatus = 2 Record already deleted
* _nRecStatus = 3 (2+1) Record found and locked but already deleted
****************************************************************/
STATIC FUNCTION p010_ShowForm(aParm, cCode)
PUBLIC p010_nRecStatus := -1, p010_lOnChange := .F.
PUBLIC p010_aParm := aParm
p010win.StatusBar.Item(1) :=  "DataBase : " + l3w_fConf("DataBase", "Description")
p010win.StatusBar.Item(2) :=  "User : " + l3w_fConf("User", "Name")
p010win.Restore
p010win.SetFocus
p010_FormReset()
IF LEN(ALLTRIM(cCode))>0
 p010win.mllidmcod.Value := cCode
 p010win.mllidmcod.SetFocus
 p010_Enter()
ENDIF
RETURN NIL

/****************************************************************
* Set New Focus
* __MVEXIST, __MVGET, __MVPUT are little trick because p010_aParm is declared PUBLIC inside in p010_ShowForm function
* but p010_NewFocus can be called from p010_Main and p010_aParm it's not declared!
****************************************************************/
STATIC FUNCTION p010_NewFocus(aParm)
LOCAL aNewFocus := IIF(VALTYPE(aParm)=="A", aParm, IIF(__MVEXIST("p010_aParm"), __MVGET("p010_aParm"), {}))
IF LEN(aNewFocus)>=1
 DoMethod(aNewFocus[1], "Restore" )
 IF LEN(aNewFocus)==1
  DoMethod(aNewFocus[1], "SetFocus")
 ELSEIF LEN(aNewFocus)>=2
  DoMethod(aNewFocus[1], aNewFocus[2], "SetFocus")
 ENDIF
ENDIF
IF __MVEXIST("p010_aParm")
 __MVPUT("p010_aParm", {})
ENDIF
RETURN NIL

/****************************************************************
* IntercativeClose function
****************************************************************/
STATIC FUNCTION p010_IntClose()
p010_FormReset()
p010_StatusReset()
p010_NewFocus()
RETURN NIL

/****************************************************************
* Exit function
****************************************************************/
STATIC FUNCTION p010_Exit()
p010_FormReset()
p010_StatusReset()
p010win.Hide
p010_NewFocus()
RETURN NIL

/****************************************************************
* Save function
****************************************************************/
STATIC FUNCTION p010_Save()
IF l3w_fGetperms( p010_cProcname, "w" ) .AND. p010_CheckData()
 IF p010_Update()
  p010_FormReset()
  p010_StatusReset()
 ENDIF
ENDIF
RETURN NIL

/****************************************************************
* Reset function
****************************************************************/
STATIC FUNCTION p010_Reset()
p010_FormReset()
p010_StatusReset()
RETURN NIL

/****************************************************************
* Delete function
****************************************************************/
STATIC FUNCTION p010_Delete()
IF l3w_fGetperms( p010_cProcname, "d" )
 IF p010_nRecStatus==1
  maillist->(DBDELETE())
  p010_FormReset()
  p010_StatusReset()
 ELSE
  MsgStop(l3w_fMsg("Error", "ERR001"),"p010_delete()")
 ENDIF
ENDIF
RETURN NIL

/****************************************************************
* UnDelete function
****************************************************************/
STATIC FUNCTION p010_Undelete()
IF l3w_fGetperms( p010_cProcname, "d" )
 IF p010_nRecStatus==3
  maillist->(DBRECALL())
  p010_FormReset()
  p010_StatusReset()
 ELSE
  MsgStop(l3w_fMsg("Error", "ERR002"),"p010_undelete()")
 ENDIF
ENDIF
RETURN NIL

/****************************************************************
* Status Reset function
****************************************************************/
STATIC FUNCTION p010_StatusReset()
IF p010_nRecStatus<>-1
 maillist->(DBUNLOCK())
ENDIF
p010_nRecStatus := -1
p010win.FormStatus.Value := "N"
RETURN NIL

/****************************************************************
* Form Reset function
****************************************************************/
STATIC FUNCTION p010_FormReset()
p010win.cb_mllstatus.Value := 1
p010win.mllidmcod.Value := ""
p010win.mlldescri.Value := ""

l3w_fSetAllControls("p010win", .F., {"cb_mllstatus","mlldescri"})
p010win.mllidmcod.Enabled := .T.
p010win.bt_src_mllidmcod.Enabled := .T.
p010win.mllidmcod.SetFocus

p010win.bt_save.Enabled := .F.
p010win.bt_reset.Enabled := .F.
RETURN NIL

/****************************************************************
* Retrieve record function
****************************************************************/
STATIC FUNCTION p010_Getrec()
LOCAL cKey := l3w_fFiller(p010win.mllidmcod.Value, p999_LenField("maillist","mllidmcod"))
maillist->(ORDSETFOCUS(1))
p010_nRecStatus := 0
IF maillist->(DBSEEK(cKey, .F.))==.T.
 IF l3w_fReclock("maillist")==.T.
  p010_nRecStatus := 1
  IF maillist->(DELETED())
   p010_nRecStatus := 3
  ENDIF
  p010_LoadForm()
 ELSE
  MsgStop(l3w_fMsg("Error", "ERR003"), "p010_Getrec()")
 ENDIF
ELSE
 p010_LoadForm()
ENDIF
RETURN NIL

/****************************************************************
* Load form function
****************************************************************/
STATIC FUNCTION p010_LoadForm()
p010win.FormStatus.Value := "I"
IF p010_nRecStatus<>0
 p010win.cb_mllstatus.Value := p999_StatusByCod(maillist->mllstatus)
 p010win.mlldescri.Value := maillist->mlldescri
ENDIF
l3w_fSetAllControls("p010win", .T., {"cb_mllstatus","mlldescri"})
p010win.mllidmcod.Enabled := .F.
p010win.bt_src_mllidmcod.Enabled := .F.
p010win.mlldescri.SetFocus

p010win.bt_save.Enabled := .T.
p010win.bt_reset.Enabled := .T.
RETURN NIL

/****************************************************************
* Update function
****************************************************************/
STATIC FUNCTION p010_Update()
LOCAL lDone := .T., lRiattiva := .F.
IF p010_nRecStatus==0 .AND. l3w_fAddrec("maillist")==.F.
 MsgStop(l3w_fMsg("Error", "ERR004"),"p010_update()")
 lDone:=.F.
ENDIF
IF p010_nRecStatus==3
 lRiattiva := MsgYesNo(l3w_fMsg("Message", "MSG001"),"p010_update()")
ENDIF
IF lDone == .T.
 maillist->adminproc := p010_cProcname
 maillist->adminuser := l3w_fConf("User", "Login")
 maillist->admintstp := HB_TTOS(HB_DATETIME())
 maillist->mllidmcod := p010win.mllidmcod.Value
 maillist->mllstatus := p999_StatusByNum(p010win.cb_mllstatus.Value)
 maillist->mlldescri := p010win.mlldescri.Value
 IF p010_nRecStatus==3 .AND. lRiattiva==.T.
  maillist->(DBRECALL())
 ENDIF
 maillist->(DBCOMMIT())
ENDIF
RETURN lDone

/****************************************************************
* Enter function
****************************************************************/
STATIC FUNCTION p010_Enter()
IF p010_mllidmcod()==.T.
 p010_Getrec()
ENDIF
RETURN NIL

/****************************************************************
* Errors check
****************************************************************/
STATIC FUNCTION p010_CheckData()
LOCAL lItsOk := .T.
lItsOk := IF(lItsOk==.T., p010_mllidmcod(), lItsOk)
lItsOk := IF(lItsOk==.T., p010_mlldescri(), lItsOk)
RETURN lItsOk

/****************************************************************
* error mllidmcod
****************************************************************/
STATIC FUNCTION p010_mllidmcod()
LOCAL lItsOk := .T.
IF LEN( ALLTRIM( p010win.mllidmcod.Value ) )==0
 lItsOk := .F.
 MsgStop(l3w_fMsg("Error", "ERR005"), "p010_mllidmcod()")
 p010win.mllidmcod.SetFocus
ENDIF
RETURN lItsOk
/****************************************************************
* src1
****************************************************************/
STATIC FUNCTION p010_src_mllidmcod()
LOCAL lReturn := p011_Main( {"p010win", "mllidmcod", "mllidmcod"}, p010win.mllidmcod.Value )
RETURN NIL

/****************************************************************
* error mlldescri
****************************************************************/
STATIC FUNCTION p010_mlldescri()
LOCAL lItsOk := .T.
IF LEN(ALLTRIM(p010win.mlldescri.Value)) == 0
  lItsOk := .F.
  MsgStop(l3w_fMsg("Error", "ERR006"),"p010_mlldescri()")
  p010win.mlldescri.SetFocus
ENDIF
RETURN lItsOk

/****************************************************************
* useful functions
****************************************************************/
/*
* check if code exists
*/
FUNCTION p010_Isok(cChiave)
LOCAL p010_lastord := maillist->(ORDSETFOCUS(1))
LOCAL p010_lastrec := maillist->(RECNO())
LOCAL cKey := l3w_fFiller(cChiave, p999_LenField("maillist","mllidmcod"))
LOCAL lReturn := .F.
IF LEN(ALLTRIM(cKey))>0
 lReturn := maillist->(DBSEEK(cKey, .F.))
ENDIF
maillist->(DBGOTO(p010_lastrec))
maillist->(ORDSETFOCUS(p010_lastord))
RETURN lReturn

/*
* retrieve datas
*/
FUNCTION p010_Getdes(cChiave)
LOCAL nLastord := maillist->(ORDSETFOCUS(1)), nLastrec := maillist->(RECNO())
LOCAL cKey := l3w_fFiller(cChiave, p999_LenField("maillist","mllidmcod"))
LOCAL aReturn := {"",""}
IF LEN(ALLTRIM(cKey))>0
 IF maillist->(DBSEEK(cKey, .F.))
  aReturn[1] := maillist->mllstatus
  aReturn[2] := maillist->mlldescri
 ENDIF
ENDIF
maillist->(ORDSETFOCUS(nLastord))
maillist->(DBGOTO(nLastrec))
RETURN aReturn