/****************************************************************
*        selezione maillist
****************************************************************/
#include "hconp000.ch"

/****************************************************************
* Form definition
****************************************************************/
FUNCTION p011_Define()
LOCAL aGridHead := {l3w_fMsg("Grid", "GRD004"),l3w_fMsg("Grid", "GRD001"),l3w_fMsg("Grid", "GRD002")}
LOCAL aGrid1 := {"TEXTBOX", "CHARACTER"}
LOCAL aGrid2 := {"TEXTBOX", "CHARACTER"}
LOCAL aGrid3 := {"TEXTBOX", "CHARACTER"}

SET NAVIGATION EXTENDED
DEFINE WINDOW p011win ;
 ROW 0 ;
 COL 0 ;
 WIDTH 700 ;
 HEIGHT 525 ;
 TITLE l3w_fMsg("Form", "FRM011")+" (hconp011)" ;
 WINDOWTYPE CHILD ;
 NOAUTORELEASE ;
 NOMAXIMIZE ;
 ON INTERACTIVECLOSE p011_IntClose() ;
 ICON 'L3W_L3WICO' ;
 FONTNAME l3w_fConf("FormFont", "Name") FONTSIZE VAL(l3w_fConf("FormFont", "Size"))

 DEFINE TOOLBAR toolbar1 ;
  BUTTONSIZE 60,30 ;
  FONT l3w_fConf("ButtFont", "Name") ;
  SIZE VAL(l3w_fConf("ButtFont", "Size")) ;
  FLAT ;
  BORDER
  BUTTON bt_exit ;
   CAPTION l3w_fMsg("Command", "CMD001") ;
   PICTURE "L3W_IEXIT" ;
   ACTION p011_Exit() ;
   SEPARATOR
  BUTTON bt_select ;
   CAPTION l3w_fMsg("Command", "CMD010") ;
   PICTURE "L3W_IAPPLY" ;
   ACTION p011_Select() ;
   SEPARATOR
  BUTTON bt_addrec ;
   CAPTION l3w_fMsg("Command", "CMD007") ;
   PICTURE "L3W_IADDREC" ;
   ACTION p011_Addrec() ;
   SEPARATOR
  BUTTON bt_edit ;
   CAPTION l3w_fMsg("Command", "CMD008") ;
   PICTURE "L3W_IEDITREC" ;
   ACTION p011_Editrec() ;
   SEPARATOR
 END TOOLBAR

 DEFINE STATUSBAR
  STATUSITEM "DataBase : " + l3w_fConf("DataBase", "Description") WIDTH 250
  STATUSITEM "User : " + l3w_fConf("User", "Name") WIDTH 250
  CLOCK WIDTH 80
  DATE WIDTH 100
 END STATUSBAR

* Form Status:
* N=Form Free
* I=Form committed
 DEFINE LABEL FormStatus
  PARENT p011win
  ROW 20
  COL 500
  WIDTH 20
  HEIGHT 20
  VALUE "N"
  VISIBLE .F.
 END LABEL

* grid definition
 DEFINE GRID Grid1
  PARENT p011win
  ROW 60
  COL 20
  WIDTH 600
  HEIGHT 330
  HEADERS aGridHead
  WIDTHS {80,100,300}
  ONHEADCLICK { {||p011_ChgOrd(1)}, {||p011_ChgOrd(1)}, {||p011_ChgOrd(2)} }
  COLUMNCONTROLS {aGrid1, aGrid2, aGrid3}
  TOOLTIP l3w_fMsg("ToolTip", "TTI006")
  ONDBLCLICK p011_Select()
 END GRID

* field fldsearch
 DEFINE LABEL lb_fldsearch
  PARENT p011win
  ROW 420
  COL 20
  VALUE l3w_fMsg("Label", "LBL004")
  WIDTH 100
  HEIGHT 25
  ALIGNMENT Left
 END LABEL
 DEFINE TEXTBOX fldsearch
  ROW 420
  COL 125
  HEIGHT 25
  WIDTH 300
  TOOLTIP l3w_fMsg("ToolTip", "TTI005")
  MAXLENGTH p999_LenField("maillist", "mlldescri")
  ONENTER p011_LoadForm()
 END TEXTBOX
* button bt_src1
 DEFINE BUTTON bt_src_fldsearch
  ROW 420
  COL 430
  PICTURE "L3W_IFIND"
  ONCLICK p011_LoadForm()
  WIDTH 30
  HEIGHT 30
  TOOLTIP l3w_fMsg("ToolTip", "TTI002")
  FLAT .T.
  TABSTOP .F.
 END BUTTON
END WINDOW
p011win.Center
RETURN NIL

/****************************************************************
* Entry function
* aParm[1] = form name to assign focus when leave this form
* aParm[2] = control name (about prev. form name) to assign focus when leave this form
* aParm[3] = control name (about prev. form name) to assign a value from grid of this form
* aParm[...] = control name (about prev. form name) to assign a value from grid of this form
* aParm[n] = control name (about prev. form name) to assign a value from grid of this form
* cCode = if passed when load grid set Grid.Value else is set to 1
****************************************************************/
FUNCTION p011_Main( aParm, cCode)
LOCAL lReturn := .F.
PUBLIC p011_cProcname := "hconp011"
cCode := IIF(VALTYPE(cCode)=="C", cCode, "")
aParm := IIF(VALTYPE(aParm)=="A", aParm, {})
IF l3w_fGetperms( p011_cProcname, "x" ) .AND. l3w_fFomFree( "p011win", "FormStatus", "N" )
 p011_ShowForm( aParm, cCode)
 lReturn := .T.
ELSE
 p011_NewFocus(aParm)
ENDIF
RETURN lReturn

/****************************************************************
* ShowForm function
****************************************************************/
STATIC FUNCTION p011_ShowForm( aParm, cCode)
PUBLIC p011_nOrder := 2, p011_lFirst := .T.
PUBLIC p011_aParm := aParm, p011_cCode := cCode
p011win.StatusBar.Item(1) :=  "DataBase : " + l3w_fConf("DataBase", "Description")
p011win.StatusBar.Item(2) :=  "User : " + l3w_fConf("User", "Name")
p011win.Restore
p011win.Setfocus
p011_LoadForm()
RETURN NIL

/****************************************************************
* Set New Focus
* __MVEXIST, __MVGET, __MVPUT are little trick because p011_aParm is declared PUBLIC inside in p011_ShowForm function
* but p011_NewFocus can be called from p011_Main and p011_aParm it's not declared!
****************************************************************/
STATIC FUNCTION p011_NewFocus(aParm)
LOCAL aNewFocus := IIF(VALTYPE(aParm)=="A", aParm, IIF(__MVEXIST("p011_aParm"), __MVGET("p011_aParm"), {}))
IF LEN(aNewFocus)>=1
 DoMethod(aNewFocus[1], "Restore" )
 IF LEN(aNewFocus)==1
  DoMethod(aNewFocus[1], "SetFocus")
 ELSEIF LEN(aNewFocus)>=2
  DoMethod(aNewFocus[1], aNewFocus[2], "SetFocus")
 ENDIF
ENDIF
IF __MVEXIST("p011_aParm")
 __MVPUT("p011_aParm", {})
ENDIF
RETURN NIL

/****************************************************************
* IntercativeClose function
****************************************************************/
STATIC FUNCTION p011_IntClose()
p011_StatusReset()
p011_FormReset()
p011_NewFocus()
RETURN NIL

/****************************************************************
* Exit function
****************************************************************/
STATIC FUNCTION p011_Exit()
p011_StatusReset()
p011_FormReset()
p011win.Hide
p011_NewFocus()
RETURN NIL

/****************************************************************
* Reset function
****************************************************************/
STATIC FUNCTION p011_Reset()
p011_FormReset()
RETURN NIL

/****************************************************************
* Select function
****************************************************************/
STATIC FUNCTION p011_Select()
LOCAL aTemp := {}
IF p011win.Grid1.Value<>0
 aTemp := p011win.Grid1.Item( p011win.Grid1.Value )
 IF LEN(p011_aParm)>=3
  SetProperty( p011_aParm[1], p011_aParm[3], "Value", aTemp[2] )
 ENDIF
 IF LEN(p011_aParm)>=4
  SetProperty( p011_aParm[1], p011_aParm[4], "Value", aTemp[3] )
 ENDIF
 p011_StatusReset()
 p011_FormReset()
 p011win.Hide
 p011_NewFocus()
ENDIF
RETURN NIL

/****************************************************************
* Addrec function
****************************************************************/
STATIC FUNCTION p011_Addrec()
IF p010_Main({"p011win", "Grid1"}, "")
 p011_StatusReset()
 p011_FormReset()
 p011win.Hide
ENDIF
RETURN NIL

/****************************************************************
* Editrec function
****************************************************************/
STATIC FUNCTION p011_Editrec()
LOCAL aTemp := {}
IF p011win.Grid1.Value<>0
 aTemp := p011win.Grid1.Item( p011win.Grid1.Value )
 IF p010_Main({"p011win", "Grid1"}, aTemp[1])
  p011_StatusReset()
  p011_FormReset()
  p011win.Hide
 ENDIF
ENDIF
RETURN NIL

/****************************************************************
* Status Reset function
****************************************************************/
STATIC FUNCTION p011_StatusReset()
p011win.FormStatus.Value := "N"
RETURN NIL

/****************************************************************
* Form Reset function
****************************************************************/
STATIC FUNCTION p011_FormReset()
* p011win.Grid1.DeleteAllItems
p011win.fldsearch.Value := ""
RETURN NIL

/****************************************************************
* Change Order
****************************************************************/
STATIC FUNCTION p011_ChgOrd(nOrd)
p011_nOrder := nOrd
p011_LoadForm()
RETURN NIL

/****************************************************************
* Load form function
****************************************************************/
STATIC FUNCTION p011_LoadForm()
LOCAL nGrid := 1, lAddrow := .T.
* commits form video
p011win.FormStatus.Value := "I"
maillist->(ORDSETFOCUS(p011_nOrder))
maillist->(DBGOTOP())
p011win.Grid1.DeleteAllItems
DO WHILE !maillist->(EOF())
 lAddrow := .F.
 IF LEN(ALLTRIM(p011win.fldsearch.Value))==0 .OR. ;
  AT(LOWER(ALLTRIM(p011win.fldsearch.Value)), LOWER(ALLTRIM(maillist->mlldescri)))<>0
  lAddrow := .T.
 ENDIF
 IF lAddrow == .T.
*  p011win.Grid1.AddItem( {maillist->mllstatus, maillist->mllidmcod, maillist->mlldescri} )
  p011win.Grid1.AddItem( {p999_StatusByDes(maillist->mllstatus), maillist->mllidmcod, maillist->mlldescri} )
  IF p011_lFirst .AND. LEN(ALLTRIM(p011_cCode))>0 .AND. ALLTRIM(p011_cCode)==ALLTRIM(maillist->mllidmcod)
   nGrid := p011win.Grid1.ItemCount
  ENDIF
 ENDIF
 maillist->(DBSKIP(+1))
ENDDO
p011_lFirst := .F.
p011win.Grid1.Value := IIF( nGrid>0, nGrid, 1 )
p011win.Grid1.Refresh
p011win.Grid1.Setfocus
RETURN NIL