/****************************************************************
*        selezione contacts
****************************************************************/
#include "hconp000.ch"

/****************************************************************
* Form definition
****************************************************************/
FUNCTION p100_Define()
LOCAL aGrid1 := {"TEXTBOX", "CHARACTER"}
LOCAL aGrid2 := {"TEXTBOX", "CHARACTER"}
LOCAL aGrid3 := {"TEXTBOX", "CHARACTER"}
LOCAL aGrid4 := {"TEXTBOX", "CHARACTER"}

SET NAVIGATION EXTENDED
DEFINE WINDOW p100win ;
 ROW 0 ;
 COL 0 ;
 WIDTH 940 ;
 HEIGHT 705 ;
 TITLE l3w_fMsg("Form", "FRM100")+" (hconp100)" ;
 WINDOWTYPE CHILD ;
 NOAUTORELEASE ;
 NOMAXIMIZE ;
 ON INTERACTIVECLOSE p100_IntClose() ;
 ICON 'L3W_L3WICO' ;
 FONTNAME l3w_fConf("FormFont", "Name") FONTSIZE VAL(l3w_fConf("FormFont", "Size"))

 DEFINE TOOLBAR toolbar1 ;
  BUTTONSIZE 60,30 ;
  FONT l3w_fConf("ButtFont", "Name") ;
  SIZE VAL(l3w_fConf("ButtFont", "Size")) ;
  FLAT ;
  BORDER
  BUTTON bt_exit ;
   CAPTION l3w_fMsg("Command", "CMD001") ;
   PICTURE "L3W_IEXIT" ;
   ACTION p100_Exit() ;
   SEPARATOR
  BUTTON bt_find ;
   CAPTION l3w_fMsg("Command", "CMD005") ;
   PICTURE "L3W_IFIND" ;
   ACTION p100_LoadForm() ;
   SEPARATOR
  BUTTON bt_addrec ;
   CAPTION l3w_fMsg("Command", "CMD007") ;
   PICTURE "L3W_IADDREC" ;
   ACTION p100_Addrec() ;
   SEPARATOR
  BUTTON bt_edit ;
   CAPTION l3w_fMsg("Command", "CMD008") ;
   PICTURE "L3W_IEDITREC" ;
   ACTION p100_Editrec() ;
   SEPARATOR
  BUTTON bt_reset ;
   CAPTION l3w_fMsg("Command", "CMD009") ;
   PICTURE "L3W_ICLEAR" ;
   ACTION p100_Reset() ;
   SEPARATOR
 END TOOLBAR

 DEFINE STATUSBAR
  STATUSITEM "DataBase : " + l3w_fConf("DataBase", "Description") WIDTH 250
  STATUSITEM "User : " + l3w_fConf("User", "Name") WIDTH 250
  CLOCK WIDTH 80
  DATE WIDTH 100
 END STATUSBAR

* Form Status:
* N=Form Free
* I=Form committed
 DEFINE LABEL FormStatus
  PARENT p100win
  ROW 20
  COL 500
  WIDTH 20
  HEIGHT 20
  VALUE "N"
  VISIBLE .F.
 END LABEL

* tab pages definition
 DEFINE TAB tab01 ;
  PARENT p100win ;
  AT 90,5 ;
  WIDTH 900 ;
  HEIGHT 550 ;
  VALUE 1 ;
  ON CHANGE p100_ChgPage()

* list page
  PAGE l3w_fMsg("Page", "PAG001")
* grid definition
   DEFINE GRID gridfiltro
    PARENT p100win
    ROW 60
    COL 20
    WIDTH 800
    HEIGHT 400
    HEADERS {'Status','Code','Last Name','First Name'}
    WIDTHS {60,80,200,200}
    ONDBLCLICK p100_Editrec()
    ONHEADCLICK { {||p100_ChgOrd(1)}, {||p100_ChgOrd(1)}, {||p100_ChgOrd(2)}, {||p100_ChgOrd(3)} }
    COLUMNCONTROLS {aGrid1, aGrid2, aGrid3, aGrid4}
    TOOLTIP l3w_fMsg("ToolTip", "TTI006")
   END GRID
  END PAGE

* filter page
  PAGE l3w_fMsg("Page", "PAG002")
* fltrname
   DEFINE LABEL lb_fltrname
    PARENT p100win
    ROW 60
    COL 20
    VALUE l3w_fMsg("Label", "LBL020")
    WIDTH 100
    HEIGHT 25
    ALIGNMENT Left
   END LABEL
   DEFINE TEXTBOX fltrname
    PARENT p100win
    ROW 60
    COL 125
    HEIGHT 25
    WIDTH 300
    TOOLTIP l3w_fMsg("ToolTip", "TTI005")
    MAXLENGTH p999_LenField("contacts","conlaname")
   END TEXTBOX

* fltremai
   DEFINE LABEL lb_fltremai
    PARENT p100win
    ROW 90
    COL 20
    VALUE l3w_fMsg("Label", "LBL021")
    WIDTH 100
    HEIGHT 25
    ALIGNMENT Left
   END LABEL
   DEFINE TEXTBOX fltremai
    PARENT p100win
    ROW 90
    COL 125
    HEIGHT 25
    WIDTH 300
    TOOLTIP l3w_fMsg("ToolTip", "TTI005")
    MAXLENGTH p999_LenField("mailaddr","emladdres")
   END TEXTBOX

* fltrpost
   DEFINE LABEL lb_fltrpost
    PARENT p100win
    ROW 120
    COL 20
    VALUE l3w_fMsg("Label", "LBL022")
    WIDTH 100
    HEIGHT 25
    ALIGNMENT Left
   END LABEL
   DEFINE TEXTBOX fltrpost
    PARENT p100win
    ROW 120
    COL 125
    HEIGHT 25
    WIDTH 300
    TOOLTIP l3w_fMsg("ToolTip", "TTI005")
    MAXLENGTH p999_LenField("postaddr","posaddrl1")
   END TEXTBOX

  END PAGE
 END TAB

END WINDOW
p100win.Center
RETURN NIL

/****************************************************************
* aParm[1] = form name to assign focus when leave this form
* aParm[2] = control name (about prev. form name) to assign focus when leave this form
* aParm[3] = control name (about prev. form name) to assign a value from grid of this form
* aParm[...] = control name (about prev. form name) to assign a value from grid of this form
* aParm[n] = control name (about prev. form name) to assign a value from grid of this form
****************************************************************/
FUNCTION p100_Main(aParm)
LOCAL lReturn := .F.
PUBLIC p100_cProcname := "hconp100"
aParm := IIF(VALTYPE(aParm)=="A", aParm, {})
IF l3w_fGetperms( p100_cProcname, "x" ) .AND. l3w_fFomFree( "p100win", "FormStatus", "N" )
 p100_ShowForm(aParm)
 lReturn := .T.
ELSE
 p100_NewFocus(aParm)
ENDIF
RETURN lReturn

/****************************************************************
* ShowForm function
****************************************************************/
STATIC FUNCTION p100_ShowForm(aParm)
PUBLIC p100_nOrder := 2
PUBLIC p100_aParm := aParm
p100win.StatusBar.Item(1) :=  "DataBase : " + l3w_fConf("DataBase", "Description")
p100win.StatusBar.Item(2) :=  "User : " + l3w_fConf("User", "Name")
p100win.Restore
p100win.SetFocus
p100_FormReset()
RETURN NIL

/****************************************************************
* Set New Focus
* __MVEXIST, __MVGET, __MVPUT are little trick because p100_aParm is declared PUBLIC inside in p100_ShowForm function
* but p100_NewFocus can be called from p100_Main and p100_aParm it's not declared!
****************************************************************/
STATIC FUNCTION p100_NewFocus(aParm)
LOCAL aNewFocus := IIF(VALTYPE(aParm)=="A", aParm, IIF(__MVEXIST("p100_aParm"), __MVGET("p100_aParm"), {}))
IF LEN(aNewFocus)>=1
 DoMethod(aNewFocus[1], "Restore" )
 IF LEN(aNewFocus)==1
  DoMethod(aNewFocus[1], "SetFocus")
 ELSEIF LEN(aNewFocus)>=2
  DoMethod(aNewFocus[1], aNewFocus[2], "SetFocus")
 ENDIF
ENDIF
IF __MVEXIST("p100_aParm")
 __MVPUT("p100_aParm", {})
ENDIF
RETURN NIL

/****************************************************************
* IntercativeClose function
****************************************************************/
STATIC FUNCTION p100_IntClose()
p100_FormReset()
p100_StatusReset()
p100_NewFocus()
RETURN NIL

/****************************************************************
* Exit function
****************************************************************/
STATIC FUNCTION p100_Exit()
p100_FormReset()
p100_StatusReset()
p100win.Hide
p100_NewFocus()
RETURN NIL

/****************************************************************
* Reset function
****************************************************************/
STATIC FUNCTION p100_Reset()
p100_StatusReset()
p100_FormReset()
RETURN NIL

/****************************************************************
* Addrec function
****************************************************************/
STATIC FUNCTION p100_Addrec()
LOCAL lReturn := p102_Main({"p100win","gridfiltro","gridfiltro"}, 0)
RETURN NIL

/****************************************************************
* Editrec function
****************************************************************/
STATIC FUNCTION p100_Editrec()
LOCAL lReturn := .F.
IF p100win.gridfiltro.Value!=0
 lReturn := p102_Main({"p100win","gridfiltro","gridfiltro"}, p100win.gridfiltro.Value)
ENDIF
RETURN NIL

/****************************************************************
* Status Reset function
****************************************************************/
STATIC FUNCTION p100_StatusReset()
p100win.FormStatus.Value := "N"
RETURN NIL

/****************************************************************
* Form Reset function
****************************************************************/
STATIC FUNCTION p100_FormReset()
p100win.tab01.Value := 1
p100win.fltrname.Value := ""
p100win.fltremai.Value := ""
p100win.fltrpost.Value := ""
p100win.gridfiltro.DeleteAllItems
p100win.gridfiltro.SetFocus
RETURN NIL

/****************************************************************
* Change order function
****************************************************************/
STATIC FUNCTION p100_ChgOrd( nOrd )
p100_nOrder := nOrd
p100_LoadForm()
RETURN NIL

/****************************************************************
* Change page function
****************************************************************/
STATIC FUNCTION p100_ChgPage()
IF p100win.tab01.Value==1
 p100win.gridfiltro.SetFocus
ELSE
 p100win.fltrname.SetFocus
ENDIF
RETURN NIL

/****************************************************************
* Load form function
****************************************************************/
STATIC FUNCTION p100_LoadForm()
* commits form video
p100win.FormStatus.Value := "I"

contacts->(ORDSETFOCUS(p100_nOrder))
contacts->(DBGOTOP())
mailaddr->(ORDSETFOCUS(1))
mailaddr->(DBGOTOP())
postaddr->(ORDSETFOCUS(1))
postaddr->(DBGOTOP())
teleaddr->(ORDSETFOCUS(1))
teleaddr->(DBGOTOP())

p100win.gridfiltro.DeleteAllItems
DO WHILE !contacts->(EOF())
 IF p100_SetFilter()
  p100win.gridfiltro.AddItem( {p999_StatusByDes(contacts->constatus),contacts->conidcont,contacts->conlaname,contacts->confiname} )
 ENDIF
 contacts->(DBSKIP(+1))
ENDDO
p100win.gridfiltro.Value := 1
p100win.gridfiltro.Refresh
p100win.gridfiltro.SetFocus
p100win.tab01.Value := 1
RETURN NIL

/****************************************************************
* Apply filter
****************************************************************/
STATIC FUNCTION p100_SetFilter()
LOCAL lAddContact := .F.
* special case: not filters yet
IF LEN(ALLTRIM(p100win.fltrname.Value)) == 0 .AND. ;
   LEN(ALLTRIM(p100win.fltremai.Value)) == 0 .AND. ;
   LEN(ALLTRIM(p100win.fltrpost.Value)) == 0
 lAddContact := .T.
ELSEIF p100_FltrName() .OR. p100_FltrEmail() .OR. p100_FltrPost()
 lAddContact := .T.
ENDIF
RETURN lAddContact

/****************************************************************
* Apply filter to contacts fields
****************************************************************/
STATIC FUNCTION p100_FltrName()
LOCAL lFound := .F.
LOCAL cFilter := LOWER(ALLTRIM(p100win.fltrname.Value))
IF LEN(cFilter) <> 0
 IF AT(cFilter, LOWER(ALLTRIM(contacts->confiname))) <> 0 .OR. ;
    AT(cFilter, LOWER(ALLTRIM(contacts->conlaname))) <> 0 .OR. ;
    AT(cFilter, LOWER(ALLTRIM(contacts->connkname))) <> 0
  lFound := .T.
 ENDIF
ENDIF
RETURN lFound

/****************************************************************
* Apply filter to mailaddr fields
****************************************************************/
STATIC FUNCTION p100_FltrEmail()
LOCAL lFound := .F.
LOCAL cFilter := LOWER(ALLTRIM(p100win.fltremai.Value))
mailaddr->(DBSEEK(contacts->conidcont, .T.))
DO WHILE !mailaddr->(EOF()) .AND. mailaddr->emlidcont == contacts->conidcont
 IF LEN(cFilter) <> 0
  IF AT(cFilter, LOWER(ALLTRIM(mailaddr->emladdres))) <> 0
   lFound := .T.
  ENDIF
 ENDIF
 mailaddr->(DBSKIP(+1))
ENDDO
RETURN lFound

/****************************************************************
* Apply filter to postaddr fields
****************************************************************/
STATIC FUNCTION p100_FltrPost()
LOCAL lFound := .F.
LOCAL cFilter := LOWER(ALLTRIM(p100win.fltrpost.Value))
postaddr->(DBSEEK(contacts->conidcont, .T.))
DO WHILE !postaddr->(EOF()) .AND. postaddr->posidcont == contacts->conidcont
 IF LEN(cFilter) <> 0
  IF AT(cFilter, LOWER(ALLTRIM(postaddr->posaddrl1))) <> 0 .OR. ;
     AT(cFilter, LOWER(ALLTRIM(postaddr->posaddrl2))) <> 0 .OR. ;
     AT(cFilter, LOWER(ALLTRIM(postaddr->posaddrl3))) <> 0 .OR. ;
     AT(cFilter, LOWER(ALLTRIM(postaddr->posaddrl4))) <> 0 .OR. ;
     AT(cFilter, LOWER(ALLTRIM(postaddr->posaddrl5)))
   lFound := .T.
  ENDIF
 ENDIF
 postaddr->(DBSKIP(+1))
ENDDO
RETURN lFound
