/****************************************************************
* manager of table mailaddr
****************************************************************/
#include "hconp000.ch"

/****************************************************************
* Form definition
****************************************************************/
FUNCTION p103_Define()
LOCAL aStatdes := p999_aStatus("D")
LOCAL aGrdMail1 := {"TEXTBOX", "NUMERIC", "99999999", "99999999"}
LOCAL aGrdMail2 := {"TEXTBOX", "CHARACTER"}
LOCAL aGrdMail3 := {"TEXTBOX", "CHARACTER"}
LOCAL aGrdMail4 := {"TEXTBOX", "CHARACTER"}

SET NAVIGATION EXTENDED
DEFINE WINDOW p103win ;
 ROW 0 ;
 COL 0 ;
 WIDTH 700 ;
 HEIGHT 525 ;
 TITLE l3w_fMsg("Form", "FRM103")+" (hconp103)" ;
 WINDOWTYPE CHILD ;
 NOAUTORELEASE ;
 NOMAXIMIZE ;
 ON INTERACTIVECLOSE p103_IntClose() ;
 ICON 'L3W_L3WICO' ;
 FONTNAME l3w_fConf("FormFont", "Name") FONTSIZE VAL(l3w_fConf("FormFont", "Size"))

 DEFINE TOOLBAR toolbar1 ;
  BUTTONSIZE 60,30 ;
  FONT l3w_fConf("ButtFont", "Name") ;
  SIZE VAL(l3w_fConf("ButtFont", "Size")) ;
  FLAT ;
  BORDER
  BUTTON bt_exit ;
   CAPTION l3w_fMsg("Command", "CMD001") ;
   PICTURE "L3W_IEXIT" ;
   ACTION p103_Exit() ;
   SEPARATOR
  BUTTON bt_save ;
   CAPTION l3w_fMsg("Command", "CMD011") ;
   PICTURE "L3W_IOK" ;
   ACTION p103_Save() ;
   SEPARATOR
 END TOOLBAR

 DEFINE STATUSBAR
  STATUSITEM "DataBase : " + l3w_fConf("DataBase", "Description") WIDTH 250
  STATUSITEM "User : " + l3w_fConf("User", "Name") WIDTH 250
  CLOCK WIDTH 80
  DATE WIDTH 100
 END STATUSBAR

* form status :
* N=Form Free
* I=Form committed
 DEFINE LABEL FormStatus
  PARENT p103win
  ROW 20
  COL 500
  WIDTH 20
  HEIGHT 20
  VALUE "N"
  VISIBLE .F.
 END LABEL

* field emlstatus
 DEFINE LABEL lb_emlstatus
  PARENT p103win
  ROW 60
  COL 20
  VALUE l3w_fMsg("Label", "LBL006")
  WIDTH 100
  HEIGHT 25
  ALIGNMENT Left
 END LABEL
 DEFINE COMBOBOX cb_emlstatus
  PARENT p103win
  ROW 60
  COL 125
  WIDTH 125
  ITEMS aStatdes
  VALUE 1
 END COMBOBOX

* field emltypolo
 DEFINE LABEL lb_emltypolo
  PARENT p103win
  ROW 90
  COL 20
  VALUE l3w_fMsg("Label", "LBL013")
  WIDTH 100
  HEIGHT 25
  ALIGNMENT Left
 END LABEL
 DEFINE TEXTBOX emltypolo
  PARENT p103win
  ROW 90
  COL 125
  HEIGHT 25
  WIDTH 100
  TOOLTIP l3w_fMsg("ToolTip", "TTI013")
  MAXLENGTH p999_LenField("mailaddr","emltypolo")
  CASECONVERT UPPER
  ONENTER p103_emltypolo()
 END TEXTBOX
* button bt_src_emltypolo
 DEFINE BUTTON bt_src_emltypolo
  PARENT p103win
  ROW 90
  COL 230
  PICTURE "L3W_ISEARCH"
  ONCLICK p103_src_emltypolo()
  WIDTH 30
  HEIGHT 30
  TOOLTIP l3w_fMsg("ToolTip", "TTI002")
  FLAT .T.
  TABSTOP .F.
 END BUTTON
 DEFINE TEXTBOX typdescri
  PARENT p103win
  ROW 90
  COL 265
  HEIGHT 25
  WIDTH 300
  MAXLENGTH p999_LenField("typology","typdescri")
  READONLY .T.
  TABSTOP .F.
  DISABLEDBACKCOLOR L3W_DISABLEDBACKCOLOR
 END TEXTBOX

* field emldescri
 DEFINE LABEL lb_emldescri
  PARENT p103win
  ROW 120
  COL 20
  VALUE l3w_fMsg("Label", "LBL002")
  WIDTH 100
  HEIGHT 25
  ALIGNMENT Left
  END LABEL
 DEFINE TEXTBOX emldescri
  PARENT p103win
  ROW 120
  COL 125
  WIDTH 400
  HEIGHT 25
  MAXLENGTH p999_LenField("mailaddr","emldescri")
  ONENTER p103_emldescri()
  TOOLTIP l3w_fMsg("ToolTip", "TTI003")
 END TEXTBOX

* field emladdres
 DEFINE LABEL lb_emladdres
  PARENT p103win
  ROW 150
  COL 20
  VALUE l3w_fMsg("Label", "LBL014")
  WIDTH 100
  HEIGHT 25
  ALIGNMENT Left
  END LABEL
 DEFINE TEXTBOX emladdres
  PARENT p103win
  ROW 150
  COL 125
  WIDTH 400
  HEIGHT 25
  MAXLENGTH p999_LenField("mailaddr","emladdres")
  ONENTER p103_emladdres()
  TOOLTIP l3w_fMsg("ToolTip", "TTI014")
  DISABLEDBACKCOLOR L3W_DISABLEDBACKCOLOR
 END TEXTBOX

* Mailing list
 DEFINE LABEL lb_grdmllist
  PARENT p103win
  ROW 180
  COL 100
  VALUE l3w_fMsg("Label", "LBL019")
  WIDTH 500
  HEIGHT 25
  FONTSIZE 14
  FONTBOLD .T.
  FONTCOLOR {0,0,0}
  BACKCOLOR {197,217,241}
  ALIGNMENT Center
 END LABEL
 DEFINE GRID grdmllist
  PARENT p103win
  ROW 210
  COL 100
  WIDTH 500
  HEIGHT 200
  HEADERS {'Rec.N.','Status','e-mail','Mail List'}
  WIDTHS {0,80,200,120}
  ONDBLCLICK p103_EditMail()
  COLUMNCONTROLS {aGrdMail1, aGrdMail2, aGrdMail3, aGrdMail4}
  TOOLTIP l3w_fMsg("ToolTip", "TTI006")
 END GRID

END WINDOW
p103win.Center
RETURN NIL

/****************************************************************
* Entry function
* aParm[1] = form name to assign focus when leave this form
* aParm[2] = control name (about prev. form name) to assign focus when leave this form
* aParm[3] = control name (about prev. form name) to assign a value from grid of this form
* aParm[...] = control name (about prev. form name) to assign a value from grid of this form
* aParm[n] = control name (about prev. form name) to assign a value from grid of this form
* nGrid = if passed when load grid set Grid.Value else is set to 1
****************************************************************/
FUNCTION p103_Main(aParm, nGrid)
LOCAL lReturn := .F.
PUBLIC p103_cProcname := "hconp103"
nGrid := IIF(VALTYPE(nGrid)=="N", nGrid, 0)
aParm := IIF(VALTYPE(aParm)=="A", aParm, {})
IF l3w_fGetperms( p103_cProcname, "x" ) .AND. l3w_fFomFree( "p103win", "FormStatus", "N" )
 lReturn := .T.
 p103_ShowForm(aParm, nGrid)
ELSE
 p103_NewFocus(aParm)
ENDIF

/****************************************************************
* ShowForm function
****************************************************************/
STATIC FUNCTION p103_ShowForm(aParm, nGrid)
PUBLIC p103_nGrid := nGrid
PUBLIC p103_aParm := aParm
p103win.StatusBar.Item(1) :=  "DataBase : " + l3w_fConf("DataBase", "Description")
p103win.StatusBar.Item(2) :=  "User : " + l3w_fConf("User", "Name")
p103win.Restore
p103win.SetFocus
p103_FormReset()
p103_LoadForm()
RETURN NIL

/****************************************************************
* Set New Focus
* __MVEXIST, __MVGET, __MVPUT are little trick because p103_aParm is declared PUBLIC inside in p103_ShowForm function
* but p103_NewFocus can be called from p103_Main and p103_aParm it's not declared!
****************************************************************/
STATIC FUNCTION p103_NewFocus(aParm)
LOCAL aNewFocus := IIF(VALTYPE(aParm)=="A", aParm, IIF(__MVEXIST("p103_aParm"), __MVGET("p103_aParm"), {}))
IF LEN(aNewFocus)>=1
 DoMethod(aNewFocus[1], "Restore" )
 IF LEN(aNewFocus)==1
  DoMethod(aNewFocus[1], "SetFocus")
 ELSEIF LEN(aNewFocus)>=2
  DoMethod(aNewFocus[1], aNewFocus[2], "SetFocus")
 ENDIF
ENDIF
IF __MVEXIST("p103_aParm")
 __MVPUT("p103_aParm", {})
ENDIF
RETURN NIL

/****************************************************************
* InteractiveClose function
****************************************************************/
STATIC FUNCTION p103_IntClose()
p103_FormReset()
p103_StatusReset()
p103_NewFocus()
RETURN NIL

/****************************************************************
* Exit function
****************************************************************/
STATIC FUNCTION p103_Exit()
p103_FormReset()
p103_StatusReset()
p103win.Hide
p103_NewFocus()
RETURN NIL

/****************************************************************
* Save function
****************************************************************/
STATIC FUNCTION p103_Save()
IF l3w_fGetperms( p103_cProcname, "w" ) .AND. p103_CheckData()
 IF p103_Update()
  p103_FormReset()
  p103_StatusReset()
  p103win.Hide
  p103_NewFocus()
 ENDIF
ENDIF
RETURN NIL

/****************************************************************
* Reset function
****************************************************************/
STATIC FUNCTION p103_Reset()
p103_FormReset()
p103_StatusReset()
p103win.Hide
p103_NewFocus()
RETURN NIL

/****************************************************************
* Edit Mail Grid
****************************************************************/
STATIC FUNCTION p103_EditMail()
LOCAL lReturn := p106_Main({"p103win","grdmllist","grdmllist"}, p103win.grdmllist.Value)
RETURN NIL

/****************************************************************
* Delete function
****************************************************************/
STATIC FUNCTION p103_Delete()
RETURN NIL

/****************************************************************
* UnDelete function
****************************************************************/
STATIC FUNCTION p103_Undelete()
RETURN NIL

/****************************************************************
* Status Reset function
****************************************************************/
STATIC FUNCTION p103_StatusReset()
p103win.FormStatus.Value := "N"
RETURN NIL

/****************************************************************
* Form Reset function
****************************************************************/
STATIC FUNCTION p103_FormReset()
p103win.cb_emlstatus.Value := 1
p103win.emltypolo.Value := ""
p103win.typdescri.Value := ""
p103win.emldescri.Value := ""
p103win.emladdres.Value := ""
p103win.grdmllist.DeleteAllItems

p103win.cb_emlstatus.SetFocus

p103win.bt_save.Enabled := .F.
RETURN NIL

/****************************************************************
* Load form function
* {ALLTRIM(STR(mailaddr->(RECNO()))), mailaddr->emlstatus, mailaddr->emltypolo, cDescr }
****************************************************************/
STATIC FUNCTION p103_LoadForm()
LOCAL aReturn := {}
LOCAL aTemp := {}
* commits form video
p103win.FormStatus.Value := "I"
* if Row Grid number is 0, it's a new email
IF p103_nGrid==0
 p103win.cb_emlstatus.Value := 1
ELSE
 aTemp := GetProperty( "p102win", "gridmail", "Item" , p103_nGrid)
 p103win.cb_emlstatus.Value := p999_StatusByCod( aTemp[2] )
 p103win.emltypolo.Value := aTemp[3]
 p103win.emldescri.Value := aTemp[4]
 p103win.emladdres.Value := aTemp[5]
* if email is a saved record, to preserve link with mailing list, email address field is disabled
 IF aTemp[1] <> 0
  SetProperty("p103win", "emladdres", "Readonly", .T.)
  SetProperty("p103win", "emladdres", "Tabstop", .F.)
 ELSE
  SetProperty("p103win", "emladdres", "Readonly", .F.)
  SetProperty("p103win", "emladdres", "Tabstop", .T.)
 ENDIF
 p103_LoadMlist()
ENDIF
* se il codice socio esiste, ritorna i campi
IF LEN( ALLTRIM( p103win.emltypolo.Value )) > 0
 aReturn := p008_Getdes(p103win.emltypolo.Value)
 p103win.typdescri.Value := aReturn[2]
ENDIF

p103win.bt_save.Enabled := .T.
RETURN NIL

/****************************************************************
* Load Mailing list
****************************************************************/
STATIC FUNCTION p103_LoadMlist()
LOCAL aTemp := {}, nI := 0, nItem := 0
nItem := GetProperty( "p102win", "gridmlst", "ItemCount")
p103win.grdmllist.DeleteAllItems
FOR nI := 1 TO nItem
 aTemp := GetProperty( "p102win", "gridmlst", "Item" , nI)
 IF ALLTRIM(aTemp[3])==ALLTRIM(p103win.emladdres.Value)
  p103win.grdmllist.AddItem(aTemp)
 ENDIF
NEXT nI
RETURN NIL

/****************************************************************
* Update function
****************************************************************/
STATIC FUNCTION p103_update()
LOCAL aTemp := {}
LOCAL aGetdes := p008_Getdes(p103win.emltypolo.Value)

* if Record Numer is 0 I must Append
IF p103_nGrid==0
 aTemp := {0, "", "", "", ""}
ELSE
 aTemp := GetProperty( "p102win", "gridmail", "Item", p103_nGrid)
ENDIF
aTemp[2] := p999_StatusByNum(p103win.cb_emlstatus.Value)
aTemp[3] := p103win.emltypolo.Value
aTemp[4] := p103win.emldescri.Value
aTemp[5] := p103win.emladdres.Value
* if Record Numer is 0 I must Append
IF p103_nGrid==0
 DoMethod( "p102win", "gridmail", "AddItem", aTemp )
 p103_nGrid := GetProperty("p102win", "gridmail", "ItemCount")
 SetProperty("p102win", "gridmail", "Value", p103_nGrid )
ELSE
 SetProperty( "p102win", "gridmail", "Item", p103_nGrid, aTemp )
ENDIF
p103_UpdMlist()
RETURN .T.

/****************************************************************
* Update function TOO complicate!!!
* I must control two grid with different data: someone is the same
* someone is added and someone it's different!!!
* for this reason I need to use aToUpdate array: the last value tell me if update or not
****************************************************************/
STATIC FUNCTION p103_UpdMlist()
LOCAL aTemp := {}, nI := 0, nItem := 0
LOCAL aTemp1 := {}, nX := 0, nXtem := 0
LOCAL aToUpdate := {}
nXtem := GetProperty( "p103win", "grdmllist", "ItemCount")
FOR nX := 1 TO nXtem
 aTemp1 := GetProperty( "p103win", "grdmllist", "Item" , nX)
 AADD(aToUpdate,{aTemp1[1],aTemp1[2],aTemp1[3],aTemp1[4],.F.})
NEXT nX
* now I can update p102 grid
nItem := GetProperty( "p102win", "gridmlst", "ItemCount")
FOR nX := 1 TO LEN(aToUpdate)
 aTemp1 := {aToUpdate[nX,1], aToUpdate[nX,2], aToUpdate[nX,3], aToUpdate[nX,4]}
 FOR nI := 1 TO nItem
  aTemp := GetProperty( "p102win", "gridmlst", "Item" , nI)
  IF ALLTRIM(aTemp[3])==ALLTRIM(aToUpdate[nX,3]) .AND. ALLTRIM(aTemp[4])==ALLTRIM(aToUpdate[nX,4])
   SetProperty( "p102win", "gridmlst", "Item", nI, aTemp1 )
* this item it's update
   aToUpdate[nX,5] := .T.
  ENDIF
 NEXT nI
NEXT nX
* now I must update Item not included: I hope it's a new record :)
FOR nX := 1 TO LEN(aToUpdate)
 IF aToUpdate[nX,5]==.F.
  aTemp1 := {0, aToUpdate[nX,2], aToUpdate[nX,3], aToUpdate[nX,4]}
  DoMethod( "p102win", "gridmlst", "AddItem", aTemp1 )
* this item it's update
  aToUpdate[nX,5] := .T.
 ENDIF
NEXT nX
RETURN NIL

/****************************************************************
* Errors check
****************************************************************/
STATIC FUNCTION p103_CheckData()
LOCAL lItsOk := .T.
lItsOk := IF(lItsOk==.T., p103_emltypolo(), lItsOk)
lItsOk := IF(lItsOk==.T., p103_emldescri(), lItsOk)
lItsOk := IF(lItsOk==.T., p103_emladdres(), lItsOk)
RETURN lItsOk

/*
* error emltypolo
*/
STATIC FUNCTION p103_emltypolo()
LOCAL lItsOk := .T.
LOCAL aReturn := {}
IF p008_Isok( p103win.emltypolo.Value ) == .F.
 lItsOk := .F.
 MsgStop(l3w_fMsg("Error", "ERR010"),"p103_CheckData")
 p103win.emltypolo.SetFocus
ELSE
 aReturn := p008_Getdes(p103win.emltypolo.Value)
 p103win.typdescri.Value := aReturn[2]
ENDIF
RETURN lItsOk
/*
* src1
*/
STATIC FUNCTION p103_src_emltypolo()
LOCAL lReturn := p009_main( {"p103win", "emltypolo", "emltypolo", "typdescri"}, p103win.emltypolo.Value )
RETURN NIL

/*
* error emldescri
*/
STATIC FUNCTION p103_emldescri()
LOCAL lItsOk := .T.
IF LEN(ALLTRIM(p103win.emldescri.Value))==0
 lItsOk := .F.
 MsgStop(l3w_fMsg("Error", "ERR006"),"p103_emldescri")
 p103win.emldescri.SetFocus
ENDIF
RETURN lItsOk

/*
* error emladdres
*/
STATIC FUNCTION p103_emladdres()
LOCAL lItsOk := .T.
IF l3w_fIsValidMail(ALLTRIM(p103win.emladdres.Value))==.F.
 lItsOk := .F.
 MsgStop(l3w_fMsg("Error", "ERR011"),"p103_emladdres")
 p103win.emladdres.SetFocus
ENDIF
RETURN lItsOk
