/****************************************************************
* manager of table teleaddr
****************************************************************/
#include "hconp000.ch"

/****************************************************************
* Form definition
****************************************************************/
FUNCTION p104_Define()
LOCAL aStatdes := p999_aStatus("D")

SET NAVIGATION EXTENDED
DEFINE WINDOW p104win ;
 ROW 0 ;
 COL 0 ;
 WIDTH 700 ;
 HEIGHT 525 ;
 TITLE l3w_fMsg("Form", "FRM104")+" (hconp104)" ;
 WINDOWTYPE CHILD ;
 NOAUTORELEASE ;
 NOMAXIMIZE ;
 ON INTERACTIVECLOSE p104_IntClose() ;
 ICON 'L3W_L3WICO' ;
 FONTNAME l3w_fConf("FormFont", "Name") FONTSIZE VAL(l3w_fConf("FormFont", "Size"))

 DEFINE TOOLBAR toolbar1 ;
  BUTTONSIZE 60,30 ;
  FONT l3w_fConf("ButtFont", "Name") ;
  SIZE VAL(l3w_fConf("ButtFont", "Size")) ;
  FLAT ;
  BORDER
  BUTTON bt_exit ;
   CAPTION l3w_fMsg("Command", "CMD001") ;
   PICTURE "L3W_IEXIT" ;
   ACTION p104_Exit() ;
   SEPARATOR
  BUTTON bt_save ;
   CAPTION l3w_fMsg("Command", "CMD011") ;
   PICTURE "L3W_IOK" ;
   ACTION p104_Save() ;
   SEPARATOR
 END TOOLBAR

 DEFINE STATUSBAR
  STATUSITEM "DataBase : " + l3w_fConf("DataBase", "Description") WIDTH 250
  STATUSITEM "User : " + l3w_fConf("User", "Name") WIDTH 250
  CLOCK WIDTH 80
  DATE WIDTH 100
 END STATUSBAR

* form status :
* N=Form Free
* I=Form committed
 DEFINE LABEL FormStatus
  PARENT p104win
  ROW 20
  COL 500
  WIDTH 20
  HEIGHT 20
  VALUE "N"
  VISIBLE .F.
 END LABEL

* field telstatus
 DEFINE LABEL lb_telstatus
  PARENT p104win
  ROW 60
  COL 20
  VALUE l3w_fMsg("Label", "LBL006")
  WIDTH 100
  HEIGHT 25
  ALIGNMENT Left
 END LABEL
 DEFINE COMBOBOX cb_telstatus
  PARENT p104win
  ROW 60
  COL 125
  WIDTH 125
  ITEMS aStatdes
  VALUE 1
 END COMBOBOX

* field teltypolo
 DEFINE LABEL lb_teltypolo
  PARENT p104win
  ROW 90
  COL 20
  VALUE l3w_fMsg("Label", "LBL013")
  WIDTH 100
  HEIGHT 25
  ALIGNMENT Left
 END LABEL
 DEFINE TEXTBOX teltypolo
  PARENT p104win
  ROW 90
  COL 125
  HEIGHT 25
  WIDTH 100
  TOOLTIP l3w_fMsg("ToolTip", "TTI013")
  MAXLENGTH p999_LenField("teleaddr","teltypolo")
  CASECONVERT UPPER
  ONENTER p104_teltypolo()
 END TEXTBOX
* button bt_src_teltypolo
 DEFINE BUTTON bt_src_teltypolo
  PARENT p104win
  ROW 90
  COL 230
  PICTURE "L3W_ISEARCH"
  ONCLICK p104_src_teltypolo()
  WIDTH 30
  HEIGHT 30
  TOOLTIP l3w_fMsg("ToolTip", "TTI002")
  FLAT .T.
  TABSTOP .F.
 END BUTTON
 DEFINE TEXTBOX typdescri
  PARENT p104win
  ROW 90
  COL 265
  HEIGHT 25
  WIDTH 300
  MAXLENGTH p999_LenField("typology","typdescri")
  READONLY .T.
  TABSTOP .F.
  DISABLEDBACKCOLOR L3W_DISABLEDBACKCOLOR
 END TEXTBOX

* field teldescri
 DEFINE LABEL lb_teldescri
  PARENT p104win
  ROW 120
  COL 20
  VALUE l3w_fMsg("Label", "LBL002")
  WIDTH 100
  HEIGHT 25
  ALIGNMENT Left
  END LABEL
 DEFINE TEXTBOX teldescri
  PARENT p104win
  ROW 120
  COL 125
  WIDTH 400
  HEIGHT 25
  MAXLENGTH p999_LenField("teleaddr","teldescri")
  ONENTER p104_teldescri()
  TOOLTIP l3w_fMsg("ToolTip", "TTI003")
 END TEXTBOX

* field teladdres
 DEFINE LABEL lb_teladdres
  PARENT p104win
  ROW 150
  COL 20
  VALUE l3w_fMsg("Label", "LBL016")
  WIDTH 100
  HEIGHT 25
  ALIGNMENT Left
  END LABEL
 DEFINE TEXTBOX teladdres
  PARENT p104win
  ROW 150
  COL 125
  WIDTH 400
  HEIGHT 25
  MAXLENGTH p999_LenField("teleaddr","teladdres")
  ONENTER p104_teladdres()
  TOOLTIP l3w_fMsg("ToolTip", "TTI016")
 END TEXTBOX

END WINDOW
p104win.Center
RETURN NIL

/****************************************************************
* Entry function
* aParm[1] = form name to assign focus when leave this form
* aParm[2] = control name (about prev. form name) to assign focus when leave this form
* aParm[3] = control name (about prev. form name) to assign a value from grid of this form
* aParm[...] = control name (about prev. form name) to assign a value from grid of this form
* aParm[n] = control name (about prev. form name) to assign a value from grid of this form
* nGrid = if passed when load grid set Grid.Value else is set to 1
****************************************************************/
FUNCTION p104_Main(aParm, nGrid)
LOCAL lReturn := .F.
PUBLIC p104_cProcname := "hconp104"
nGrid := IIF(VALTYPE(nGrid)=="N", nGrid, 0)
aParm := IIF(VALTYPE(aParm)=="A", aParm, {})
IF l3w_fGetperms( p104_cProcname, "x" ) .AND. l3w_fFomFree( "p104win", "FormStatus", "N" )
 lReturn := .T.
 p104_ShowForm(aParm, nGrid)
ELSE
 p104_NewFocus(aParm)
ENDIF

/****************************************************************
* ShowForm function
****************************************************************/
STATIC FUNCTION p104_ShowForm(aParm, nGrid)
PUBLIC p104_nGrid := nGrid
PUBLIC p104_aParm := aParm
p104win.StatusBar.Item(1) :=  "DataBase : " + l3w_fConf("DataBase", "Description")
p104win.StatusBar.Item(2) :=  "User : " + l3w_fConf("User", "Name")
p104win.Restore
p104win.SetFocus
p104_FormReset()
p104_LoadForm()
RETURN NIL

/****************************************************************
* Set New Focus
* __MVEXIST, __MVGET, __MVPUT are little trick because p104_aParm is declared PUBLIC inside in p104_ShowForm function
* but p104_NewFocus can be called from p104_Main and p104_aParm it's not declared!
****************************************************************/
STATIC FUNCTION p104_NewFocus(aParm)
LOCAL aNewFocus := IIF(VALTYPE(aParm)=="A", aParm, IIF(__MVEXIST("p104_aParm"), __MVGET("p104_aParm"), {}))
IF LEN(aNewFocus)>=1
 DoMethod(aNewFocus[1], "Restore" )
 IF LEN(aNewFocus)==1
  DoMethod(aNewFocus[1], "SetFocus")
 ELSEIF LEN(aNewFocus)>=2
  DoMethod(aNewFocus[1], aNewFocus[2], "SetFocus")
 ENDIF
ENDIF
IF __MVEXIST("p104_aParm")
 __MVPUT("p104_aParm", {})
ENDIF
RETURN NIL

/****************************************************************
* InteractiveClose function
****************************************************************/
STATIC FUNCTION p104_IntClose()
p104_FormReset()
p104_StatusReset()
p104_NewFocus()
RETURN NIL

/****************************************************************
* Exit function
****************************************************************/
STATIC FUNCTION p104_Exit()
p104_FormReset()
p104_StatusReset()
p104win.Hide
p104_NewFocus()
RETURN NIL

/****************************************************************
* Save function
****************************************************************/
STATIC FUNCTION p104_Save()
IF l3w_fGetperms( p104_cProcname, "w" ) .AND. p104_CheckData()
 IF p104_Update()
  p104_FormReset()
  p104_StatusReset()
  p104win.Hide
  p104_NewFocus()
 ENDIF
ENDIF
RETURN NIL

/****************************************************************
* Reset function
****************************************************************/
STATIC FUNCTION p104_Reset()
p104_FormReset()
p104_StatusReset()
p104win.Hide
p104_NewFocus()
RETURN NIL

/****************************************************************
* Delete function
****************************************************************/
STATIC FUNCTION p104_Delete()
RETURN NIL

/****************************************************************
* UnDelete function
****************************************************************/
STATIC FUNCTION p104_Undelete()
RETURN NIL

/****************************************************************
* Status Reset function
****************************************************************/
STATIC FUNCTION p104_StatusReset()
p104win.FormStatus.Value := "N"
RETURN NIL

/****************************************************************
* Form Reset function
****************************************************************/
STATIC FUNCTION p104_FormReset()
p104win.cb_telstatus.Value := 1
p104win.teltypolo.Value := ""
p104win.typdescri.Value := ""
p104win.teldescri.Value := ""
p104win.teladdres.Value := ""

p104win.cb_telstatus.SetFocus

p104win.bt_save.Enabled := .F.
RETURN NIL

/****************************************************************
* Load form function
* {ALLTRIM(STR(teleaddr->(RECNO()))), teleaddr->telstatus, teleaddr->teltypolo, cDescr }
****************************************************************/
STATIC FUNCTION p104_LoadForm()
LOCAL aReturn := {}
LOCAL aTemp := {}
* commits form video
p104win.FormStatus.Value := "I"
* if Record Numer is 0 I must Append
IF p104_nGrid==0
 p104win.cb_telstatus.Value := 1
ELSE
 aTemp := GetProperty( "p102win", "gridphon", "Item" , p104_nGrid)
 p104win.cb_telstatus.Value := p999_StatusByCod( aTemp[2] )
 p104win.teltypolo.Value := aTemp[3]
 p104win.teldescri.Value := aTemp[4]
 p104win.teladdres.Value := aTemp[5]
ENDIF
* se il codice socio esiste, ritorna i campi
IF LEN( ALLTRIM( p104win.teltypolo.Value )) > 0
 aReturn := p008_Getdes(p104win.teltypolo.Value)
 p104win.typdescri.Value := aReturn[2]
ENDIF

p104win.bt_save.Enabled := .T.
RETURN NIL

/****************************************************************
* Update function
****************************************************************/
STATIC FUNCTION p104_update()
LOCAL aTemp := {}
LOCAL aGetdes := p008_Getdes(p104win.teltypolo.Value)

* if Record Numer is 0 I must Append
IF p104_nGrid==0
 aTemp := {0, "", "", "", ""}
ELSE
 aTemp := GetProperty( "p102win", "gridphon", "Item", p104_nGrid)
ENDIF
aTemp[2] := p999_StatusByNum(p104win.cb_telstatus.Value)
aTemp[3] := p104win.teltypolo.Value
aTemp[4] := p104win.teldescri.Value
aTemp[5] := p104win.teladdres.Value
* if Record Numer is 0 I must Append
IF p104_nGrid==0
 DoMethod( "p102win", "gridphon", "AddItem", aTemp )
 p104_nGrid := GetProperty("p102win", "gridphon", "ItemCount")
 SetProperty("p102win", "gridphon", "Value", p104_nGrid )
ELSE
 SetProperty( "p102win", "gridphon", "Item", p104_nGrid, aTemp )
ENDIF
RETURN .T.

/****************************************************************
* Errors check
****************************************************************/
STATIC FUNCTION p104_CheckData()
LOCAL lItsOk := .T.
lItsOk := IF(lItsOk==.T., p104_teltypolo(), lItsOk)
lItsOk := IF(lItsOk==.T., p104_teldescri(), lItsOk)
lItsOk := IF(lItsOk==.T., p104_teladdres(), lItsOk)
RETURN lItsOk

/*
* error teltypolo
*/
STATIC FUNCTION p104_teltypolo()
LOCAL lItsOk := .T.
LOCAL aReturn := {}
IF p008_Isok( p104win.teltypolo.Value ) == .F.
 lItsOk := .F.
 MsgStop(l3w_fMsg("Error", "ERR010"),"p104_CheckData")
 p104win.teltypolo.SetFocus
ELSE
 aReturn := p008_Getdes(p104win.teltypolo.Value)
 p104win.typdescri.Value := aReturn[2]
ENDIF
RETURN lItsOk
/*
* src1
*/
STATIC FUNCTION p104_src_teltypolo()
LOCAL lReturn := p009_main( {"p104win", "teltypolo", "teltypolo", "typdescri"}, p104win.teltypolo.Value )
RETURN NIL

/*
* error teldescri
*/
STATIC FUNCTION p104_teldescri()
LOCAL lItsOk := .T.
IF LEN(ALLTRIM(p104win.teldescri.Value))==0
 lItsOk := .F.
 MsgStop(l3w_fMsg("Error", "ERR006"),"p104_teldescri")
 p104win.teldescri.SetFocus
ENDIF
RETURN lItsOk

/*
* error teladdres
*/
STATIC FUNCTION p104_teladdres()
LOCAL lItsOk := .T.
IF LEN(ALLTRIM(p104win.teladdres.Value))==0
 lItsOk := .F.
 MsgStop(l3w_fMsg("Error", "ERR014"),"p104_teladdres")
 p104win.teladdres.SetFocus
ENDIF
RETURN lItsOk
