/****************************************************************
* manager of table mailings
****************************************************************/
#include "hconp000.ch"

/****************************************************************
* Form definition
****************************************************************/
FUNCTION p106_Define()
LOCAL aStatdes := p999_aStatus("D")

SET NAVIGATION EXTENDED
DEFINE WINDOW p106win ;
 ROW 0 ;
 COL 0 ;
 WIDTH 620 ;
 HEIGHT 465 ;
 TITLE l3w_fMsg("Form", "FRM106")+" (hconp106)" ;
 WINDOWTYPE CHILD ;
 NOAUTORELEASE ;
 NOMAXIMIZE ;
 ON INTERACTIVECLOSE p106_IntClose() ;
 ICON 'L3W_L3WICO' ;
 FONTNAME l3w_fConf("FormFont", "Name") FONTSIZE VAL(l3w_fConf("FormFont", "Size"))

 DEFINE TOOLBAR toolbar1 ;
  BUTTONSIZE 60,30 ;
  FONT l3w_fConf("ButtFont", "Name") ;
  SIZE VAL(l3w_fConf("ButtFont", "Size")) ;
  FLAT ;
  BORDER
  BUTTON bt_exit ;
   CAPTION l3w_fMsg("Command", "CMD001") ;
   PICTURE "L3W_IEXIT" ;
   ACTION p106_Exit() ;
   SEPARATOR
  BUTTON bt_save ;
   CAPTION l3w_fMsg("Command", "CMD011") ;
   PICTURE "L3W_IOK" ;
   ACTION p106_Save() ;
   SEPARATOR
 END TOOLBAR

 DEFINE STATUSBAR
  STATUSITEM "DataBase : " + l3w_fConf("DataBase", "Description") WIDTH 250
  STATUSITEM "User : " + l3w_fConf("User", "Name") WIDTH 250
  CLOCK WIDTH 80
  DATE WIDTH 100
 END STATUSBAR

* form status :
* N=Form Free
* I=Form committed
 DEFINE LABEL FormStatus
  PARENT p106win
  ROW 20
  COL 500
  WIDTH 20
  HEIGHT 20
  VALUE "N"
  VISIBLE .F.
 END LABEL

* field mlsstatus
 DEFINE LABEL lb_mlsstatus
  PARENT p106win
  ROW 60
  COL 20
  VALUE l3w_fMsg("Label", "LBL006")
  WIDTH 100
  HEIGHT 25
  ALIGNMENT Left
 END LABEL
 DEFINE COMBOBOX cb_mlsstatus
  PARENT p106win
  ROW 60
  COL 125
  WIDTH 125
  ITEMS aStatdes
  VALUE 1
 END COMBOBOX

* field mlsidmcod
 DEFINE LABEL lb_mlsidmcod
  PARENT p106win
  ROW 90
  COL 20
  VALUE l3w_fMsg("Label", "LBL013")
  WIDTH 100
  HEIGHT 25
  ALIGNMENT Left
 END LABEL
 DEFINE TEXTBOX mlsidmcod
  PARENT p106win
  ROW 90
  COL 125
  HEIGHT 25
  WIDTH 100
  TOOLTIP l3w_fMsg("ToolTip", "TTI013")
  MAXLENGTH p999_LenField("mailings","mlsidmcod")
  CASECONVERT UPPER
  ONENTER p106_mlsidmcod()
 END TEXTBOX
* button bt_src_mlsidmcod
 DEFINE BUTTON bt_src_mlsidmcod
  PARENT p106win
  ROW 90
  COL 230
  PICTURE "L3W_ISEARCH"
  ONCLICK p106_src_mlsidmcod()
  WIDTH 30
  HEIGHT 30
  TOOLTIP l3w_fMsg("ToolTip", "TTI002")
  FLAT .T.
  TABSTOP .F.
 END BUTTON
 DEFINE TEXTBOX mlldescri
  PARENT p106win
  ROW 90
  COL 265
  HEIGHT 25
  WIDTH 300
  MAXLENGTH p999_LenField("maillist","mlldescri")
  READONLY .T.
  TABSTOP .F.
  DISABLEDBACKCOLOR L3W_DISABLEDBACKCOLOR
 END TEXTBOX

END WINDOW
p106win.Center
RETURN NIL

/****************************************************************
* Entry function
* aParm[1] = form name to assign focus when leave this form
* aParm[2] = control name (about prev. form name) to assign focus when leave this form
* aParm[3] = control name (about prev. form name) to assign a value from grid of this form
* aParm[...] = control name (about prev. form name) to assign a value from grid of this form
* aParm[n] = control name (about prev. form name) to assign a value from grid of this form
* nGrid = if passed when load grid set Grid.Value else is set to 1
****************************************************************/
FUNCTION p106_Main(aParm, nGrid)
LOCAL lReturn := .F.
PUBLIC p106_cProcname := "hconp106"
nGrid := IIF(VALTYPE(nGrid)=="N", nGrid, 0)
aParm := IIF(VALTYPE(aParm)=="A", aParm, {})
IF l3w_fGetperms( p106_cProcname, "x" ) .AND. l3w_fFomFree( "p106win", "FormStatus", "N" )
 lReturn := .T.
 p106_ShowForm(aParm, nGrid)
ELSE
 p106_NewFocus(aParm)
ENDIF

/****************************************************************
* ShowForm function
****************************************************************/
STATIC FUNCTION p106_ShowForm(aParm, nGrid)
PUBLIC p106_nGrid := nGrid
PUBLIC p106_aParm := aParm
p106win.StatusBar.Item(1) :=  "DataBase : " + l3w_fConf("DataBase", "Description")
p106win.StatusBar.Item(2) :=  "User : " + l3w_fConf("User", "Name")
p106win.Restore
p106win.SetFocus
p106_FormReset()
p106_LoadForm()
RETURN NIL

/****************************************************************
* Set New Focus
* __MVEXIST, __MVGET, __MVPUT are little trick because p106_aParm is declared PUBLIC inside in p106_ShowForm function
* but p106_NewFocus can be called from p106_Main and p106_aParm it's not declared!
****************************************************************/
STATIC FUNCTION p106_NewFocus(aParm)
LOCAL aNewFocus := IIF(VALTYPE(aParm)=="A", aParm, IIF(__MVEXIST("p106_aParm"), __MVGET("p106_aParm"), {}))
IF LEN(aNewFocus)>=1
 DoMethod(aNewFocus[1], "Restore" )
 IF LEN(aNewFocus)==1
  DoMethod(aNewFocus[1], "SetFocus")
 ELSEIF LEN(aNewFocus)>=2
  DoMethod(aNewFocus[1], aNewFocus[2], "SetFocus")
 ENDIF
ENDIF
IF __MVEXIST("p106_aParm")
 __MVPUT("p106_aParm", {})
ENDIF
RETURN NIL

/****************************************************************
* InteractiveClose function
****************************************************************/
STATIC FUNCTION p106_IntClose()
p106_FormReset()
p106_StatusReset()
p106_NewFocus()
RETURN NIL

/****************************************************************
* Exit function
****************************************************************/
STATIC FUNCTION p106_Exit()
p106_FormReset()
p106_StatusReset()
p106win.Hide
p106_NewFocus()
RETURN NIL

/****************************************************************
* Save function
****************************************************************/
STATIC FUNCTION p106_Save()
IF l3w_fGetperms( p106_cProcname, "w" ) .AND. p106_CheckData()
 IF p106_Update()
  p106_FormReset()
  p106_StatusReset()
  p106win.Hide
  p106_NewFocus()
 ENDIF
ENDIF
RETURN NIL

/****************************************************************
* Reset function
****************************************************************/
STATIC FUNCTION p106_Reset()
p106_FormReset()
p106_StatusReset()
p106win.Hide
p106_NewFocus()
RETURN NIL

/****************************************************************
* Delete function
****************************************************************/
STATIC FUNCTION p106_Delete()
RETURN NIL

/****************************************************************
* UnDelete function
****************************************************************/
STATIC FUNCTION p106_Undelete()
RETURN NIL

/****************************************************************
* Status Reset function
****************************************************************/
STATIC FUNCTION p106_StatusReset()
p106win.FormStatus.Value := "N"
RETURN NIL

/****************************************************************
* Form Reset function
****************************************************************/
STATIC FUNCTION p106_FormReset()
p106win.cb_mlsstatus.Value := 1
p106win.mlsidmcod.Value := ""
p106win.mlldescri.Value := ""

p106win.cb_mlsstatus.SetFocus

p106win.bt_save.Enabled := .F.
RETURN NIL

/****************************************************************
* Load form function
* {ALLTRIM(STR(mailings->(RECNO()))), mailings->mlsstatus, mailings->mlsidmcod, cDescr }
****************************************************************/
STATIC FUNCTION p106_LoadForm()
LOCAL aReturn := {}
LOCAL aTemp := {}
* commits form video
p106win.FormStatus.Value := "I"
* if Record Numer is 0 I must Append
IF p106_nGrid==0
 p106win.cb_mlsstatus.Value := 1
ELSE
 aTemp := GetProperty( "p103win", "grdmllist", "Item" , p106_nGrid)
 p106win.cb_mlsstatus.Value := p999_StatusByCod( aTemp[2] )
 p106win.mlsidmcod.Value := aTemp[4]
ENDIF
* se il codice socio esiste, ritorna i campi
IF LEN( ALLTRIM( p106win.mlsidmcod.Value )) > 0
 aReturn := p010_Getdes(p106win.mlsidmcod.Value)
 p106win.mlldescri.Value := aReturn[2]
ENDIF

p106win.bt_save.Enabled := .T.
RETURN NIL

/****************************************************************
* Update function
****************************************************************/
STATIC FUNCTION p106_update()
LOCAL aTemp := {}
LOCAL aGetdes := p010_Getdes(p106win.mlsidmcod.Value)

* if Record Numer is 0 I must Append
IF p106_nGrid==0
 aTemp := {0, "", "", ""}
ELSE
 aTemp := GetProperty( "p103win", "grdmllist", "Item", p106_nGrid)
ENDIF
aTemp[2] := p999_StatusByNum(p106win.cb_mlsstatus.Value)
aTemp[3] := GetProperty( "p103win", "emladdres", "Value")
aTemp[4] := p106win.mlsidmcod.Value
* if Record Numer is 0 I must Append
IF p106_nGrid==0
 DoMethod( "p103win", "grdmllist", "AddItem", aTemp )
 p106_nGrid := GetProperty("p103win", "grdmllist", "ItemCount")
 SetProperty("p103win", "grdmllist", "Value", p106_nGrid )
ELSE
 SetProperty( "p103win", "grdmllist", "Item", p106_nGrid, aTemp )
ENDIF
RETURN .T.

/****************************************************************
* Errors check
****************************************************************/
STATIC FUNCTION p106_CheckData()
LOCAL lItsOk := .T.
lItsOk := IF(lItsOk==.T., p106_mlsidmcod(), lItsOk)
RETURN lItsOk

/*
* error mlsidmcod
*/
STATIC FUNCTION p106_mlsidmcod()
LOCAL lItsOk := .T.
LOCAL aReturn := {}
IF p010_Isok( p106win.mlsidmcod.Value ) == .F.
 lItsOk := .F.
 MsgStop(l3w_fMsg("Error", "ERR010"),"p106_CheckData")
 p106win.mlsidmcod.SetFocus
ELSE
 aReturn := p010_Getdes(p106win.mlsidmcod.Value)
 p106win.mlldescri.Value := aReturn[2]
ENDIF
RETURN lItsOk
/*
* src1
*/
STATIC FUNCTION p106_src_mlsidmcod()
LOCAL lReturn := p011_main( {"p106win", "mlsidmcod", "mlsidmcod", "mlldescri"}, p106win.mlsidmcod.Value )
RETURN NIL
