/****************************************************************
*        mailing extractor
****************************************************************/
#include "hconp000.ch"
#include "fileio.ch"

/****************************************************************
* Form definition
****************************************************************/
FUNCTION p107_Define()
LOCAL aGridHead := {l3w_fMsg("Grid", "GRD004"),l3w_fMsg("Grid", "GRD001"),l3w_fMsg("Grid", "GRD002")}
LOCAL aGrdMail1 := {"TEXTBOX", "CHARACTER"}
LOCAL aGrdMail2 := {"TEXTBOX", "CHARACTER"}
LOCAL aGrdMail3 := {"TEXTBOX", "CHARACTER"}

SET NAVIGATION EXTENDED
DEFINE WINDOW p107win ;
 ROW 0 ;
 COL 0 ;
 WIDTH 940 ;
 HEIGHT 705 ;
 TITLE "MAILING (hconp107)" ;
 WINDOWTYPE CHILD ;
 NOAUTORELEASE ;
 NOMAXIMIZE ;
 ON INTERACTIVECLOSE p107_IntClose() ;
 ICON 'L3W_L3WICO' ;
 FONTNAME l3w_fConf("FormFont", "Name") FONTSIZE VAL(l3w_fConf("FormFont", "Size"))

* definizione toolbar
 DEFINE TOOLBAR toolbar1 ;
  BUTTONSIZE 60,30 ;
  FONT l3w_fConf("ButtFont", "Name") ;
  SIZE VAL(l3w_fConf("ButtFont", "Size")) ;
  FLAT ;
  BORDER
  BUTTON bt_exit ;
   CAPTION 'e&Xit' ;
   PICTURE "L3W_IEXIT" ;
   ACTION p107_Exit() ;
   SEPARATOR
  BUTTON bt_edit ;
   CAPTION '&Export' ;
   PICTURE "L3W_IMSEXCEL" ;
   ACTION p107_Save() ;
   SEPARATOR
  BUTTON bt_reset ;
   CAPTION '&Clear' ;
   PICTURE "L3W_ICLEAR" ;
   ACTION p107_Reset() ;
   SEPARATOR
 END TOOLBAR

 DEFINE STATUSBAR
  STATUSITEM "DataBase : " + l3w_fConf("DataBase", "Description") WIDTH 250
  STATUSITEM "User : " + l3w_fConf("User", "Name") WIDTH 250
  CLOCK WIDTH 80
  DATE WIDTH 100
 END STATUSBAR

* form status :
* N=Form Free
* I=Form committed
 DEFINE LABEL FormStatus
  PARENT p107win
  ROW 20
  COL 500
  WIDTH 20
  HEIGHT 20
  VALUE "N"
  VISIBLE .F.
 END LABEL

* pages
 DEFINE TAB tab01 ;
  AT 90,5 ;
  WIDTH 900 ;
  HEIGHT 500 ;
  VALUE 1 ;
  ON CHANGE p107_ChgPage()

* page file
  PAGE l3w_fMsg("Page", "PAG003")
* campo nomefile
   DEFINE LABEL lb_nomefile
    PARENT p107win
    ROW 40
    COL 20
    VALUE 'File'
    WIDTH 100
    HEIGHT 25
    ALIGNMENT Left
   END LABEL
   DEFINE TEXTBOX nomefile
    PARENT p107win
    ROW 40
    COL 125
    HEIGHT 25
    WIDTH 400
    TOOLTIP 'File name'
    MAXLENGTH 120
    ONENTER p107_nomefile()
   END TEXTBOX
* button bt_src_nomefile
   DEFINE BUTTON bt_src_nomefile
    PARENT p107win
    ROW 40
    COL 530
    PICTURE "L3W_IFOLDER"
    ONCLICK p107_src_nomefile()
    WIDTH 30
    HEIGHT 30
    TOOLTIP 'Click to search'
    FLAT .T.
    TABSTOP .F.
   END BUTTON

* progress bar read records
   DEFINE LABEL lb_inputline
    PARENT p107win
    ROW 90
    COL 20
    VALUE 'Read'
    WIDTH 100
    HEIGHT 25
    ALIGNMENT Left
   END LABEL
   DEFINE PROGRESSBAR inputline
    PARENT p107win
    ROW 90
    COL 125
    WIDTH 300
    HEIGHT 30
    RANGEMAX 100
    RANGEMIN 0
    SMOOTH .T.
    BACKCOLOR GREEN
    FORECOLOR YELLOW
   END PROGRESSBAR

* progress bar extracted records
   DEFINE LABEL lb_outputline
    PARENT p107win
    ROW 120
    COL 20
    VALUE 'Extract'
    WIDTH 100
    HEIGHT 25
    ALIGNMENT Left
   END LABEL
   DEFINE PROGRESSBAR outputline
    PARENT p107win
    ROW 120
    COL 125
    WIDTH 300
    HEIGHT 30
    RANGEMAX 100
    RANGEMIN 0
    SMOOTH .T.
    BACKCOLOR YELLOW
    FORECOLOR GREEN
   END PROGRESSBAR

  END PAGE

* Category
  PAGE l3w_fMsg("Page", "PAG004")

* included category area
   DEFINE LABEL lb_grcatin
    PARENT p107win
    ROW 40
    COL 20
    VALUE l3w_fMsg("Label", "LBL023")
    WIDTH 300
    HEIGHT 25
    FONTSIZE 12
    FONTBOLD .T.
    BACKCOLOR GREEN
    ALIGNMENT Center
   END LABEL

* grid of included category
   DEFINE GRID grcatin
    PARENT p107win
    ROW 90
    COL 20
    WIDTH 300
    HEIGHT 300
    HEADERS aGridHead
    WIDTHS {80,100,200}
    COLUMNCONTROLS {aGrdMail1, aGrdMail2, aGrdMail3}
    TOOLTIP l3w_fMsg("ToolTip", "TTI023")
   END GRID

* bt_allin_catidcate
   DEFINE BUTTON bt_allin_catidcate
    PARENT p107win
    ROW 150
    COL 400
    PICTURE "L3W_IREWIND"
    ONCLICK p107_allin_catidcate()
    WIDTH 30
    HEIGHT 30
    TOOLTIP l3w_fMsg("ToolTip", "TTI019")
    FLAT .T.
    TABSTOP .F.
   END BUTTON

* bt_onein_catidcate
   DEFINE BUTTON bt_onein_catidcate
    PARENT p107win
    ROW 200
    COL 400
    PICTURE "L3W_IRECPREV"
    ONCLICK p107_onein_catidcate()
    WIDTH 30
    HEIGHT 30
    TOOLTIP l3w_fMsg("ToolTip", "TTI020")
    FLAT .T.
    TABSTOP .F.
   END BUTTON

* bt_oneout_catidcate
   DEFINE BUTTON bt_oneout_catidcate
    PARENT p107win
    ROW 250
    COL 400
    PICTURE "L3W_IRECNEXT"
    ONCLICK p107_oneout_catidcate()
    WIDTH 30
    HEIGHT 30
    TOOLTIP l3w_fMsg("ToolTip", "TTI022")
    FLAT .T.
    TABSTOP .F.
   END BUTTON

* bt_allout_catidcate
   DEFINE BUTTON bt_allout_catidcate
    PARENT p107win
    ROW 300
    COL 400
    PICTURE "L3W_IFSTFW"
    ONCLICK p107_allout_catidcate()
    WIDTH 30
    HEIGHT 30
    TOOLTIP l3w_fMsg("ToolTip", "TTI021")
    FLAT .T.
    TABSTOP .F.
   END BUTTON

* excluded category area
   DEFINE LABEL lb_grcatout
    PARENT p107win
    ROW 40
    COL 520
    VALUE l3w_fMsg("Label", "LBL024")
    WIDTH 300
    HEIGHT 25
    FONTSIZE 12
    FONTBOLD .T.
    BACKCOLOR YELLOW
    ALIGNMENT Center
   END LABEL

* grid of excluded category
   DEFINE GRID grcatout
    PARENT p107win
    ROW 90
    COL 520
    WIDTH 300
    HEIGHT 300
    HEADERS aGridHead
    WIDTHS {80,100,200}
    COLUMNCONTROLS {aGrdMail1, aGrdMail2, aGrdMail3}
    TOOLTIP l3w_fMsg("ToolTip", "TTI024")
   END GRID

  END PAGE

* Typology
  PAGE l3w_fMsg("Page", "PAG005")

* included Typology area
   DEFINE LABEL lb_grtypin
    PARENT p107win
    ROW 40
    COL 20
    VALUE l3w_fMsg("Label", "LBL023")
    WIDTH 300
    HEIGHT 25
    FONTSIZE 12
    FONTBOLD .T.
    BACKCOLOR GREEN
    ALIGNMENT Center
   END LABEL

* grid of included Typology
   DEFINE GRID grtypin
    PARENT p107win
    ROW 90
    COL 20
    WIDTH 300
    HEIGHT 300
    HEADERS aGridHead
    WIDTHS {80,100,200}
    COLUMNCONTROLS {aGrdMail1, aGrdMail2, aGrdMail3}
    TOOLTIP l3w_fMsg("ToolTip", "TTI023")
   END GRID

* bt_allin_typidtypo
   DEFINE BUTTON bt_allin_typidtypo
    PARENT p107win
    ROW 150
    COL 400
    PICTURE "L3W_IREWIND"
    ONCLICK p107_allin_typidtypo()
    WIDTH 30
    HEIGHT 30
    TOOLTIP l3w_fMsg("ToolTip", "TTI019")
    FLAT .T.
    TABSTOP .F.
   END BUTTON

* bt_onein_typidtypo
   DEFINE BUTTON bt_onein_typidtypo
    PARENT p107win
    ROW 200
    COL 400
    PICTURE "L3W_IRECPREV"
    ONCLICK p107_onein_typidtypo()
    WIDTH 30
    HEIGHT 30
    TOOLTIP l3w_fMsg("ToolTip", "TTI020")
    FLAT .T.
    TABSTOP .F.
   END BUTTON

* bt_oneout_typidtypo
   DEFINE BUTTON bt_oneout_typidtypo
    PARENT p107win
    ROW 250
    COL 400
    PICTURE "L3W_IRECNEXT"
    ONCLICK p107_oneout_typidtypo()
    WIDTH 30
    HEIGHT 30
    TOOLTIP l3w_fMsg("ToolTip", "TTI022")
    FLAT .T.
    TABSTOP .F.
   END BUTTON

* bt_allout_typidtypo
   DEFINE BUTTON bt_allout_typidtypo
    PARENT p107win
    ROW 300
    COL 400
    PICTURE "L3W_IFSTFW"
    ONCLICK p107_allout_typidtypo()
    WIDTH 30
    HEIGHT 30
    TOOLTIP l3w_fMsg("ToolTip", "TTI021")
    FLAT .T.
    TABSTOP .F.
   END BUTTON

* excluded Typology area
   DEFINE LABEL lb_grtypout
    PARENT p107win
    ROW 40
    COL 520
    VALUE l3w_fMsg("Label", "LBL024")
    WIDTH 300
    HEIGHT 25
    FONTSIZE 12
    FONTBOLD .T.
    BACKCOLOR YELLOW
    ALIGNMENT Center
   END LABEL

* grid of excluded Typology
   DEFINE GRID grtypout
    PARENT p107win
    ROW 90
    COL 520
    WIDTH 300
    HEIGHT 300
    HEADERS aGridHead
    WIDTHS {80,100,200}
    COLUMNCONTROLS {aGrdMail1, aGrdMail2, aGrdMail3}
    TOOLTIP l3w_fMsg("ToolTip", "TTI024")
   END GRID

  END PAGE

* Language
  PAGE l3w_fMsg("Page", "PAG006")

* included language
   DEFINE LABEL lb_grlanin
    PARENT p107win
    ROW 40
    COL 20
    VALUE l3w_fMsg("Label", "LBL023")
    WIDTH 300
    HEIGHT 25
    FONTSIZE 12
    FONTBOLD .T.
    BACKCOLOR GREEN
    ALIGNMENT Center
   END LABEL

* grid of included language
   DEFINE GRID grlanin
    PARENT p107win
    ROW 90
    COL 20
    WIDTH 300
    HEIGHT 300
    HEADERS aGridHead
    WIDTHS {80,100,200}
    COLUMNCONTROLS {aGrdMail1, aGrdMail2, aGrdMail3}
    TOOLTIP l3w_fMsg("ToolTip", "TTI023")
   END GRID

* bt_allin_lanidlang
   DEFINE BUTTON bt_allin_lanidlang
    PARENT p107win
    ROW 150
    COL 400
    PICTURE "L3W_IREWIND"
    ONCLICK p107_allin_lanidlang()
    WIDTH 30
    HEIGHT 30
    TOOLTIP l3w_fMsg("ToolTip", "TTI019")
    FLAT .T.
    TABSTOP .F.
   END BUTTON

* bt_onein_lanidlang
   DEFINE BUTTON bt_onein_lanidlang
    PARENT p107win
    ROW 200
    COL 400
    PICTURE "L3W_IRECPREV"
    ONCLICK p107_onein_lanidlang()
    WIDTH 30
    HEIGHT 30
    TOOLTIP l3w_fMsg("ToolTip", "TTI020")
    FLAT .T.
    TABSTOP .F.
   END BUTTON

* bt_oneout_lanidlang
   DEFINE BUTTON bt_oneout_lanidlang
    PARENT p107win
    ROW 250
    COL 400
    PICTURE "L3W_IRECNEXT"
    ONCLICK p107_oneout_lanidlang()
    WIDTH 30
    HEIGHT 30
    TOOLTIP l3w_fMsg("ToolTip", "TTI022")
    FLAT .T.
    TABSTOP .F.
   END BUTTON

* bt_allout_lanidlang
   DEFINE BUTTON bt_allout_lanidlang
    PARENT p107win
    ROW 300
    COL 400
    PICTURE "L3W_IFSTFW"
    ONCLICK p107_allout_lanidlang()
    WIDTH 30
    HEIGHT 30
    TOOLTIP l3w_fMsg("ToolTip", "TTI021")
    FLAT .T.
    TABSTOP .F.
   END BUTTON

* excluded language area
   DEFINE LABEL lb_grlanout
    PARENT p107win
    ROW 40
    COL 520
    VALUE l3w_fMsg("Label", "LBL024")
    WIDTH 300
    HEIGHT 25
    FONTSIZE 12
    FONTBOLD .T.
    BACKCOLOR YELLOW
    ALIGNMENT Center
   END LABEL

* grid of excluded language
   DEFINE GRID grlanout
    PARENT p107win
    ROW 90
    COL 520
    WIDTH 300
    HEIGHT 300
    HEADERS aGridHead
    WIDTHS {80,100,200}
    COLUMNCONTROLS {aGrdMail1, aGrdMail2, aGrdMail3}
    TOOLTIP l3w_fMsg("ToolTip", "TTI024")
   END GRID

  END PAGE

* mailinglist
  PAGE l3w_fMsg("Page", "PAG007")

* included mailing list area
   DEFINE LABEL lb_grmllin
    PARENT p107win
    ROW 40
    COL 20
    VALUE l3w_fMsg("Label", "LBL023")
    WIDTH 300
    HEIGHT 25
    FONTSIZE 12
    FONTBOLD .T.
    BACKCOLOR GREEN
    ALIGNMENT Center
   END LABEL

* grid of excluded mailing list
   DEFINE GRID grmllin
    PARENT p107win
    ROW 90
    COL 20
    WIDTH 300
    HEIGHT 300
    HEADERS aGridHead
    WIDTHS {80,100,200}
    COLUMNCONTROLS {aGrdMail1, aGrdMail2, aGrdMail3}
    TOOLTIP l3w_fMsg("ToolTip", "TTI023")
   END GRID

* bt_allin_mllidmcod
   DEFINE BUTTON bt_allin_mllidmcod
    PARENT p107win
    ROW 150
    COL 400
    PICTURE "L3W_IREWIND"
    ONCLICK p107_allin_mllidmcod()
    WIDTH 30
    HEIGHT 30
    TOOLTIP l3w_fMsg("ToolTip", "TTI019")
    FLAT .T.
    TABSTOP .F.
   END BUTTON

* bt_onein_mllidmcod
   DEFINE BUTTON bt_onein_mllidmcod
    PARENT p107win
    ROW 200
    COL 400
    PICTURE "L3W_IRECPREV"
    ONCLICK p107_onein_mllidmcod()
    WIDTH 30
    HEIGHT 30
    TOOLTIP l3w_fMsg("ToolTip", "TTI020")
    FLAT .T.
    TABSTOP .F.
   END BUTTON

* bt_oneout_mllidmcod
   DEFINE BUTTON bt_oneout_mllidmcod
    PARENT p107win
    ROW 250
    COL 400
    PICTURE "L3W_IRECNEXT"
    ONCLICK p107_oneout_mllidmcod()
    WIDTH 30
    HEIGHT 30
    TOOLTIP l3w_fMsg("ToolTip", "TTI022")
    FLAT .T.
    TABSTOP .F.
   END BUTTON

* bt_allout_mllidmcod
   DEFINE BUTTON bt_allout_mllidmcod
    PARENT p107win
    ROW 300
    COL 400
    PICTURE "L3W_IFSTFW"
    ONCLICK p107_allout_mllidmcod()
    WIDTH 30
    HEIGHT 30
    TOOLTIP l3w_fMsg("ToolTip", "TTI021")
    FLAT .T.
    TABSTOP .F.
   END BUTTON

* excluded mailing list area
   DEFINE LABEL lb_grmllout
    PARENT p107win
    ROW 40
    COL 520
    VALUE l3w_fMsg("Label", "LBL024")
    WIDTH 300
    HEIGHT 25
    FONTSIZE 12
    FONTBOLD .T.
    BACKCOLOR YELLOW
    ALIGNMENT Center
   END LABEL

* grid of excluded mailing list
   DEFINE GRID grmllout
    PARENT p107win
    ROW 90
    COL 520
    WIDTH 300
    HEIGHT 300
    HEADERS aGridHead
    WIDTHS {80,100,200}
    COLUMNCONTROLS {aGrdMail1, aGrdMail2, aGrdMail3}
    TOOLTIP l3w_fMsg("ToolTip", "TTI024")
   END GRID

  END PAGE

 END TAB

END WINDOW
p107win.Center
RETURN NIL

/****************************************************************
* Entry function
* aParm[1] = form name to assign focus when leave this form
* aParm[2] = control name (about prev. form name) to assign focus when leave this form
* aParm[3] = control name (about prev. form name) to assign a value from grid of this form
* aParm[...] = control name (about prev. form name) to assign a value from grid of this form
* aParm[n] = control name (about prev. form name) to assign a value from grid of this form
****************************************************************/
FUNCTION p107_Main(aParm)
LOCAL lReturn := .F.
PUBLIC p107_cProcname := "hconp107"
aParm := IIF(VALTYPE(aParm)=="A", aParm, {})
IF l3w_fGetperms( p107_cProcname, "x" ) .AND. l3w_fFomFree( "p107win", "FormStatus", "N" )
 p107_ShowForm(aParm)
 lReturn := .T.
ELSE
 p107_NewFocus(aParm)
ENDIF
RETURN lReturn

/****************************************************************
* ShowForm function
****************************************************************/
STATIC FUNCTION p107_ShowForm(aParm)
PUBLIC p107_nOrder := 3
PUBLIC p107_aParm := aParm
p107win.StatusBar.Item(1) :=  "DataBase : " + l3w_fConf("DataBase", "Description")
p107win.StatusBar.Item(2) :=  "User : " + l3w_fConf("User", "Name")
p107win.Restore
p107win.SetFocus
p107_FormReset()
p107_LoadForm()
p107win.nomefile.SetFocus
RETURN NIL

/****************************************************************
* Set New Focus
* __MVEXIST, __MVGET, __MVPUT are little trick because p107_aParm is declared PUBLIC inside in p107_ShowForm function
* but p107_NewFocus can be called from p107_Main and p107_aParm it's not declared!
****************************************************************/
STATIC FUNCTION p107_NewFocus(aParm)
LOCAL aNewFocus := IIF(VALTYPE(aParm)=="A", aParm, IIF(__MVEXIST("p107_aParm"), __MVGET("p107_aParm"), {}))
IF LEN(aNewFocus)>=1
 DoMethod(aNewFocus[1], "Restore" )
 IF LEN(aNewFocus)==1
  DoMethod(aNewFocus[1], "SetFocus")
 ELSEIF LEN(aNewFocus)>=2
  DoMethod(aNewFocus[1], aNewFocus[2], "SetFocus")
 ENDIF
ENDIF
IF __MVEXIST("p107_aParm")
 __MVPUT("p107_aParm", {})
ENDIF
RETURN NIL

/****************************************************************
* InteractiveClose function
****************************************************************/
STATIC FUNCTION p107_IntClose()
p107_FormReset()
p107_StatusReset()
p107_NewFocus()
RETURN NIL

/****************************************************************
* Exit function
****************************************************************/
STATIC FUNCTION p107_Exit()
p107_FormReset()
p107_StatusReset()
p107win.Hide
p107_NewFocus()
RETURN NIL

/****************************************************************
* Save function
****************************************************************/
STATIC FUNCTION p107_Save()
IF p107_CheckData()
 IF p107_Update()
*  p107_FormReset()
*  p107_StatusReset()
*  p107_LoadForm()
 ENDIF
ENDIF
RETURN NIL

/****************************************************************
* Reset function
****************************************************************/
STATIC FUNCTION p107_Reset()
p107_FormReset()
p107_StatusReset()
p107_LoadForm()
RETURN NIL

/****************************************************************
* Status Reset function
****************************************************************/
STATIC FUNCTION p107_StatusReset()
p107win.FormStatus.Value := "N"
RETURN NIL


/****************************************************************
* Form Reset function
****************************************************************/
STATIC FUNCTION p107_FormReset()
p107win.nomefile.Value := ""

p107win.grcatin.DeleteAllItems
p107win.grcatout.DeleteAllItems

p107win.grtypin.DeleteAllItems
p107win.grtypout.DeleteAllItems

p107win.grlanin.DeleteAllItems
p107win.grlanout.DeleteAllItems

p107win.grmllin.DeleteAllItems
p107win.grmllout.DeleteAllItems

p107win.inputline.Value := 0
p107win.outputline.Value := 0
RETURN NIL

/****************************************************************
* Load form function
****************************************************************/
STATIC FUNCTION p107_LoadForm()
p107_loadcate()
p107_loadtypo()
p107_loadlang()
p107_loadmlli()
RETURN NIL

/****************************************************************
* cambio pagina
****************************************************************/
STATIC FUNCTION p107_ChgPage()
RETURN NIL

/****************************************************************
* Errors check
****************************************************************/
STATIC FUNCTION p107_CheckData()
LOCAL lItsOk := .T.
lItsOk := IF(lItsOk==.T., p107_nomefile(), lItsOk)
RETURN lItsOk

/****************************************************************
* p107_nomefile
****************************************************************/
STATIC FUNCTION p107_nomefile()
LOCAL lItsOk := .T.
LOCAL cPath := "", cFile := "", cExt := ""
Hb_FnameSplit(p107win.nomefile.Value, @cPath, @cFile, @cExt)
IF LEN(ALLTRIM(cFile)) == 0
 lItsOk := .F.
 MsgStop(l3w_fMsg("Error", "ERR016"), "p107_nomefile()")
 p107win.nomefile.SetFocus
ELSEIF FILE(p107win.nomefile.Value)==.T. .AND. MsgYesNo(l3w_fMsg("Message", "MSG002"),"p107_nomefile()", .T.)==.F.
 lItsOk := .F.
ENDIF
RETURN lItsOk

/****************************************************************
* p107_src_nomefile
****************************************************************/
STATIC FUNCTION p107_src_nomefile()
LOCAL cPath := l3w_fConf("Application", "Path")
LOCAL aFilter := { {'csv Files','*.csv'} }
LOCAL cX := Putfile(aFilter, "Save file", cPath)
IF LEN(ALLTRIM(cX))>0
 p107win.nomefile.Value := ALLTRIM(cX)
ENDIF
RETURN NIL

/****************************************************************
* load categories data
****************************************************************/
STATIC FUNCTION p107_loadcate()
category->(ORDSETFOCUS(1))
category->(DBGOTOP())
p107win.grcatin.DeleteAllItems
p107win.grcatout.DeleteAllItems
DO WHILE !category->(EOF())
 p107win.grcatout.AddItem( {category->catstatus,category->catidcate,category->catdescri} )
 category->(DBSKIP(+1))
ENDDO
RETURN NIL
/*
* ALL included
*/
STATIC FUNCTION p107_allin_catidcate()
FOR nL := 1 TO p107win.grcatout.ItemCount
 p107win.grcatin.AddItem( p107win.grcatout.Item(nL) )
NEXT nL
p107win.grcatout.DeleteAllItems
p107win.grcatin.Refresh()
p107win.grcatout.Refresh()
RETURN NIL
/*
* ONE included
*/
STATIC FUNCTION p107_onein_catidcate()
IF p107win.grcatout.Value <> 0
 p107win.grcatin.AddItem( p107win.grcatout.Item(p107win.grcatout.Value) )
 p107win.grcatout.DeleteItem(p107win.grcatout.Value)
ENDIF
p107win.grcatin.Refresh()
p107win.grcatout.Refresh()
RETURN NIL
/*
* ALL excluded
*/
STATIC FUNCTION p107_allout_catidcate()
FOR nL := 1 TO p107win.grcatin.ItemCount
 p107win.grcatout.AddItem( p107win.grcatin.Item(nL) )
NEXT nL
p107win.grcatin.DeleteAllItems
p107win.grcatin.Refresh()
p107win.grcatout.Refresh()
RETURN NIL
/*
* ONE excluded
*/
STATIC FUNCTION p107_oneout_catidcate()
IF p107win.grcatin.Value <> 0
 p107win.grcatout.AddItem( p107win.grcatin.Item(p107win.grcatin.Value) )
 p107win.grcatin.DeleteItem(p107win.grcatin.Value)
ENDIF
p107win.grcatin.Refresh()
p107win.grcatout.Refresh()
RETURN NIL

/****************************************************************
* load typologies data
****************************************************************/
STATIC FUNCTION p107_loadtypo()
typology->(ORDSETFOCUS(1))
typology->(DBGOTOP())
p107win.grtypin.DeleteAllItems
p107win.grtypout.DeleteAllItems
DO WHILE !typology->(EOF())
 p107win.grtypout.AddItem( {typology->typstatus,typology->typidtypo,typology->typdescri} )
 typology->(DBSKIP(+1))
ENDDO
RETURN NIL
/*
* ALL included
*/
STATIC FUNCTION p107_allin_typidtypo()
FOR nL := 1 TO p107win.grtypout.ItemCount
 p107win.grtypin.AddItem( p107win.grtypout.Item(nL) )
NEXT nL
p107win.grtypout.DeleteAllItems
p107win.grtypin.Refresh()
p107win.grtypout.Refresh()
RETURN NIL
/*
* ONE included
*/
STATIC FUNCTION p107_onein_typidtypo()
IF p107win.grtypout.Value <> 0
 p107win.grtypin.AddItem( p107win.grtypout.Item(p107win.grtypout.Value) )
 p107win.grtypout.DeleteItem(p107win.grtypout.Value)
ENDIF
p107win.grtypin.Refresh()
p107win.grtypout.Refresh()
RETURN NIL
/*
* ALL excluded
*/
STATIC FUNCTION p107_allout_typidtypo()
FOR nL := 1 TO p107win.grtypin.ItemCount
 p107win.grtypout.AddItem( p107win.grtypin.Item(nL) )
NEXT nL
p107win.grtypin.DeleteAllItems
p107win.grtypin.Refresh()
p107win.grtypout.Refresh()
RETURN NIL
/*
* ONE excluded
*/
STATIC FUNCTION p107_oneout_typidtypo()
IF p107win.grtypin.Value <> 0
 p107win.grtypout.AddItem( p107win.grtypin.Item(p107win.grtypin.Value) )
 p107win.grtypin.DeleteItem(p107win.grtypin.Value)
ENDIF
p107win.grtypin.Refresh()
p107win.grtypout.Refresh()
RETURN NIL

/****************************************************************
* load languages data
****************************************************************/
STATIC FUNCTION p107_loadlang()
language->(ORDSETFOCUS(1))
language->(DBGOTOP())
p107win.grlanin.DeleteAllItems
p107win.grlanout.DeleteAllItems
DO WHILE !language->(EOF())
 p107win.grlanout.AddItem( {language->lanstatus,language->lanidlang,language->landescri} )
 language->(DBSKIP(+1))
ENDDO
RETURN NIL
/*
* ALL included
*/
STATIC FUNCTION p107_allin_lanidlang()
FOR nL := 1 TO p107win.grlanout.ItemCount
 p107win.grlanin.AddItem( p107win.grlanout.Item(nL) )
NEXT nL
p107win.grlanout.DeleteAllItems
p107win.grlanin.Refresh()
p107win.grlanout.Refresh()
RETURN NIL
/*
* ONE included
*/
STATIC FUNCTION p107_onein_lanidlang()
IF p107win.grlanout.Value <> 0
 p107win.grlanin.AddItem( p107win.grlanout.Item(p107win.grlanout.Value) )
 p107win.grlanout.DeleteItem(p107win.grlanout.Value)
ENDIF
p107win.grlanin.Refresh()
p107win.grlanout.Refresh()
RETURN NIL
/*
* ALL excluded
*/
STATIC FUNCTION p107_allout_lanidlang()
FOR nL := 1 TO p107win.grlanin.ItemCount
 p107win.grlanout.AddItem( p107win.grlanin.Item(nL) )
NEXT nL
p107win.grlanin.DeleteAllItems
p107win.grlanin.Refresh()
p107win.grlanout.Refresh()
RETURN NIL
/*
* ONE excluded
*/
STATIC FUNCTION p107_oneout_lanidlang()
IF p107win.grlanin.Value <> 0
 p107win.grlanout.AddItem( p107win.grlanin.Item(p107win.grlanin.Value) )
 p107win.grlanin.DeleteItem(p107win.grlanin.Value)
ENDIF
p107win.grlanin.Refresh()
p107win.grlanout.Refresh()
RETURN NIL

/****************************************************************
* load mailing list
****************************************************************/
STATIC FUNCTION p107_loadmlli()
maillist->(ORDSETFOCUS(1))
maillist->(DBGOTOP())
p107win.grmllin.DeleteAllItems
p107win.grmllout.DeleteAllItems
DO WHILE !maillist->(EOF())
 p107win.grmllout.AddItem( {maillist->mllstatus,maillist->mllidmcod,maillist->mlldescri} )
 maillist->(DBSKIP(+1))
ENDDO
RETURN NIL
/*
* ALL included
*/
STATIC FUNCTION p107_allin_mllidmcod()
FOR nL := 1 TO p107win.grmllout.ItemCount
 p107win.grmllin.AddItem( p107win.grmllout.Item(nL) )
NEXT nL
p107win.grmllout.DeleteAllItems
p107win.grmllin.Refresh()
p107win.grmllout.Refresh()
RETURN NIL
/*
* ONE included
*/
STATIC FUNCTION p107_onein_mllidmcod()
IF p107win.grmllout.Value <> 0
 p107win.grmllin.AddItem( p107win.grmllout.Item(p107win.grmllout.Value) )
 p107win.grmllout.DeleteItem(p107win.grmllout.Value)
ENDIF
p107win.grmllin.Refresh()
p107win.grmllout.Refresh()
RETURN NIL
/*
* ALL excluded
*/
STATIC FUNCTION p107_allout_mllidmcod()
FOR nL := 1 TO p107win.grmllin.ItemCount
 p107win.grmllout.AddItem( p107win.grmllin.Item(nL) )
NEXT nL
p107win.grmllin.DeleteAllItems
p107win.grmllin.Refresh()
p107win.grmllout.Refresh()
RETURN NIL
/*
* ONE excluded
*/
STATIC FUNCTION p107_oneout_mllidmcod()
IF p107win.grmllin.Value <> 0
 p107win.grmllout.AddItem( p107win.grmllin.Item(p107win.grmllin.Value) )
 p107win.grmllin.DeleteItem(p107win.grmllin.Value)
ENDIF
p107win.grmllin.Refresh()
p107win.grmllout.Refresh()
RETURN NIL

/*
* extractor loop
*/
STATIC FUNCTION p107_Update()
LOCAL lIncluded := .F., nRecords := 0, nReadrec := 0, nOutrec := 0, lMailing := .F.
LOCAL aTemp := {}, cLine := "", nF := 0, nP := 0
LOCAL oTxtOut := NIL

* impegna il form
p107win.FormStatus.Value := "I"

contacts->(ORDSETFOCUS(1))
mailaddr->(ORDSETFOCUS(1))
mailings->(ORDSETFOCUS(1))
category->(ORDSETFOCUS(1))
language->(ORDSETFOCUS(1))
typology->(ORDSETFOCUS(1))

DBSELECTAREA("contacts")
DBSETRELATION( "category", {|| contacts->concatego} )
DBSETRELATION( "language", {|| contacts->conlangua} )

DBSELECTAREA("mailaddr")
DBCLEARRELATION()
DBSETRELATION( "typology", {|| mailaddr->emltypolo} )

DBSELECTAREA("mailings")
DBCLEARRELATION()
DBSETRELATION( "maillist", {|| mailings->mlsidmcod} )

p107win.tab01.Value := 1
p107win.inputline.Value := 0
p107win.inputline.Refresh()
p107win.outputline.Value := 0
p107win.outputline.Refresh()
nRecords := contacts->(LASTREC())

WAIT WINDOW "Processing..."  NOWAIT

contacts->(DBGOTOP())
DO WHILE !contacts->(EOF())
 nReadrec += 1
 p107win.inputline.Value := INT( nReadrec/nRecords*100)
 p107win.inputline.Refresh()

 lIncluded := IIF( contacts->constatus <> "D", .T., .F.)
* only enabled contacts
 IF contacts->constatus <> "D"

* check category inclusion/exclusion
  lIncluded := IIF( p107_test_category()==.F., .F., lIncluded )
* check lanugage inclusion/exclusion
  lIncluded := IIF( p107_test_language()==.F., .F., lIncluded )

* Only if contact is included, scan mail address
  IF lIncluded == .T.
   mailaddr->(DBSEEK(contacts->conidcont, .T.))
   DO WHILE !mailaddr->(EOF()) .AND. mailaddr->emlidcont == contacts->conidcont

* Only if mail address is enabled and typology is included, scan maillist link
    IF mailaddr->emlstatus <> "D" .AND. p107_test_typology()
     lMailing := .F.
     mailings->(DBSEEK(contacts->conidcont+mailaddr->emladdres, .T.))
     DO WHILE !mailings->(EOF()) .AND. ;
       mailings->mlsidcont == contacts->conidcont .AND. ;
       mailings->mlsaddres == mailaddr->emladdres
* check mail list inclusion/exclusion
      lMailing := IIF( p107_test_maillist()==.T., .T., lMailing )
      mailings->(DBSKIP(+1))
     ENDDO
     IF lIncluded .AND. lMailing
      nOutrec += 1
      p107win.outputline.Value := INT( nOutrec/nRecords*100)
      p107win.outputline.Refresh()
      AADD(aTemp, {ALLTRIM(mailaddr->emladdres), ALLTRIM(contacts->confiname), ALLTRIM(contacts->conlaname)} )
     ENDIF
    ENDIF

* mailaddr loop
    DO EVENTS
    mailaddr->(DBSKIP(+1))
   ENDDO

  ENDIF
 ENDIF
* contacts loop
 DO EVENTS
 contacts->(DBSKIP(+1))
ENDDO

p107_WriteTxt(aTemp)

WAIT CLEAR

MsgExclamation("End procedure")

RETURN .T.

/*
* write out
*/
STATIC FUNCTION p107_WriteTxt(aArg1)
LOCAL nHandFile := 0, nL := 0, cLine := 0, cEol := CHR(13) + CHR(10)
nHandFile := FCREATE(p107win.nomefile.Value)
IF nHandFile <> -1
 FOR nL := 1 TO LEN(aArg1)
  cLine := aArg1[nL,1] + ";" + ;
           aArg1[nL,2] + ";" + ;
           aArg1[nL,3] + cEOL
  IF FWRITE(nHandFile, cLine ) <> LEN(cLine)
  ENDIF
 NEXT nL
 FCLOSE(nHandFile)
ENDIF
RETURN NIL

/*
* check category
*/
STATIC FUNCTION p107_test_category()
LOCAL lValid := .F., nL := 0, aTemp := {}
FOR nL := 1 TO p107win.grcatin.ItemCount
 aTemp := p107win.grcatin.Item( nL )
 IF ALLTRIM( aTemp[2] ) == ALLTRIM( contacts->concatego )
  lValid := .T.
 ENDIF
NEXT nL
RETURN lValid

/*
* check typology
*/
STATIC FUNCTION p107_test_typology()
LOCAL lValid := .F., nL := 0, aTemp := {}
FOR nL := 1 TO p107win.grtypin.ItemCount
 aTemp := p107win.grtypin.Item( nL )
 IF ALLTRIM( aTemp[2] ) == ALLTRIM( typology->typidtypo )
  lValid := .T.
 ENDIF
NEXT nL
RETURN lValid

/*
* check language
*/
STATIC FUNCTION p107_test_language()
LOCAL lValid := .F., nL := 0, aTemp := {}
FOR nL := 1 TO p107win.grlanin.ItemCount
 aTemp := p107win.grlanin.Item( nL )
 IF ALLTRIM( aTemp[2] ) == ALLTRIM( contacts->conlangua )
  lValid := .T.
 ENDIF
NEXT nL
RETURN lValid

/*
* check mailing list
*/
STATIC FUNCTION p107_test_maillist()
LOCAL lValid := .F., nL := 0, aTemp := {}
FOR nL := 1 TO p107win.grmllin.ItemCount
 aTemp := p107win.grmllin.Item( nL )
 IF ALLTRIM( aTemp[2] ) == ALLTRIM( mailings->mlsidmcod ) .AND. mailings->mlsstatus <> "D"
  lValid := .T.
 ENDIF
NEXT nL
RETURN lValid
