/*
* utility
*
*/

#include "hconp000.ch"

/****************************************************************
* apertura database
****************************************************************/
FUNCTION p999_OpenDb(lExclusive)
LOCAL cType := IIF(VALTYPE(lExclusive)=="L", IIF(lExclusive, "E", "S"), "S")
LOCAL lOpendb := .F.
IF l3w_fNetuse("progress", cType, {"progres1","progres2"}) .AND. ;
   l3w_fNetuse("category", cType, {"categor1","categor2"}) .AND. ;
   l3w_fNetuse("language", cType, {"languag1","languag2"}) .AND. ;
   l3w_fNetuse("typology", cType, {"typolog1","typolog2"}) .AND. ;
   l3w_fNetuse("maillist", cType, {"maillis1","maillis2"}) .AND. ;
   l3w_fNetuse("contacts", cType, {"contact1","contact2"}) .AND. ;
   l3w_fNetuse("postaddr", cType, {"postadd1","postadd2"}) .AND. ;
   l3w_fNetuse("mailaddr", cType, {"mailadd1","mailadd2"}) .AND. ;
   l3w_fNetuse("teleaddr", cType, {"teleadd1","teleadd2"}) .AND. ;
   l3w_fNetuse("mailings", cType, {"mailing1","mailing2"})
 lOpendb := .T.
ENDIF
RETURN lOpendb

/****************************************************************
* lunghezza campi
****************************************************************/
FUNCTION p999_LenField(cT, cF)
LOCAL nLen := 1, cTable := "", cField := "", aStru := {}, nX := 0
cTable := IIF(VALTYPE(cT)=="C", LOWER(cT), "")
cField := IIF(VALTYPE(cF)=="C", LOWER(cF), "")
aStru := p999_aStru(cTable)
* scova il campo
nX := ASCAN(aStru, {|x| x[1]==cField})
nLen := IIF(nX<>0, aStru[nX,3], 1)
RETURN nLen

/****************************************************************
* Status Array
****************************************************************/
FUNCTION p999_aStatus(cTypeName)
LOCAL aReturn := {}, cType := IIF(VALTYPE(cTypeName)=="C", UPPER(ALLTRIM(cTypeName)), "C")
IF cType=="C"
 AADD(aReturn, "A")
 AADD(aReturn, "D")
ELSE
 AADD(aReturn, "Enable")
 AADD(aReturn, "Disable")
ENDIF
RETURN aReturn
/****************************************************************
* Return pointer by Code of Status Array
****************************************************************/
FUNCTION p999_StatusByCod(cCodice)
LOCAL aReturn := p999_aStatus("C"), cCode := IIF(VALTYPE(cCodice)=="C", UPPER(ALLTRIM(cCodice)), "")
LOCAL nPoint := ASCAN(aReturn, cCode)
nPoint := IIF(nPoint>0, nPoint, 1)
RETURN nPoint
/****************************************************************
* Return code by Pointer of Status Array
****************************************************************/
FUNCTION p999_StatusByNum(nPointer)
LOCAL aReturn := p999_aStatus("C"), nPoint := IIF(VALTYPE(nPointer)=="N", nPointer, 1)
LOCAL cReturn := ""
nPoint := IIF(nPoint<=LEN(aReturn), nPoint, 1)
cReturn := aReturn[nPoint]
RETURN cReturn
/****************************************************************
* Return description of Status Array by [pointer | code]
****************************************************************/
FUNCTION p999_StatusByDes(Arg1)
LOCAL nPoint := IIF(VALTYPE(Arg1)=="N", Arg1, 0)
LOCAL cCode := IIF(VALTYPE(Arg1)=="C", UPPER(ALLTRIM(Arg1)), "")
LOCAL aDesc := p999_aStatus("D"), aCode := p999_aStatus("C")
LOCAL cReturn := ""
IF LEN(cCode)>0
 nPoint := ASCAN(aCode, cCode)
ENDIF
IF nPoint>0 .AND. nPoint<=LEN(aDesc)
 cReturn := aDesc[nPoint]
ENDIF
RETURN cReturn

/****************************************************************
* Return table structure
****************************************************************/
FUNCTION p999_aStru(cTableName)
LOCAL cTable := IIF(VALTYPE(cTableName)=="C", LOWER(ALLTRIM(cTableName)), "")
LOCAL aStru := {}
* progressive
IF cTable == "progress"
 AADD( aStru, { "adminproc", "C", 020, 000 }) // Upd.procedure
 AADD( aStru, { "adminuser", "C", 016, 000 }) // Upd.user
 AADD( aStru, { "admintstp", "C", 017, 000 }) // Upd.timer aaaammgghhmmssnnn es. 201003121425221
 AADD( aStru, { "prgcodice", "C", 008, 000 }) // codice
 AADD( aStru, { "prgdescri", "C", 050, 000 }) // descrizione
 AADD( aStru, { "prgnumero", "N", 008, 000 }) // ultimo valore
ENDIF
* category
IF cTable == "category"
 AADD( aStru, { "adminproc", "C", 020, 000 }) // Upd.procedure
 AADD( aStru, { "adminuser", "C", 016, 000 }) // Upd.user
 AADD( aStru, { "admintstp", "C", 017, 000 }) // Upd.timer aaaammgghhmmssnnn es. 201003121425221
 AADD( aStru, { "catidcate", "C", 006, 000 }) // code
 AADD( aStru, { "catstatus", "C", 001, 000 }) // status
 AADD( aStru, { "catdescri", "C", 050, 000 }) // description
ENDIF
* language
IF cTable == "language"
 AADD( aStru, { "adminproc", "C", 020, 000 }) // Upd.procedure
 AADD( aStru, { "adminuser", "C", 016, 000 }) // Upd.user
 AADD( aStru, { "admintstp", "C", 017, 000 }) // Upd.timer aaaammgghhmmssnnn es. 201003121425221
 AADD( aStru, { "lanidlang", "C", 006, 000 }) // code
 AADD( aStru, { "lanstatus", "C", 001, 000 }) // status
 AADD( aStru, { "landescri", "C", 050, 000 }) // description
ENDIF
* typology
IF cTable == "typology"
 AADD( aStru, { "adminproc", "C", 020, 000 }) // Upd.procedure
 AADD( aStru, { "adminuser", "C", 016, 000 }) // Upd.user
 AADD( aStru, { "admintstp", "C", 017, 000 }) // Upd.timer aaaammgghhmmssnnn es. 201003121425221
 AADD( aStru, { "typidtypo", "C", 006, 000 }) // code
 AADD( aStru, { "typstatus", "C", 001, 000 }) // status
 AADD( aStru, { "typdescri", "C", 050, 000 }) // description
ENDIF
* maillist
IF cTable == "maillist"
 AADD( aStru, { "adminproc", "C", 020, 000 }) // Upd.procedure
 AADD( aStru, { "adminuser", "C", 016, 000 }) // Upd.user
 AADD( aStru, { "admintstp", "C", 017, 000 }) // Upd.timer aaaammgghhmmssnnn es. 201003121425221
 AADD( aStru, { "mllidmcod", "C", 006, 000 }) // code
 AADD( aStru, { "mllstatus", "C", 001, 000 }) // status
 AADD( aStru, { "mlldescri", "C", 050, 000 }) // description
ENDIF
* contacts
IF cTable == "contacts"
 AADD( aStru, { "adminproc", "C", 020, 000 }) // Upd.procedure
 AADD( aStru, { "adminuser", "C", 016, 000 }) // Upd.user
 AADD( aStru, { "admintstp", "C", 017, 000 }) // Upd.timer aaaammgghhmmssnnn es. 201003121425221
 AADD( aStru, { "conidcont", "C", 008, 000 }) // contact id code
 AADD( aStru, { "constatus", "C", 001, 000 }) // status
 AADD( aStru, { "confiname", "C", 050, 000 }) // first name
 AADD( aStru, { "conlaname", "C", 050, 000 }) // last name
 AADD( aStru, { "connkname", "C", 050, 000 }) // nick name
 AADD( aStru, { "concatego", "C", 006, 000 }) // category
 AADD( aStru, { "conlangua", "C", 006, 000 }) // language
 AADD( aStru, { "conidgrou", "C", 008, 000 }) // reserved to future id group
ENDIF
* contacts postal address
IF cTable == "postaddr"
 AADD( aStru, { "adminproc", "C", 020, 000 }) // Upd.procedure
 AADD( aStru, { "adminuser", "C", 016, 000 }) // Upd.user
 AADD( aStru, { "admintstp", "C", 017, 000 }) // Upd.timer aaaammgghhmmssnnn es. 201003121425221
 AADD( aStru, { "posidcont", "C", 008, 000 }) // contact id code
 AADD( aStru, { "posstatus", "C", 001, 000 }) // status
 AADD( aStru, { "postypolo", "C", 006, 000 }) // typology
 AADD( aStru, { "posdescri", "C", 030, 000 }) // short description
 AADD( aStru, { "posaddrl1", "C", 050, 000 }) // address line 1
 AADD( aStru, { "posaddrl2", "C", 050, 000 }) // address line 2
 AADD( aStru, { "posaddrl3", "C", 050, 000 }) // address line 3
 AADD( aStru, { "posaddrl4", "C", 050, 000 }) // address line 4
 AADD( aStru, { "posaddrl5", "C", 050, 000 }) // address line 5
ENDIF
* contacts email address
IF cTable == "mailaddr"
 AADD( aStru, { "adminproc", "C", 020, 000 }) // Upd.procedure
 AADD( aStru, { "adminuser", "C", 016, 000 }) // Upd.user
 AADD( aStru, { "admintstp", "C", 017, 000 }) // Upd.timer aaaammgghhmmssnnn es. 201003121425221
 AADD( aStru, { "emlidcont", "C", 008, 000 }) // contact id code
 AADD( aStru, { "emlstatus", "C", 001, 000 }) // status
 AADD( aStru, { "emltypolo", "C", 006, 000 }) // typology
 AADD( aStru, { "emldescri", "C", 030, 000 }) // short description
 AADD( aStru, { "emladdres", "C", 250, 000 }) // address
ENDIF
* contacts telephone address
IF cTable == "teleaddr"
 AADD( aStru, { "adminproc", "C", 020, 000 }) // Upd.procedure
 AADD( aStru, { "adminuser", "C", 016, 000 }) // Upd.user
 AADD( aStru, { "admintstp", "C", 017, 000 }) // Upd.timer aaaammgghhmmssnnn es. 201003121425221
 AADD( aStru, { "telidcont", "C", 008, 000 }) // contact id code
 AADD( aStru, { "telstatus", "C", 001, 000 }) // status
 AADD( aStru, { "teltypolo", "C", 006, 000 }) // typology
 AADD( aStru, { "teldescri", "C", 030, 000 }) // short description
 AADD( aStru, { "teladdres", "C", 030, 000 }) // address
ENDIF
* contacts mailing list association
IF cTable == "mailings"
 AADD( aStru, { "adminproc", "C", 020, 000 }) // Upd.procedure
 AADD( aStru, { "adminuser", "C", 016, 000 }) // Upd.user
 AADD( aStru, { "admintstp", "C", 017, 000 }) // Upd.timer aaaammgghhmmssnnn es. 201003121425221
 AADD( aStru, { "mlsidcont", "C", 008, 000 }) // contact id code
 AADD( aStru, { "mlsstatus", "C", 001, 000 }) // status
 AADD( aStru, { "mlsaddres", "C", 250, 000 }) // address
 AADD( aStru, { "mlsidmcod", "C", 006, 000 }) // code
ENDIF
RETURN aStru